/*
 * CustLocalImpl.java
 *
 * Java code for the implementation of the local customizer
 * takes the call from the client and redirects it to the remote Customizer
 * giving it necessary info about the client
 */


package MovieService;

public class CustLocalImpl extends CoreBroker.BasicCustomizer implements MovieInterface {
    
    //    public void setCustomizerSessionID(String ids)
    // {
    //super.setCustomizerSessionID(ids);
    // }

    public void getMovies(java.lang.String title, java.lang.String actor, java.lang.String director, int flag, MovieService.holders.ArrayOfIntHolder movieID, MovieService.holders.ArrayOfStringHolder movieList) throws java.rmi.RemoteException {

	String rc = getRC();
	try{
	    CustRemoteService.CustRemoteInterface service = new CustRemoteService.CustRemoteSOAPBindingStub(new java.net.URL(rc),null);   
	    System.out.println("LC calling getMovies with RC = "+rc);
	    service.getMovies(title,actor,director,flag,movieID,movieList);
	    return;
	    
	}
	catch (Exception ex) {
	    ex.printStackTrace();
	    return;
	}   
    }
    
    public void getMovieInfo(int movieID, java.util.Calendar fromDate, java.util.Calendar fromTime, java.util.Calendar toDate, java.util.Calendar toTime, MovieService.holders.ArrayOfIntHolder scheduleIDList, MovieService.holders.ArrayOfStringHolder cityList, MovieService.holders.ArrayOfStringHolder addressList, MovieService.holders.ArrayOfIntHolder roomList, MovieService.holders.ArrayOfDateTimeHolder dateList, MovieService.holders.ArrayOfDateTimeHolder timeList) throws java.rmi.RemoteException {
	String rc=getRC();
	try 
	    {
		CustRemoteService.CustRemoteInterface service = new CustRemoteService.CustRemoteSOAPBindingStub(new java.net.URL(rc),null);      
		service.getMovieInfo(movieID,fromDate,fromTime,toDate,toTime,scheduleIDList,cityList,addressList,roomList,dateList,timeList);
	    }
	catch (Exception ex) {
	    ex.printStackTrace();
	}
    }
    
    public String getMovieTrailer(int movieID) throws java.rmi.RemoteException {
	System.out.println("******************** CustLocal getTrailer ************");
	System.out.println("Call received from client .");
	String rc=getRC();
	try 
	    {
		System.out.println("getting RC instance.");
		CustRemoteService.CustRemoteInterface service = new CustRemoteService.CustRemoteSOAPBindingStub(new java.net.URL(rc),null);
		System.out.println("LC calling getMovieTrailer....");
		String trailerURL = service.getMovieTrailer(movieID,"00:00:20","80x80","mpg");
		service = null;
		if (trailerURL!=null) System.out.println(" CustLocal recieve file"+ trailerURL);
		else System.out.println("Trailer is null");
		//numbytes.value=trailer.value.length;

		System.out.println("LC has served the call.");
		System.out.println("******************** end CustLocal getTrailer ************");
		return trailerURL;
	    }
	catch (Exception ex) {
	    ex.printStackTrace();
	}	
	return null;
    }
    
    public String getAudioCriticisms(int movieID) throws java.rmi.RemoteException {
	try
	    {
		String rc = getRC();
		CustRemoteService.CustRemoteInterface service = new CustRemoteService.CustRemoteSOAPBindingStub(new java.net.URL(rc),null); 
		return service.getAudioCriticisms(movieID);
	    }
	catch(Exception ex) {
	    ex.printStackTrace();
	}
	return null;
    }
    
public String getTextCriticisms(int movieID) throws java.rmi.RemoteException {
    try
	{
	    String rc = getRC();
	    CustRemoteService.CustRemoteInterface service = new CustRemoteService.CustRemoteSOAPBindingStub(new java.net.URL(rc),null); 
	    return service.getTextCriticisms(movieID);
	}
    catch(Exception ex) {
	ex.printStackTrace();
    }
    return null;
}

    public int bookTicket(java.lang.String firstName, java.lang.String lastName, int scheduleID, int numSeats) throws java.rmi.RemoteException {
	String rc = getRC();
	try{
	    CustRemoteService.CustRemoteInterface service = new CustRemoteService.CustRemoteSOAPBindingStub(new java.net.URL(rc),null);   
	    int ret=0;
	    System.out.println("LC calling getMovies.....");
	    ret=service.bookTicket(firstName,lastName,scheduleID,numSeats);
	    return ret;
	}
	catch (Exception ex) {
	    ex.printStackTrace();
	    return 0;
	}    
    }
    public static void main (String arg[]) 
    {
	if (arg.length>=1) 
	    {
		System.out.println("Ids = "+arg[0]);
		CustLocalImpl cust = new CustLocalImpl();
		cust.setCustomizerSessionID(arg[0]);
	    }
    }

    
}
