/**
 * HotelSOAPBindingImpl.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis WSDL2Java emitter.
 */

package HotelService;

import HotelService.database.*;

import java.math.*;
import java.util.*;

public class HotelImpl implements HotelService.HotelInterface{
    public java.math.BigInteger createAccount(HotelService.Client client) throws java.rmi.RemoteException, HotelService.HotelException {

	try{
	    // get an HotelDB to be able to do queries
	    HotelDB hotelDB = HotelDBFactory.getHotelDB();
	    String firstName = client.getFirstName();
	    String surName = client.getSurName();
	    String password = client.getPassword();
	    
	    	    
	    int rc = hotelDB.createAccount(firstName, surName, password);
	    hotelDB.close();
 	    return new BigInteger(""+rc);

	    
	}catch(DatabaseException ex){
            ex.printStackTrace();
	    throw new HotelException(ex.getErrorCode(),ex.getErrorMessage());
	}
	
    }

    public HotelService.Hotel[] listHotels(java.lang.String city) throws java.rmi.RemoteException, HotelService.HotelException {

	try{
	    HotelDB hotelDB = HotelDBFactory.getHotelDB();
	    
	    Vector list = hotelDB.listHotels(city);
	    
	    hotelDB.close();

	    //HotelEnumeration hotelEnumeration = new HotelEnumeration();

	    Hotel [] hotels = new Hotel[list.size()];
	    
	    for(int i=0;i<list.size();i++){
		hotels[i] = (Hotel) list.elementAt(i);
	    }

	    //hotelEnumeration.setHotels(hotels);
	    return hotels;


	}catch(DatabaseException ex){
	    throw new HotelException(ex.getErrorCode(),ex.getErrorMessage());
	
	}


    }

    public HotelService.Reservation[] listReservations(java.math.BigInteger clientId, java.lang.String password) throws java.rmi.RemoteException, HotelService.HotelException {

	try{
	    System.out.println("listReservations......1");
	    HotelDB hotelDB = HotelDBFactory.getHotelDB();
	    System.out.println("listReservations......2");
	
	    if(! hotelDB.checkPassword(clientId.intValue(),password)){
		System.out.println("listReservations......3");
		throw new HotelException(new BigInteger("1"),"Authentication Failed");
	    }
	    System.out.println("listReservations......4");
	    
	    Vector list = hotelDB.listReservation(clientId.intValue(),password);
	    System.out.println("listReservations......5");
	    hotelDB.close();
	    System.out.println("listReservations......6");

	    //ReservationEnumeration reservationEnumeration = new ReservationEnumeration();
	    System.out.println("listReservations......7");
	    
	    Reservation [] reservations = new Reservation[list.size()];
	    System.out.println("listReservations......8: size: "+ list.size());

	    for(int i=0;i<list.size();i++){
		System.out.println("listReservations......9");
		reservations[i] = (Reservation) list.elementAt(i);
	    }
	    System.out.println("listReservations......10");
	    
	    //reservationEnumeration.setReservations(reservations);
	    System.out.println("listReservations......11");
	    /*if(reservationEnumeration == null){
		System.out.println("reservationEnumeration NULL");
	    }
	    else{
		System.out.println("reservationEnumeration NOT NULL");
	    }*/

	    return reservations; //Enumeration;
	    
	    
	}catch(DatabaseException ex){
	    System.out.println("listReservations......13");
	    throw new HotelException(ex.getErrorCode(),ex.getErrorMessage());
	}


    }


    public java.math.BigInteger createReservation(java.math.BigInteger clientId, java.math.BigInteger hotelId, java.lang.String hotelName, java.math.BigInteger roomSize, java.lang.String password, java.util.Calendar startDate, java.math.BigInteger nights) throws java.rmi.RemoteException, HotelService.HotelException {
	
	
	try{
	    HotelDB hotelDB = HotelDBFactory.getHotelDB();
	    System.out.println("createReservations......1");
	    if(! hotelDB.checkPassword(clientId.intValue(),password)){
		throw new HotelException(new BigInteger("1"),"Authentication Failed");
	    } System.out.println("createReservations......2");
	    if(! hotelDB.checkAvailaibleRooms(roomSize.intValue(), hotelId.intValue(),startDate.getTime(),nights.intValue())){
		throw new HotelException(new BigInteger("1"),"No Room Left for this date");
	    }
	     System.out.println("createReservations......3");
	    int rc = hotelDB.createReservation(clientId.intValue(),hotelId.intValue(), hotelName,  roomSize.intValue(),startDate.getTime(),nights.intValue());
 System.out.println("createReservations......4");
	    hotelDB.close();
 System.out.println("createReservations......5");
	    return new BigInteger(""+rc);
	    
	    

	}catch(DatabaseException ex){
	    throw new HotelException(ex.getErrorCode(),ex.getErrorMessage());
	}


    }
    

    public void cancelReservation(java.math.BigInteger clientId, java.lang.String password, java.math.BigInteger reservationId) throws java.rmi.RemoteException, HotelService.HotelException {
	
	try{
	    HotelDB hotelDB = HotelDBFactory.getHotelDB();
	    
	    if(! hotelDB.checkPassword(clientId.intValue(),password)){
		throw new HotelException(new BigInteger("1"),"Authentication Failed");
	    }
	    
	    hotelDB.cancelReservation(reservationId.intValue());

	    hotelDB.close();
	    
	    
	    

	}catch(DatabaseException ex){
	    throw new HotelException(ex.getErrorCode(),ex.getErrorMessage());
	}
	

    }

    public boolean checkPassword(java.math.BigInteger clientId, java.lang.String password) throws java.rmi.RemoteException, HotelService.HotelException {
	
	try{
	    System.out.println("test...1");
	    HotelDB hotelDB = HotelDBFactory.getHotelDB();
	    System.out.println("test...2");
	    boolean ret = hotelDB.checkPassword(clientId.intValue(),password);
	    System.out.println("test...3");
	    hotelDB.close();
	    System.out.println("test...4");
	    return ret;

	}catch(DatabaseException ex){
	    throw new HotelException(ex.getErrorCode(),ex.getErrorMessage());
	}

    }
}
