package HotelService.database;

import HotelService.*;

import java.math.*;
import java.util.*;


// interface to implement

public interface HotelDB{

    // connect methods
    public void connect() throws DatabaseException;
    public void close() throws DatabaseException;

    // main methods
    public int createAccount(String firstName,
		      String lastName,
		      String password)  throws DatabaseException;

    public int createReservation(int clientId, 
				 int hotelId,
				 String hotelName,
				 int roomSize,
				 Date startDate,
				 int nights
				 )  throws DatabaseException;
    
    public Vector listHotels(String city)  throws DatabaseException;

    public Vector listReservation(int clientId, String password)  throws DatabaseException;
    
    // make sure u check the password before calling this method
    public void cancelReservation(int reservationId)  throws DatabaseException;

    // helper methods

    public boolean checkPassword(int id, String password)  throws DatabaseException;

    public boolean checkAvailaibleRooms(int roomSize,
					int hotelId,
					Date startDate,
					int nights
					)  throws DatabaseException;
}
