/**
 * MovieImpl.java
 *
 * Java code for the implementation of the Movie Web Service
 */

package MovieService;

import java.util.*;
import java.io.*;
import java.sql.*;

public class MovieImpl implements MovieService.MovieInterface{

    private Connection        conn=null;
    private ResultSet         rs=null;
    private Statement         stmt=null;
    private PreparedStatement pstmt = null;

    public MovieImpl() {
	System.out.println("Movie Service Constructor called!!");
	String databasePath="payia.inria.fr";
	String user="root";
	try {
	    Class.forName ("com.mysql.jdbc.Driver").newInstance ();
	    System.out.println("Driver Okay.");
	    ClassLoader cl = Thread.currentThread().getContextClassLoader();
	    java.net.URL resource = cl.getResource("database.conf");
	    if (resource !=null)
		{
		    FileReader fr = new FileReader(resource.getPath()); 
		    BufferedReader br = new BufferedReader(fr); 
		    if (br.ready())
			{ 
			 String readPath = br.readLine();
			 if(readPath!=null && !readPath.equals("")) databasePath=readPath;
			}
		    if (br.ready()) 
			{
			    String readUser = br.readLine();
			    if (readUser!=null && !readUser.equals("")) user=readUser;
			}
		}
	    conn = DriverManager.getConnection("jdbc:mysql://"+databasePath+"/moviedb?user="+user);	                     
	    System.out.println ("connection to "+databasePath+"/moviedb establemacished");
	    stmt = conn.createStatement();
	}catch(Exception e) {
	    System.out.println("Error in connection to "+databasePath+"/moviedb");
	    e.printStackTrace();
	}
    } 
    
    public void finalize() {
	System.out.println("Service Destructor called!!");
	if (conn != null) {
	    try {
		conn.close ();
		System.out.println ("Database connection terminated");
	    }
	    catch (Exception e) { /* ignore close errors */ }
	}
    }
    
    
    public void getMovies(java.lang.String title, java.lang.String actor, java.lang.String director, int flag, MovieService.holders.ArrayOfIntHolder movieID, MovieService.holders.ArrayOfStringHolder movieList) throws java.rmi.RemoteException {
	//ArrayOfString movieArray=new ArrayOfString();
	String movieArray[] = null;
	String names[]=null;
	//ArrayOfInt movieIDs=new ArrayOfInt();
	int movieIDs[]=null;
	int ids[]=null;
	
	try {
	    String sql="SELECT movieid, title, actor, director FROM movie";
	    String append="";
	    if(title!=null && !title.equals("")) {
		if(flag==1) 
		    append=" WHERE title LIKE '%"+title+"%'";
		else 
		    append=" WHERE title LIKE '%"+title+"%'";
	    }
	    if(actor!=null  && !actor.equals("")) {
		if(append.equals("")) 
		    append=" WHERE actor LIKE '%"+actor+"%'";
		else 
		    append= append + " AND actor LIKE '%"+actor+"%'";
	    }
	    if(director!=null && !director.equals("")) {
		if(append.equals("")) 
		    append=" WHERE director LIKE '%"+director+"%'";
		else 
		    append=append+" AND director LIKE '%"+director+"%'";
	    }
	    //if(append==null) append=" 1";
	    sql=sql.concat(append)+";";
             
	    System.out.println("SQL Request : "+sql);
	    rs = stmt.executeQuery(sql);
	    if (rs.first()) {
		int i=0;
		rs.last();
		i = rs.getRow();
                ids=new int[i];
		names=new String [i];
		}
	    else return;
	    rs.beforeFirst();
	    int i=0;
	    while(rs.next()){
		ids[i]=rs.getInt("movieid");
		String titleTmp = rs.getString("title").trim();
		while (titleTmp.length()<21) titleTmp = titleTmp+" ";
		String actorTmp = rs.getString("actor").trim();
		while (actorTmp.length()<19) actorTmp = actorTmp+" ";
		names[i]=titleTmp+actorTmp+rs.getString("director").trim();
		System.out.println(names[i]);
		i++;
	    }
	    movieIDs = ids;
	    movieArray = names;
	    System.out.println("Call served by getMovies.");
	    movieID.value=movieIDs;
	    movieList.value=movieArray;
	} catch(Exception ex) {
	    ex.printStackTrace();
	}	
    }
    
    
    public void getMovieInfo(int movieID, java.util.Calendar fromDate, java.util.Calendar fromTime, java.util.Calendar toDate, java.util.Calendar toTime, MovieService.holders.ArrayOfIntHolder scheduleIDList, MovieService.holders.ArrayOfStringHolder cityList, MovieService.holders.ArrayOfStringHolder addressList, MovieService.holders.ArrayOfIntHolder roomList, MovieService.holders.ArrayOfDateTimeHolder dateList, MovieService.holders.ArrayOfDateTimeHolder timeList) throws java.rmi.RemoteException {
	int scheduleIDArray []= null;
	int scheduleIDs[]=null;
	String cityListArray[]=null;
	String cities[]=null;
	String addressListArray[]=null;
	String addresses[]=null;
	int roomListArray[]=null;
	int roomIDs[]=null;
	Calendar dateListArray[]=null;
	Calendar dates[]=null;
	Calendar timeListArray[]=null;
	Calendar times[]=null;
	
	String sql=null;
	
	if(movieID!=-1 && fromDate!=null && fromTime!=null && toDate!=null && toTime!=null) {
	    String day1=""+fromDate.get(Calendar.YEAR)+"-"+(fromDate.get(Calendar.MONTH)+1)+"-"+fromDate.get(Calendar.DAY_OF_MONTH);
	    String day2=""+toDate.get(Calendar.YEAR)+"-"+(toDate.get(Calendar.MONTH)+1)+"-"+toDate.get(Calendar.DAY_OF_MONTH);
	    String time1=""+fromTime.get(Calendar.HOUR_OF_DAY)+":"+fromTime.get(Calendar.MINUTE)+":"+fromTime.get(Calendar.SECOND);
	    String time2=""+toTime.get(Calendar.HOUR_OF_DAY)+":"+toTime.get(Calendar.MINUTE)+":"+toTime.get(Calendar.SECOND);
	    sql="SELECT scheduleid,city,address,roomid,date,time FROM schedule,cinema WHERE schedule.movieid= '"+movieID+"' AND (schedule.date BETWEEN '"+day1+"' AND '"+day2+"') AND (schedule.time BETWEEN '"+time1+"' AND '"+time2+"') AND cinema.cinemaid=schedule.cinemaid;";  
	}
	
	else if(movieID!=-1 && fromDate!=null && toDate!=null) {
	    String day1=""+fromDate.get(Calendar.YEAR)+"-"+fromDate.get(Calendar.MONTH)+"-"+fromDate.get(Calendar.DAY_OF_MONTH);
	    String day2=""+toDate.get(Calendar.YEAR)+"-"+toDate.get(Calendar.MONTH)+"-"+toDate.get(Calendar.DAY_OF_MONTH);
	    sql="SELECT scheduleid,city,address,roomid,date,time FROM schedule,cinema WHERE schedule.movieid='"+movieID+"' AND cinema.cinemaid=schedule.cinemaid AND (schedule.date BETWEEN '"+day1+"' AND '"+day2+"');";  
	}
	
	else if(movieID!=-1 && fromDate!=null){
	    // String day=fromDate.get(1)+fromDate.get(2)+fromDate.get(5);
	    String day=""+fromDate.get(Calendar.YEAR)+"-"+fromDate.get(Calendar.MONTH)+"-"+fromDate.get(Calendar.DAY_OF_MONTH);
	    sql="SELECT scheduleid,city,address,roomid,date,time FROM schedule,cinema WHERE schedule.movieid='"+movieID+"' AND schedule.date='"+day+"' AND cinema.cinemaid=schedule.cinemaid;"; 
	}
	
	else {
	    sql="SELECT scheduleid,city,address,roomid,date,time FROM schedule,cinema WHERE schedule.movieid='"+movieID+"' AND schedule.cinemaid=cinema.cinemaid;";  
	}
	
	try {
	    Calendar calForDate=Calendar.getInstance();
	    Calendar calForTime=Calendar.getInstance();
	    System.out.println("SQL Request="+sql);
	    rs = stmt.executeQuery(sql);
	    if (rs.first()) {
		int i=0;
		rs.last();
		i = rs.getRow()+1;
		scheduleIDs=new int[i];
		cities=new String[i];
		addresses=new String[i];
		roomIDs=new int[i];
		dates=new Calendar[i];
		times=new Calendar[i];

	    }
	    else {

		//empty result set
	    }
	    rs.beforeFirst();
	    int i=0;
	    while(rs.next()){
		calForDate.clear();
		calForTime.clear();
		calForDate.setTime(rs.getDate("date"));
		calForTime.setTime(rs.getTime("time"));
		dates[i] = Calendar.getInstance();
                dates[i].set(calForDate.get(Calendar.YEAR),calForDate.get(Calendar.MONTH),calForDate.get(Calendar.DAY_OF_MONTH));
                times[i]= Calendar.getInstance();
                times[i].set(Calendar.HOUR_OF_DAY,calForTime.get(Calendar.HOUR_OF_DAY));
		times[i].set(Calendar.MINUTE,calForTime.get(Calendar.MINUTE));
		times[i].set(Calendar.SECOND,calForTime.get(Calendar.SECOND));
		scheduleIDs[i]=rs.getInt("scheduleid");
		cities[i]=rs.getString("city");
		addresses[i]=rs.getString("address");
		roomIDs[i]=rs.getInt("roomid");
		i++;
	    }
	    scheduleIDArray=scheduleIDs;
	    cityListArray=cities;
	    addressListArray=addresses;
	    roomListArray=roomIDs;
	    dateListArray=dates;
	    timeListArray=times;

	} catch(Exception ex) {
	    ex.printStackTrace();
	}	
	scheduleIDList.value=scheduleIDArray;
	cityList.value=cityListArray;
	addressList.value=addressListArray;
	roomList.value=roomListArray;
	dateList.value=dateListArray;
	timeList.value=timeListArray;
        
	System.out.println("Call served by getMovieInfo.");
	
    }
    
    
    public String getMovieTrailer(int movieID) throws java.rmi.RemoteException {
	try{
	    String sql="SELECT trailer FROM movie WHERE movieid="+movieID+";"; 
	    System.out.println("SQL Request="+sql);
	    rs = stmt.executeQuery(sql);
	    rs.next();
	    String trailerURI = rs.getString("trailer");
	    String trailerName = trailerURI.substring(trailerURI.lastIndexOf("/")+1);
            
            CoreBroker.IFUtils ifUtils = new CoreBroker.IFUtils();
            String[] localIPAddrs = ifUtils.getLocalHostAddresses();
            
	    String trailerURL = "http://"+localIPAddrs[0]+":8080/trailers/"+trailerName;
 	    System.out.println("Call served by getMovieTrailer. trailer returned is :"+trailerURL);
	    return trailerURL;
	}catch(Exception ex) {
	    ex.printStackTrace();
	}
	return null;
    }
    
  

    public String getAudioCriticisms(int movieID) throws java.rmi.RemoteException {
	try
	    {
		String sql="SELECT criticaudio FROM movie WHERE movieid="+movieID+";"; 
		System.out.println("SQL Request="+sql);
		rs = stmt.executeQuery(sql);
		rs.next();
		String audioURI = rs.getString("criticaudio");
		String audioName = audioURI.substring(audioURI.lastIndexOf("/")+1);
		
		CoreBroker.IFUtils ifUtils = new CoreBroker.IFUtils();
		String[] localIPAddrs = ifUtils.getLocalHostAddresses();
	
		String audioURL = "http://"+localIPAddrs[0]+":8080/audio/"+audioName;
		System.out.println("Call served by getAudioCriticisms. audio returned is :"+audioURL);
		return audioURL;
	    }
	catch(Exception ex) {
	    ex.printStackTrace();
	}
	return null;
    }
    
public String getTextCriticisms(int movieID) throws java.rmi.RemoteException {
    try
	{
	    String sql="SELECT critictext FROM movie WHERE movieid="+movieID+";"; 
	    System.out.println("SQL Request="+sql);
	    rs = stmt.executeQuery(sql);
	    rs.next();
	    return rs.getString("critictext");
	}
    catch(Exception ex) {
	    ex.printStackTrace();
    }
    return null;
}

  
    private int getAvailability(int scheduleID) {
	int capacity=0;
	int booked=0;
	try{
	    String sql="SELECT SUM(numseats) FROM booking WHERE booking.scheduleid="+scheduleID;
	    rs = stmt.executeQuery(sql);
	    if(rs.next()) booked=rs.getInt(1);
	    else booked=0;
	    sql="SELECT capacity FROM schedule,room WHERE schedule.scheduleid="+scheduleID+" AND schedule.roomid=room.roomid;";
	    rs = stmt.executeQuery(sql);
	    rs.next();
	    capacity=rs.getInt(1);
	    return capacity-booked;
	} catch(Exception ex) {
	    ex.printStackTrace();
	    return -1;              //indicates error
	}
    }
 
	
	
    public int bookTicket(java.lang.String firstName, java.lang.String lastName, int scheduleID, int numSeats) throws java.rmi.RemoteException {
	int available=0;
	available=getAvailability(scheduleID);
	if(available==0) return 111;       //magic number....indicates zero availability
	if(available<numSeats) 
	    return -available;
	int key=1010;
	try {
	    String sql="SELECT MAX(ticketkey) FROM booking";
	    rs = stmt.executeQuery(sql);
	    if(rs.next()) key=rs.getInt(1)+1;
	    sql = "INSERT INTO booking(firstname,lastname,scheduleid,numseats,ticketkey) VALUES (?,?,?,?,?);";
	    System.out.println("SQL Request="+sql);
	    pstmt = conn.prepareStatement(sql);
	    pstmt.setString(1,firstName);
	    pstmt.setString(2,lastName);
	    pstmt.setInt(3,scheduleID);
	    pstmt.setInt(4,numSeats);
	    pstmt.setInt(5,key);
	    
	    // execute the query
	    pstmt.executeUpdate();
	    return key;
	} catch(Exception ex) {
	    ex.printStackTrace();
	    return 0;              //indicates error
	}
    }
}
