/**
 * OzoneMessenger.java
 *
 * Java code for the implementation of the Movie Web Service
 */

package OzoneMessengerService;

import java.util.*;
import java.net.*;


public class OzoneMessengerImpl implements OzoneMessengerService.OzoneMessengerInterface
{
    private String myNickname="noNickname";
    private String myServiceURL="noServiceURL";
    private String myEp="http://localhost:8080/services/OzoneMessenger";

    private String wsamiMessenger ="http://localhost:8080/wsami/OzoneMessengerAbstract.wsami";
    private String LocalNDAddress ="http://localhost:8080/services/ND";
    private Vector nicknames = new Vector();   // local managed
    private Vector serviceURLs = new Vector(); // local managed
    private Vector eps = new Vector();         // gived by ND

    // graphical interface 
    OzoneMessengerFrame window = null;
    
    // end graphical interface 
    Users users;
    User user;

    public OzoneMessengerImpl() {
	//window = new OzoneMessengerFrame(this);
	//window.show();
    }

    public boolean showWindow(String MyServiceURL)
    {
	eps.removeAllElements();
	nicknames.removeAllElements();

	if (MyServiceURL.equals("noServiceURL"))
	    {
		System.out.println(" is not autorized");
		return false;
	    } 

	myServiceURL = MyServiceURL;

	window = new OzoneMessengerFrame(this);
	// find friends on the user.xml file
	ClassLoader cl = Thread.currentThread().getContextClassLoader();
	java.net.URL resource = cl.getResource("user.xml");
	if (resource == null)
	    {
		// create the user.xml file
		resource = cl.getResource(".");
		if (resource != null)
		    {
			System.out.println("resource.getPath()="+resource.getPath()); 
			try
			    {
				java.io.File userXMLFile = new java.io.File(resource.getPath()+"/user.xml");
				userXMLFile.createNewFile(); 
				java.io.FileWriter usersFile = new java.io.FileWriter(userXMLFile);
				usersFile.write("<messenger>");
				usersFile.write("</messenger>");
				usersFile.close();
				users = new Users(userXMLFile.getPath());
			    }
			catch(Exception ex)
			    {
				System.out.println("Error in create user.xml file");
			    } 
		    }
		else System.exit(0);
	    }
	else users = new Users(resource.getPath()); 
	user = users.getUser(myServiceURL);
		if (user ==  null) 
		    {
			// add here the frame which allows to add new user and his friends
			String message ="This user doesn't exist on Ozone Messenger, Do you want to add him?";
			if (!window.autorization(message)) return false;
			window.showNewUserDialog(myServiceURL);
			if (window.getAddNewUserStat())
			    {
				System.out.println("Yes, I want");
				user = new User();
				user.setServiceURL(window. getNewUserServiceURL());
				user.setName(window.getNewUserName());
				user.setNickname(window.getNewUserNickname());
				if (!users.addUser(user)) return false;
				//users.saveChange();
			    }
			else return false;
		    }
		
		//users.saveChange();
		myNickname = user.getNickname();
		serviceURLs = user.getFriendServiceURLs();	
		nicknames = user.getFriendNicknames();
		
		CoreBroker.IFUtils ifUtils = new CoreBroker.IFUtils();
		String[] localIPAddrs = ifUtils.getLocalHostAddresses();
		myEp ="http://"+localIPAddrs[0]+":8080/services/OzoneMessenger";
		//Vector epsTmp = new Vector();
		System.out.println("Messenger level 1");
		getConnected(serviceURLs, eps);

		System.out.println("**************after getConnected********");

		System.out.println("serviceURLs.size()="+serviceURLs.size());
		System.out.println("eps.size()="+eps.size());
		for (int x=0;x<serviceURLs.size();x++)
		    {
			System.out.println("serviceURLs.elementAt("+x+")="+(String)serviceURLs.elementAt(x));
			System.out.println("eps.elementAt("+x+")="+(String)eps.elementAt(x));
		    }

		System.out.println("**************and*************");
		System.out.println("Messenger level 2");
		
		for (int i=0;i<eps.size();i++)
		    {
			try
			    {
				System.out.println("Messenger level 5");
				if (eps.elementAt(i) != null) 
				    {
					System.out.println("Messenger level 6");
					URL url = new URL((String)eps.elementAt(i));
					OzoneMessengerInterface service = new OzoneMessengerService.OzoneMessengerSOAPBindingStub(url,null);
					if (service.getServiceURL().equals((String)serviceURLs.elementAt(i)))
					    {
						System.out.println("*****************I Will tell my friend "+(String)serviceURLs.elementAt(i)+" that I'am here");
					service.newConnected(myServiceURL, myEp);
					    }
					else 
					    {
						System.out.println("**************My friend "+(String)serviceURLs.elementAt(i)+" isn't here");
						eps.set(i,null);
					    }
				    }
				System.out.println("Messenger level 7");
			    }
			catch (Exception ex)
			    {
				System.out.println("Error in newConnected message");
			    }
		    }
		// show graphical window
		System.out.println("Messenger level 8");
		window.setNickname(myNickname);
		window.showFriends();
		window.show();
		System.out.println("Messenger level 9");
		return true;
    }
    

    public String getNickname()
    {
	return myNickname;
    }

    public String getServiceURL()
    {
	return myServiceURL;
    }

    public void newConnected(String serviceURL, String ep)
    {
	System.out.println("**************new Connected serviceURL="+serviceURL+" and ep="+ep);
	System.out.println("serviceURLs[]="+serviceURLs);
	System.out.println("eps[]="+eps);
	if (serviceURLs.indexOf(serviceURL) !=-1) 
	    {
		eps.set(serviceURLs.indexOf(serviceURL),ep);
		System.out.println("After add the new connected eps[]="+eps);
		window.showFriends();
	    }
	else System.out.println("*****************this new connected isn't my friend, serviceURL="+serviceURL+" and ep="+ep);
    }
    
    public boolean receiveMessage(String serviceURL, String message, Calendar date)
    {
	int i =  serviceURLs.indexOf(serviceURL);
	if (i!=-1)
	window.showMessage((String)nicknames.elementAt(i), message, date);
	return true;
    }
    
    public boolean sendMessage(String message, Calendar date)
    {
        boolean correctSent = true;
	window.showMessage(myNickname, message, date);
	for (int i=0;i<eps.size();i++)
	    {
      		correctSent = (correctSent && sendMessage(message, date,(String)eps.elementAt(i)));
	    }
	return correctSent;
    }

    public boolean send(String message, Calendar date , String nickname)
    {
	int index = nicknames.indexOf(nickname); 
	if (index !=-1)
	    { 
		if (eps.elementAt(index)!=null)
		    {
			boolean stat = sendMessage(message, date , (String)eps.elementAt(index));
			window.showMessage(myNickname, message, date);
			return stat;
		    }
		else System.out.println("User not Connected");
    
	    }
	else System.out.println("User not exist");
	return false;
    }

    private boolean sendMessage(String message, Calendar date , String ep)
    {
	try
	    {
		URL url = new URL(ep);
		OzoneMessengerInterface service=new OzoneMessengerService.OzoneMessengerSOAPBindingStub(url,null);
		return service.receiveMessage(myServiceURL, message, date);
	    }
	catch (Exception ex)
	    {
		System.out.println("Error in sendMessage");
		return false;
	    }
    }

    private void getConnected(Vector serviceURLs, Vector eps)
    {	
	eps.removeAllElements();
	NDService.GetServiceData[] services = null ;
	try
	    {
		NDService.NDPortType nd= new NDService.NDBindingStub(new URL(LocalNDAddress),null);

		for (int cpt=0; cpt<serviceURLs.size(); cpt++)
		    {
			System.out.println("**************I will ask ND(to give Ep of: "+(String)serviceURLs.elementAt(cpt));
			services = nd.getService_ByInstanceURL((String)serviceURLs.elementAt(cpt));
			System.out.println("**************ND is Called");
			if (services != null && services.length>0) 
			    {
				System.out.println("**************Ep returned by ND: "+services[0].getServiceEP());
				eps.add(services[0].getServiceEP());
			    }
			else 
			    {
				System.out.println("**************ND return Null of: "+(String)serviceURLs.elementAt(cpt));
				System.out.println("**************I will add null into eps");
				eps.add(null);
				System.out.println("**************null is add into eps");

			    }
		    }
	    }
	catch (Exception ex)
	    {
		ex.printStackTrace();
		System.out.println("************* Error in getMembers");
	    }
    }
    
    public boolean closeWindow()
    {
	System.out.println("window closed");
	window.hide();
	// tell deconnection to all my friends
	for (int i=0;i<eps.size();i++)
	    {
		if (eps.elementAt(i)!=null)
		try
		    {
			URL url = new URL((String)eps.elementAt(i));
			OzoneMessengerInterface service = new OzoneMessengerService.OzoneMessengerSOAPBindingStub(url,null);
			service.freindDeconnecting(myServiceURL, myEp);
		    }
		catch (Exception ex)
		    {
			System.out.println("Error in closeWindow");
		    }
	    }
	eps.removeAllElements();
	myNickname="noNickname";
	myServiceURL="noServiceURL";
	return true;
    }
    public void freindDeconnecting(String serviceURL, String Ep)
    {
	eps.set(serviceURLs.indexOf(serviceURL),null);
	window.showFriends();
    }

    public Iterator getConnectedNicknames()
    {
	Vector tmp = new Vector();
	for (int i=0;i<eps.size();i++)
	    if (eps.elementAt(i)!= null) tmp.addElement((String)nicknames.elementAt(i));
	return tmp.iterator();
    }

    public boolean accept(String fileName, String serviceURL , String ep)
    {
	int i = serviceURLs.indexOf(serviceURL);
	if (i != -1)
	    {
		String nickname = (String)nicknames.elementAt(i);
		String message ="Do you want to receive "+fileName+" file from "+nickname +"?";
		if (!window.autorization(message)) return false;
		System.out.println(" You Will receive "+fileName+" file from "+nickname);
		//acceptedFiles.addElement(fileName);
	    }
	return true;
    }
    
    
    public boolean receiveFile(String url, String serviceURL, String ep)
    {
	try
	    {
		//acceptedFiles.removeElement(fileName);
		if (url == null) return false;
		System.out.println("I start wait at "+System.currentTimeMillis());
		long t7 = System.currentTimeMillis();
		String fileName = url;
		String baseAddress =  ep.substring(0,ep.indexOf("/",8));
		String context = "root";
		url = baseAddress+"/"+context+"/"+url;
		System.out.println("URL file is :"+url);
		java.net.URL urlFile = new java.net.URL(url);
		java.net.HttpURLConnection urlConn =  (java.net.HttpURLConnection)urlFile.openConnection();
		java.io.BufferedInputStream bis = new java.io.BufferedInputStream(urlConn.getInputStream());
		String uriFile = window.getFilePath(fileName);
		if (uriFile != null && !uriFile.equals(""))
		    {
			java.io.File file = new java.io.File(uriFile);
			java.io.FileOutputStream fileStream = new java.io.FileOutputStream(file);
			
			byte[] buff = new byte[1000];
			
			int num = bis.read(buff,0,1000);
			while (num >0) 
			    {
				fileStream.write(buff,0,num);
				num = bis.read(buff,0,1000);
			    }
			fileStream.close();
		    }
	    }
	catch(Exception ex)
	    {
		System.out.println("Error in receive file from "+serviceURL);
		return false;
	    }
	return true;
    }
    
    public boolean receiveFile(byte[] file, String serviceURL, String ep)
    {
	//acceptedFiles.removeElement(fileName);
	return true;
    }

    public boolean sendFile(String uri, String nickname)
    {
	int index = nicknames.indexOf(nickname); 
	if (index !=-1)
	    { 
		if (eps.elementAt(index) != null )
		return sendFileTo(uri, (String)eps.elementAt(index));
		else System.out.println("User not connected");
	    }
	else System.out.println("User not exist");
	return false;
    }

    public boolean sendFileTo(String uri, String ep)
    {
	try
	    {
		URL url = new URL(ep);
		OzoneMessengerInterface service=new OzoneMessengerService.OzoneMessengerSOAPBindingStub(url,null);
		if (service.accept(uri, myServiceURL , myEp))
		return service.receiveFile(uri, myServiceURL, myEp);
		else return false;
	    }
	catch (Exception ex)
	    {
		System.out.println("Error in sending file");
		return false;
	    }
    }

    public Vector getNicknames()
    {
	return nicknames;
    } 

    public Vector getServiceURLs()
    {
	return serviceURLs;
    }

    public void setFriends(Vector serviceURLs, Vector nicknames)
    {
	this.serviceURLs = serviceURLs;
	user.setFriendServiceURLs(this.serviceURLs);
	this.nicknames = nicknames;
	user.setFriendNicknames(this.nicknames);
	users.setUser(user, myServiceURL);
	eps = new Vector();
	getConnected(serviceURLs, eps);
	for (int i=0;i<eps.size();i++)
	    {
		try
		    {
			if (eps.elementAt(i) != null) 
			    {
				URL url = new URL((String)eps.elementAt(i));
				OzoneMessengerInterface service = new OzoneMessengerService.OzoneMessengerSOAPBindingStub(url,null);
				if (!service.getServiceURL().equals((String)serviceURLs.elementAt(i)))
				    eps.set(i,null);
			    }
		    }
		catch (Exception ex)
		    {
			System.out.println("Error in newConnected message");
		    }
	    }
	
	window.showFriends();
    }

    public static void main(String[] args)
    {
	OzoneMessengerImpl messenger = new OzoneMessengerImpl();
    }

}
