/**
 * OzoneMessenger.java
 *
 * Java code for the implementation of the Ozone Messenger Web Service
 */

package OzoneMessengerService;

import java.util.*;
import java.net.*;


public class OzoneMessengerImpl implements OzoneMessengerService.OzoneMessengerInterface ,javax.xml.rpc.server.ServiceLifecycle
{
    private String myNickname="noNickname";
    private String myServiceURL="noServiceURL";
    private String myEp="http://localhost:8080/services/OzoneMessenger";

    private String wsamiMessenger ="http://localhost:8080/wsami/OzoneMessengerAbstract.wsami";
    private String LocalNDAddress ="http://localhost:8080/services/ND";
    private Vector nicknames = new Vector();   // local managed
    private Vector serviceURLs = new Vector(); // local managed
    private Vector eps = new Vector();         // gived by ND
    private static boolean statPing = false;
    private static int pingPosition = -1;
    Thread pings;

    // graphical interface 
    OzoneMessengerFrame window = null;
    
    // end graphical interface 
    Users users;
    User user;

    public OzoneMessengerImpl() {
	//window = new OzoneMessengerFrame(this);
	//window.show();
    }

    public boolean showWindow(String MyServiceURL)
    {
	pings = friendPing();
	//System.out.println("showWindow level 1");
	eps.removeAllElements();
	nicknames.removeAllElements();
	//System.out.println("showWindow level 2");
	if (MyServiceURL.equals("noServiceURL"))
	    {
		System.out.println(" is not autorized");
		return false;
	    } 

	myServiceURL = MyServiceURL;
	//System.out.println("showWindow level 3");
	window = new OzoneMessengerFrame(this);
	//System.out.println("showWindow level 4");
	// find friends on the user.xml file
	ClassLoader cl = Thread.currentThread().getContextClassLoader();
	//System.out.println("showWindow level 5");
	java.net.URL resource = cl.getResource("user.xml");
	if (resource == null)
	    {
		//System.out.println("showWindow level 6");
		// create the user.xml file
		resource = cl.getResource(".");
		if (resource != null)
		    {
			System.out.println("resource.getPath()="+resource.getPath()); 
			try
			    {
				java.io.File userXMLFile = new java.io.File(resource.getPath()+"/user.xml");
				userXMLFile.createNewFile(); 
				java.io.FileWriter usersFile = new java.io.FileWriter(userXMLFile);
				usersFile.write("<messenger>");
				usersFile.write("</messenger>");
				usersFile.close();
				users = new Users(userXMLFile.getPath());
			    }
			catch(Exception ex)
			    {
				System.out.println("Error in create user.xml file");
			    } 
		    }
		else System.exit(0);
	    }
	else users = new Users(resource.getPath()); 
	//System.out.println("showWindow level 7");
	user = users.getUser(myServiceURL);
		if (user ==  null) 
		    {
			// add here the frame which allows to add new user and his friends
			String message1 ="This user doesn't exist on Ozone Messenger.";
			String message2=  "Do you want to add him?";
			if (!window.autorization(message1, message2)) return false;
			//System.out.println("*****************Yes, I want 1") ;
			window.showNewUserDialog(myServiceURL);
			//System.out.println("*****************Yes, I want 2") ;
			if (window.getAddNewUserStat())
			    {
				//System.out.println("*************Yes, I want 3");
				user = new User();
				user.setServiceURL(window.getNewUserServiceURL());
				user.setName(window.getNewUserName());
				user.setNickname(window.getNewUserNickname());
				if (!users.addUser(user)) return false;
				//users.saveChange();
			    }
			else return false;
		    }
		
		//users.saveChange();
		
		myNickname = user.getNickname();
		window.setNickname(myNickname);
		window.show();
		serviceURLs = user.getFriendServiceURLs();	
		nicknames = user.getFriendNicknames();

		//System.out.println("showWindow level 8");
		CoreBroker.IFUtils ifUtils = new CoreBroker.IFUtils();
		String[] localIPAddrs = ifUtils.getLocalHostAddresses();
		if (localIPAddrs.length==1)
		    {
			myEp ="http://"+localIPAddrs[0]+":8080/services/OzoneMessenger";
			//System.out.println("1******MyEp Address is "+myEp);

		    }
		else 
		    {
			myEp ="http://"+localIPAddrs[1]+":8080/services/OzoneMessenger";
			//System.out.println("2******MyEp Address is "+myEp);
		    }

		//Vector epsTmp = new Vector();
		//System.out.println("Messenger level 1");
		getConnected(serviceURLs, eps);

		//System.out.println("**************after getConnected********");

		System.out.println("serviceURLs.size()="+serviceURLs.size());
		System.out.println("eps.size()="+eps.size());
		for (int x=0;x<serviceURLs.size();x++)
		    {
			System.out.println("serviceURLs.elementAt("+x+")="+(String)serviceURLs.elementAt(x));
			System.out.println("eps.elementAt("+x+")="+(String)eps.elementAt(x));
		    }

		//System.out.println("**************and*************");
		//System.out.println("Messenger level 2");
		
		for (int i=0;i<eps.size();i++)
		    {
			try
			    {
				//	System.out.println("Messenger level 5");
				if (eps.elementAt(i) != null) 
				    {
					//System.out.println("Messenger level 6");
					URL url = new URL((String)eps.elementAt(i));
					OzoneMessengerInterface service = new OzoneMessengerService.OzoneMessengerSOAPBindingStub(url,null);
					if (service.getServiceURL().equals((String)serviceURLs.elementAt(i)))
					    {
						System.out.println("*****************I Will tell my friend "+(String)serviceURLs.elementAt(i)+" that I'am here");
						service.newConnected(myServiceURL, myEp);
					    }
					else 
					    {
						System.out.println("**************My friend "+(String)serviceURLs.elementAt(i)+" isn't here");
						eps.set(i,null);
					    }
				    }
				//System.out.println("Messenger level 7");
			    }
			catch (Exception ex)
			    {
				System.out.println("Error in newConnected message");
			    }
		    }
		// show graphical window
		//System.out.println("Messenger level 8");
		//window.setNickname(myNickname);
		//window.show();
		window.showFriends();
		//windows.fieldMessage.requestFocus();
		//System.out.println("Messenger level 9");
		
		pings.start();
		return true;
    }
    

    public String getNickname()
    {
	return myNickname;
    }

    public String getServiceURL()
    {
	return myServiceURL;
    }

    public void newConnected(String serviceURL, String ep)
    {
	System.out.println("**************new Connected serviceURL="+serviceURL+" and ep="+ep);
	System.out.println("serviceURLs[]="+serviceURLs);
	System.out.println("eps[]="+eps);
	if (serviceURLs.indexOf(serviceURL) !=-1) 
	    {
		eps.set(serviceURLs.indexOf(serviceURL),ep);
		System.out.println("After add the new connected eps[]="+eps);
		window.showFriends();
	    }
	else System.out.println("*****************this new connected isn't my friend, serviceURL="+serviceURL+" and ep="+ep);
    }
    
    public boolean receiveMessage(String serviceURL, String message, Calendar date)
    {
	int i =  serviceURLs.indexOf(serviceURL);
	if (i!=-1)
	window.showMessage((String)nicknames.elementAt(i), message, date);
	return true;
    }
    
    public boolean sendMessage(String message, Calendar date)
    {
        boolean correctSent = true;
	//window.showMessage(myNickname, message, date);
	for (int i=0;i<eps.size();i++)
	    {
		if (eps.elementAt(i) != null)
      		correctSent = (correctSent && sendMessage(message, date,(String)eps.elementAt(i)));
	    }
	return correctSent;
    }

    public boolean send(String message, Calendar date , String nickname)
    {
	int index = nicknames.indexOf(nickname); 
	if (index !=-1)
	    { 
		if (eps.elementAt(index)!=null)
		    {
			boolean stat = sendMessage(message, date , (String)eps.elementAt(index));
			//window.showMessage(myNickname, message, date);
			return stat;
		    }
		else System.out.println("User not Connected");
    
	    }
	else System.out.println("User not exist");
	return false;
    }

    private boolean sendMessage(String message, Calendar date , String ep)
    {
	try
	    {
		if (ep == null || ep.equals("")) return false;
		URL url = new URL(ep);
		OzoneMessengerInterface service=new OzoneMessengerService.OzoneMessengerSOAPBindingStub(url,null);
		return service.receiveMessage(myServiceURL, message, date);
	    }
	catch (Exception ex)
	    {
		System.out.println("Error in sendMessage");
		return false;
	    }
    }

    private void getConnected(Vector serviceURLs, Vector eps)
    {	
	eps.removeAllElements();
	NDService.GetServiceData[] services = null ;
	try
	    {
		NDService.NDPortType nd= new NDService.NDBindingStub(new URL(LocalNDAddress),null);

		for (int cpt=0; cpt<serviceURLs.size(); cpt++)
		    {
			System.out.println("**************I will ask ND(to give Ep of: "+(String)serviceURLs.elementAt(cpt));
			services = nd.getService_ByInstanceURL((String)serviceURLs.elementAt(cpt));
			System.out.println("**************ND is Called");
			if (services != null && services.length>0) 
			    {
				if (services.length==1)
				    {
					eps.add(services[0].getServiceEP());
					System.out.println("1**************Ep returned by ND: "+services[0].getServiceEP());
				    }
				else 
				    {
					eps.add(services[1].getServiceEP());
					System.out.println("2**************Ep returned by ND: "+services[1].getServiceEP());
				    }
			    }
			else 
			    {
				System.out.println("**************ND return Null of: "+(String)serviceURLs.elementAt(cpt));
				System.out.println("**************I will add null into eps");
				eps.add(null);
				System.out.println("**************null is add into eps");
			    }
		    }
	    }
	catch (Exception ex)
	    {
		ex.printStackTrace();
		System.out.println("************* Error in getMembers");
	    }
    }
    
    public boolean closeWindow()
    {
	System.out.println("window closed");
	window.hide();
	// tell deconnection to all my friends
	for (int i=0;i<eps.size();i++)
	    {
		if (eps.elementAt(i)!=null)
		try
		    {
			URL url = new URL((String)eps.elementAt(i));
			OzoneMessengerInterface service = new OzoneMessengerService.OzoneMessengerSOAPBindingStub(url,null);
			service.freindDeconnecting(myServiceURL, myEp);
		    }
		catch (Exception ex)
		    {
			System.out.println("Error in closeWindow");
		    }
	    }
	eps.removeAllElements();
	myNickname="noNickname";
	myServiceURL="noServiceURL";
	//pings.stop();
	return true;
    }
    public void freindDeconnecting(String serviceURL, String Ep)
    {
	eps.set(serviceURLs.indexOf(serviceURL),null);
	window.showFriends();
    }

    public Iterator getConnectedNicknames()
    {
	Vector tmp = new Vector();
	for (int i=0;i<eps.size();i++)
	    if (eps.elementAt(i)!= null) tmp.addElement((String)nicknames.elementAt(i));
	return tmp.iterator();
    }

    public boolean accept(String fileName, String serviceURL , String ep)
    {
	int i = serviceURLs.indexOf(serviceURL);
	if (i != -1)
	    {
		String nickname = (String)nicknames.elementAt(i);
		String message1 ="Do you want to receive "+fileName+" file,"; 
		String message2 ="from "+nickname +"?";
		if (!window.autorization(message1, message2)) return false;
		System.out.println(" You Will receive "+fileName+" file from "+nickname);
		//acceptedFiles.addElement(fileName);
	    }
	return true;
    }
    
    
    public boolean receiveFile(String url, String serviceURL, String ep)
    {
	try
	    {
		//acceptedFiles.removeElement(fileName);
		if (url == null) return false;
		System.out.println("I start wait at "+System.currentTimeMillis());
		long t7 = System.currentTimeMillis();
		String fileName = url;
		url = ep.substring(0,ep.indexOf("/",8))+"/root/"+url;
		System.out.println("URL file is :"+url);
		java.net.URL urlFile = new java.net.URL(url);
		java.net.HttpURLConnection urlConn =  (java.net.HttpURLConnection)urlFile.openConnection();
		java.io.BufferedInputStream bis = new java.io.BufferedInputStream(urlConn.getInputStream());
		String uriFile = window.getFilePath(fileName);
		if (uriFile != null && !uriFile.equals(""))
		    {
			java.io.File file = new java.io.File(uriFile);
			java.io.FileOutputStream fileStream = new java.io.FileOutputStream(file);
			
			byte[] buff = new byte[1000];
			
			int num = bis.read(buff,0,1000);
			while (num >0) 
			    {
				fileStream.write(buff,0,num);
				num = bis.read(buff,0,1000);
			    }
			fileStream.close();
			window.showInformation(fileName+" file is successfully recieved");
		    }

	    }
	catch(Exception ex)
	    {
		System.out.println("Error in receive file from "+serviceURL);
		return false;
	    }
	return true;
    }
    
    public boolean receiveFile(byte[] file, String serviceURL, String ep)
    {
	//acceptedFiles.removeElement(fileName);
	return true;
    }

    public boolean sendFile(String uri, String nickname)
    {
	int index = nicknames.indexOf(nickname); 
	if (index !=-1)
	    { 
		if (eps.elementAt(index) != null )
		return sendFileTo(uri, (String)eps.elementAt(index));
		else System.out.println("User not connected");
	    }
	else System.out.println("User not exist");
	return false;
    }

    public boolean sendFileTo(String uri, String ep)
    {
	try
	    {
		URL url = new URL(ep);
		OzoneMessengerInterface service=new OzoneMessengerService.OzoneMessengerSOAPBindingStub(url,null);
		if (service.accept(uri, myServiceURL , myEp))
		return service.receiveFile(uri, myServiceURL, myEp);
		else return false;
	    }
	catch (Exception ex)
	    {
		System.out.println("Error in sending file");
		return false;
	    }
    }

    public Vector getNicknames()
    {
	return nicknames;
    } 

    public Vector getServiceURLs()
    {
	return serviceURLs;
    }

    public void setFriends(Vector serviceURLs, Vector nicknames)
    {
	this.serviceURLs = serviceURLs;
	user.setFriendServiceURLs(this.serviceURLs);
	this.nicknames = nicknames;
	user.setFriendNicknames(this.nicknames);
	users.setUser(user, myServiceURL);
	lookFriends();
	/*
	eps = new Vector();
	getConnected(serviceURLs, eps);
	for (int i=0;i<eps.size();i++)
	    {
		try
		    {
			if (eps.elementAt(i) != null) 
			    {
				URL url = new URL((String)eps.elementAt(i));
				OzoneMessengerInterface service = new OzoneMessengerService.OzoneMessengerSOAPBindingStub(url,null);
				if (!service.getServiceURL().equals((String)serviceURLs.elementAt(i)))
				    eps.set(i,null);
				else service.newConnected(myServiceURL, myEp);
			    }
		    }
		catch (Exception ex)
		    {
			System.out.println("Error in newConnected message");
		    }
	    }
	
	window.showFriends();
	*/
    }

    public void lookFriends()
    {
	eps = new Vector();
	getConnected(serviceURLs, eps);
	for (int i=0;i<eps.size();i++)
	    {
		try
		    {
			if (eps.elementAt(i) != null) 
			    {
				URL url = new URL((String)eps.elementAt(i));
				OzoneMessengerInterface service = new OzoneMessengerService.OzoneMessengerSOAPBindingStub(url,null);
				if (!service.getServiceURL().equals((String)serviceURLs.elementAt(i)))
				    eps.set(i,null);
				else service.newConnected(myServiceURL, myEp);
			    }
		    }
		catch (Exception ex)
		    {
			System.out.println("Error in newConnected message");
		    }
	    }
	
	window.showFriends();
    }

    public boolean ping(String serviceURL)
    {
	return !myNickname.equals("noNickname");
    }

    public static void main(String[] args)
    {
	OzoneMessengerImpl messenger = new OzoneMessengerImpl();
    }

    public void init(Object obj) 
    {
	//System.out.println("********Init of Ozone Messenger is called*******");
    }
    public void destroy()
    {
	//	System.out.println("********Destroy of Ozone Messenger is called*******");
	closeWindow();
 
    }



  public Thread friendPing() {
        try
	    {
		Thread ThreadPing = 
		    new Thread( new Runnable() 
			{
			    public void run() 
			    {
				
				while (myNickname!=null && !myNickname.equals("noNickname")) 
				    {
					int cpt=0;
					if (eps!= null && eps.size()>0)
					    for (int i=0; i<eps.size();i++)
					    {
						if (eps.elementAt(i) != null) 
						    {
							cpt++;
							System.out.println("I will create ping for "+i);
							pingPosition = i;
							Thread ping = Ping();
							System.out.println("ping is created for "+i);
							ping.start();
							System.out.println("ping is started for "+i);

							System.out.println("I will waiting ping for "+i);		
							try
							    {	
								ping.join(5000);
							    }
							catch (Exception ex)
							    {
								System.out.println("Error at ping.join(5000)");
							    }
							System.out.println("ping is died for "+i);			
							if (!statPing)
							    {
								cpt--;
								eps.set(i, null);
								window.showFriends();
								System.out.println("my Friend is deconnected because statPing="+statPing);
							    }
						    }
					    }
					if (cpt==0) lookFriends();
					try
					    {
						Thread.sleep(10000);
					    }
					catch (Exception ex)
					    {
						System.out.println("Sleep Error");
					    }
				    }
			    }
			});
		return ThreadPing;
	    }
	catch (Exception ex)
	    {
		System.out.println("Error in create FriendPing Thread");
	    }
	return null;
  }


 public Thread Ping() {
        try
	    {
		Thread Ping = 
		    new Thread( new Runnable() 
			{
			    public void run() 
			    {
				statPing = false;
				try
				    {
					URL url = new URL((String)eps.elementAt(pingPosition));
					OzoneMessengerInterface service = new OzoneMessengerService.OzoneMessengerSOAPBindingStub(url,null);
					System.out.println("I will ping "+pingPosition);
					if (service.ping(myServiceURL));
					{
					    System.out.println("my Friend is allways connected");
					    statPing = true;
					}
				    }
				catch (Exception ex)
				    {
					statPing = false;
					System.out.println("my Friend is deconnected");
				    }
			    }
			});
		return Ping;
	    }
	catch (Exception ex)
	    {
		System.out.println("Error in create Ping Thread");
	    }
	return null;
  }


}


