package OzoneMessengerService;

import org.xml.sax.helpers.DefaultHandler;
import org.xml.sax.SAXParseException;
import org.xml.sax.SAXException;
import org.xml.sax.Attributes;
import java.util.Vector;


public class SAXHandler extends DefaultHandler {
  
    private int stat = 0, cpt =0;
    Vector tableAttributes = new Vector();
    Vector users = new Vector();
    int[][] startTable = new int[30][5];
    int[][] endTable = new int[30][5];
    User user = null;
    String serviceURLTmp="";

    public SAXHandler() {
	
	tableAttributes.addElement("user");
        tableAttributes.addElement("name");
        tableAttributes.addElement("nickname");
        tableAttributes.addElement("friends");
        tableAttributes.addElement("serviceURL");
	
	for (int y=0;y<5;y++)
	    for (int z=0;z<30;z++)
		startTable[z][y]=-1;
	
	startTable[0][0]=1;
	startTable[1][1]=2;
	startTable[1][2]=3;
	startTable[1][3]=4;
	startTable[5][2]=8;
	startTable[5][3]=9;
	startTable[6][1]=10;
	startTable[6][3]=11;
	startTable[7][1]=12;
        startTable[7][2]=13;
	startTable[14][3]=20;
	startTable[15][2]=21;
	startTable[16][3]=22;
	startTable[17][1]=23;
	startTable[18][2]=24;
	startTable[19][1]=25;
	startTable[20][4]=27;
	startTable[28][2]=29;
	
	endTable[2][1]=5;
	endTable[3][2]=6;
	endTable[4][3]=7;
	endTable[5][0]=0;
	endTable[6][0]=0;
	endTable[7][0]=0;
	endTable[8][2]=14;
	endTable[9][3]=15;
	endTable[10][1]=16;
	endTable[11][3]=17;
	endTable[12][1]=18;
	endTable[13][2]=19;
	endTable[14][0]=0;
	endTable[15][0]=0;
	endTable[16][0]=0;
	endTable[17][0]=0;
	endTable[18][0]=0;
	endTable[19][0]=0;
	endTable[20][3]=26;
	endTable[21][2]=26;
	endTable[22][3]=26;
	endTable[23][1]=26;
	endTable[24][2]=26;
	endTable[25][1]=26;
	endTable[26][0]=0;
	endTable[27][4]=28;
	endTable[29][2]=20;
	
        stat = -2;
    }

    private void init() {
	users.removeAllElements();
        stat = -2; // initial stat
        }


    public void startDocument() throws SAXException {
        init();
    }

    public void startElement(String uri, String localName, String qName, Attributes atts) throws SAXException
    {
	if (stat == -2 || localName.equals("messenger")) stat = 0;
	else
	    { 
		stat = startTable[stat][tableAttributes.indexOf(localName)];
		switch (stat)
		    {
		    case 1:
			if (atts.getLocalName(0) == null || !atts.getLocalName(0).equals("instance") || atts.getValue(0) == null || atts.getValue(0).equals("")) stat = -1;
			else 
			    {
				user = new User();
				user.setServiceURL(atts.getValue(0));
			    }
			break;
		    case -1:
			System.out.println("Error XML");
			System.exit(0); 
		    }
	    }
	
    }
    
   public void characters(char ch[], int start, int length)
    {
	switch (stat)
	    {
	    case 2:
	    case 10:
	    case 12:
	    case 23:
	    case 25:
		user.setName(new String(ch, start, length));
		break;
	    case 3:
	    case 8:
	    case 13:
	    case 21:
	    case 24:
		user.setNickname(new String(ch, start, length));
		break;
	    case 27:
		serviceURLTmp = new String(ch, start, length);
		break;
	    case 29:
		user.addFriend(serviceURLTmp, new String(ch, start, length)); 
		break;
	    case -1:
		System.out.println("Error XML");
		System.exit(0); 
	    }
    }
    
    public void endElement(String uri, String localName, String qName) throws SAXException
    {
	if (stat == 0 && localName.equals("messenger")) stat = -2;
	else 
	    {
		stat = endTable[stat][tableAttributes.indexOf(localName)];
		if (stat == 0) users.addElement(user);
	    }
    }
    
    public void startPrefixMapping(String prefix, String uri)
    {
	
    }

    public void endPrefixMapping(String string)
    {
	
    }
    

    public void endDocument() throws SAXException
    {
	
    }

    public void error(SAXParseException sAXParseException) throws SAXException
    {
	System.out.println("Error");
    }

    public void fatalError(SAXParseException sAXParseException) throws SAXException
    {
	System.out.println("Fatal Error ");
    }

    public Vector getUsers()
    {
	return users;
    }
}
