package YellowPagesService.database;

import YellowPagesService.*;

import java.math.*;
import java.util.*;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;



public abstract class GenericYellowPagesDB implements YellowPagesDB {

    protected Connection conn = null;
    protected ResultSet rs = null;
    protected Statement stmt = null;
    protected PreparedStatement pstmt = null;
    protected String dbUrl = Globals.dbUrl;

    protected GenericYellowPagesDB() throws DatabaseException{
	connect();
    }

    // this should connect to the database and initialize stmt
    public abstract void connect() throws DatabaseException;

    public void close() throws DatabaseException{
	try{
	    conn.close();
	} catch(Exception ex){
	    throw new DatabaseException(new BigInteger("1"),ex.getMessage());
	}
    }

    // main methods

    public Vector getCategories() throws DatabaseException{
	try{
	    String sql = "SELECT * FROM Category";

	    rs = stmt.executeQuery(sql);
	    
	    Vector results = new Vector();

	    while(rs.next()){
		Category category = new Category();

		category.setName(rs.getString("name"));
		category.setDescription(rs.getString("description"));

		results.addElement(category);
		
	    }
	    
	    return results;

	} catch(Exception ex){
	    throw new DatabaseException(new BigInteger("1"),ex.getMessage());
	}
	
    }

    public Vector find(String category,
		       String street,
		       String zip,
		       String city) throws DatabaseException{

	try{

	    boolean where = true;
	    
	    String sql = "SELECT * FROM Entry";
	    
	    if(!category.equals("")){
		if(where){
		    sql = sql + " WHERE ";
		    where = false;
		} else{
		    sql = sql + " AND ";
		}
		
		sql = sql + "categoryName = " + "\'" + category + "\'";
		
	    }

	    if(!street.equals("")){
		if(where){
		    sql = sql + " WHERE ";
		    where = false;
		} else{
		    sql = sql + " AND ";
		}
		
		
		sql = sql + "street = " + "\'" + street + "\'";
		
	    }

	    if(!zip.equals("") && !zip.equals("0")){
		if(where){
		    sql = sql + " WHERE ";
		    where = false;
		} else{
		    sql = sql + " AND ";
		}
		
		
		sql = sql + "zip = "  + zip;
		
	    }


	    if(!city.equals("")){
		if(where){
		    sql = sql + " WHERE ";
		    where = false;
		} else{
		    sql = sql + " AND ";
		}
		
		sql = sql + "city = " + "\'" + city + "\'";
		
	    }


	    System.out.println(sql);
	    rs = stmt.executeQuery(sql);

	    Vector results = new Vector();

	    while(rs.next()){

		Entry entry = new Entry();
		entry.setId(new BigInteger(rs.getString("id")));
		entry.setCategoryName(rs.getString("categoryName"));
		entry.setName(rs.getString("name"));
		entry.setDescription(rs.getString("description"));
		entry.setWau(rs.getString("wau"));
		entry.setStreet(rs.getString("street"));
		entry.setZip(new BigInteger(rs.getString("zip")));
		entry.setCity(rs.getString("city"));
		entry.setPhone(new BigInteger(rs.getString("phone")));
		
		results.addElement(entry);
	    }
	    return results;

	} catch(Exception ex){
	    throw new DatabaseException(new BigInteger("1"),ex.getMessage());
	}
    }


    public Vector advancedFind(String expression)
	throws DatabaseException{

	try{

	    boolean where = true;
	    
	    String sql = "SELECT * FROM Entry WHERE "+expression;

	    System.out.println(sql);
	    rs = stmt.executeQuery(sql);

	    Vector results = new Vector();

	    while(rs.next()){

		Entry entry = new Entry();
		entry.setId(new BigInteger(rs.getString("id")));
		entry.setCategoryName(rs.getString("categoryName"));
		entry.setName(rs.getString("name"));
		entry.setDescription(rs.getString("description"));
		entry.setWau(rs.getString("wau"));
		entry.setStreet(rs.getString("street"));
		entry.setZip(new BigInteger(rs.getString("zip")));
		entry.setCity(rs.getString("city"));
		entry.setPhone(new BigInteger(rs.getString("phone")));
		
		results.addElement(entry);
	    }
	    return results;

	} catch(Exception ex){
	    throw new DatabaseException(new BigInteger("1"),ex.getMessage());
	}

    }
}
