package CoreBroker.Axis;

import java.io.InputStream;
import java.util.Hashtable;
 
import java.util.Iterator;

import javax.xml.namespace.QName;

import org.apache.axis.AxisEngine;
import org.apache.axis.ConfigurationException;
import org.apache.axis.Handler;
import org.apache.axis.WSDDEngineConfiguration;
import org.apache.axis.deployment.wsdd.WSDDDeployment;

import org.apache.axis.deployment.wsdd.WSDDDocument;
 
import org.apache.axis.deployment.wsdd.WSDDGlobalConfiguration;
 
import org.apache.axis.encoding.TypeMappingRegistry;
 
import org.apache.axis.handlers.soap.SOAPService;


import org.w3c.dom.*;
import org.apache.axis.configuration.*;

import CoreBroker.BrokerWrapper;
import CoreBroker.BrokerFactory;
import CoreBroker.CBException;


public class WSAMIProvider implements WSDDEngineConfiguration {

    private WSDDDeployment deployment = null;

    
    public WSAMIProvider() {}

    public WSDDDeployment getDeployment() {
        return deployment;
    }

    public void setDeployment(WSDDDeployment deployment) {
        this.deployment = deployment;
    }

    public void configureEngine(AxisEngine engine)    
            throws ConfigurationException {

        BrokerWrapper broker = null;
        try {
            broker = BrokerFactory.getServerInstance();
        } catch (CBException ex) {
            throw new ConfigurationException("Error Configuring Broker");
        }
        Document docServerConfig = broker.getDeploymentConfiguration();

        WSDDDocument doc = new WSDDDocument(docServerConfig);                
        deployment = doc.getDeployment();
        deployment.configureEngine(engine);
        engine.refreshGlobalOptions();                
    }

    public void writeEngineConfig(AxisEngine engine)
        throws ConfigurationException {
    }

    public Handler getHandler(QName qname) throws ConfigurationException {
        return deployment.getHandler(qname);
    }

    public SOAPService getService(QName qname) throws ConfigurationException {
        return deployment.getService(qname);    
    }

    public SOAPService getServiceByNamespaceURI(String namespace)
            throws ConfigurationException {
        return deployment.getServiceByNamespaceURI(namespace);
    }

    public Handler getTransport(QName qname) throws ConfigurationException {
        return deployment.getTransport(qname);
    }

    public TypeMappingRegistry getTypeMappingRegistry()
            throws ConfigurationException {
        return deployment.getTypeMappingRegistry();
    }

    public Handler getGlobalRequest() throws ConfigurationException {
        return deployment.getGlobalRequest();
    }

    public Handler getGlobalResponse() throws ConfigurationException {
        return deployment.getGlobalResponse();    
    }

    public Hashtable getGlobalOptions() throws ConfigurationException {
        
        WSDDGlobalConfiguration globalConfig
            = deployment.getGlobalConfiguration();
            
        if (globalConfig != null)
            return globalConfig.getParametersTable();

        return null;        
    }

    public Iterator getDeployedServices() throws ConfigurationException {
        return deployment.getDeployedServices();
    }
}
