package CoreBroker.Axis;

import java.io.IOException;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.axis.AxisEngine;
import org.apache.axis.transport.http.*;

import CoreBroker.BrokerFactory;
import CoreBroker.CBException;
import CoreBroker.Utils;
import CoreBroker.Syslog;

public class WSAMIServlet extends AxisServlet {

    private static String FACTORY_COREBROKER= "CoreBroker.Axis.AxisBrokerWrapper";
    
    public void destroy() {
        Syslog.debug(this,"WSAMIServlet.destroy()");
        super.destroy();
    }
    
    
    public void init() 
    {
        super.init();       
        BrokerFactory.setFactory(FACTORY_COREBROKER);        
        ServletContext context = getServletConfig().getServletContext();
        CoreBroker.Axis.WSAMIProvider WSAMIProvider = new CoreBroker.Axis.WSAMIProvider();
        org.apache.axis.server.AxisServer axisServer = new org.apache.axis.server.AxisServer(WSAMIProvider);
        context.setAttribute(ATTR_AXIS_ENGINE, axisServer);
         
        try {
            AxisEngine engine = getEngine();
            engine.init();
        } catch (org.apache.axis.AxisFault ex) {
            ex.printStackTrace();
        }
        
    }
    
    public void doPost(HttpServletRequest request, HttpServletResponse response)
        throws ServletException, IOException
    {
        AxisEngine engine = getEngine();
        engine.init();     
        super.doPost(request, response);
    }

  
}