package CoreBroker;

import org.w3c.dom.*;
import javax.xml.parsers.*;
//import org.apache.axis.utils.XMLUtils;


public class CLWSDL2WSAMI extends CLBaseClass
{
   String WAU, WSU, WCU, WAD, WSD, WCD;
   String WSDLinterface, WSDLconcrete;
   String WSDLinterfaceURL, WSDLconcreteURL;   
   String className, packageName, type;
   String deployXML;
   String undeployXML;   
   String serviceName;
   String HTTPBaseAddr;
   String isCustomizer;
   boolean hasCustomizer;
   String CustRemoteWAU;
   String CustLocalWAU;
   boolean colocation;
   String outputDir;
   String scope;
   String instance_URL;
   
   protected int setNParams()
   {
       return 1;
   }
   
   protected String setParamsDescription()
   {
       return "servicename";
   }
   
   
   protected void addOptions()
   {
        options.put("WSDLinterface",new CLOptionDescr("WSDLInterface",1,"the name of the WSDL file that defines the service WSDL Interface"));
        options.put("WSDLconcrete",new CLOptionDescr("WSDLconcrete",1,"the name of the WSDL files that defines the location endpoint of the service"));
        options.put("HTTPBaseAddr",new CLOptionDescr("HTTPBaseAddr","The address used to construct the URI (WAU, WSU, WCD, WSDL URI) that are used for files generation ","http://localhost:8080/wsami/",null));
        options.put("WAD",new CLOptionDescr("WAD",1,"WSAMI Abstract Document: the name of the local file that defines the WSAMI Abstract of the service"));
        options.put("WSD",new CLOptionDescr("WSD",1,"WSAMI Service Document: the name of the local file that defines the WSAMI Service of the service"));
        options.put("WCD",new CLOptionDescr("WCD",1,"WSAMI Customizer Document: the name of the local file that defines the WSAMI Customizer of the service"));
        options.put("WAU",new CLOptionDescr("WAU",1,"WSAMI Abstract URI: the URI address where is stored the WSAMI Abstract Document"));
        options.put("WSU",new CLOptionDescr("WSU",1,"WSAMI Service URI: the URI address where is stored the WSAMI Service Document"));
        options.put("WCU",new CLOptionDescr("WCU",1,"WSAMI Customizer URI: the URI address where is stored the WSAMI Customizer Document"));
        options.put("className",new CLOptionDescr("className",1,"the name of the java class that implements the service"));
        options.put("packageName",new CLOptionDescr("packageName",1,"the name of the directory where are stored all .class files used by the java service implementation (the same of the java package)"));
        options.put("type",new CLOptionDescr("type","javaclass if service is implemented as a java class. ", "javaclass", new String[]{"javaclass"}));
        options.put("deployXML",new CLOptionDescr("deployXML",1,"the name of the file that will be used to deploy the service on the Core Broker"));
        options.put("undeployXML",new CLOptionDescr("undeployXML",1,"the name of the file that will be used to undeploy the service from the Core Broker"));
        options.put("hasCustomizer",new CLOptionDescr("hasCustomizer",3,"the service implements the Customization feature. If this option is specified, the Customization file WCD and all the references to WCU will be generated in WAD (first option is Local Customizer WAU and second option is Remote Customizer WAU third option is for customizers colocation (true/false)"));
        options.put("isCustomizer",new CLOptionDescr("isCustomizer","local if this service implements the local side of the customization feature. remote if this service implements the remote side of the customization feature", null, new String[]{"local","remote"}));
        options.put("outputDir",new CLOptionDescr("outputDir",1,"the name of the directory where all xml and wsami files are generated"));
        options.put("scope",new CLOptionDescr("scope","Application: only one instance of the service. Session: one instance for every client. Request: one instance for every request.", "Application", new String[]{"Request","Session","Application"}));
        options.put("instance_URL",new CLOptionDescr("instance_URL",1,"the instance_URL of the service instance deployed with this deployment descriptor"));
        
   }
    
   public void setValues() 
   {
        serviceName = params[0];
        
        // set className, packageName, type, deployXML, hasCustomizer;        
        packageName = serviceName+"Service";
        className = packageName+"."+serviceName+"Impl";
        type = getStringOption("type");
        deployXML = serviceName+"Deploy.xml";
        undeployXML = serviceName+"unDeploy.xml";
        
        if (getStringOption("className") != null) 
            className = getStringOption("className");
        if (getStringOption("packageName") != null)
            packageName = getStringOption("packageName");

        if (getStringOption("deployXML") != null)
            deployXML = getStringOption("deployXML");
        if (getStringOption("undeployXML") != null)
            undeployXML = getStringOption("undeployXML");
        
        isCustomizer = getStringOption("isCustomizer");
        String[] cust = getArrayStringOption("hasCustomizer");
        hasCustomizer = (cust != null);
        if (hasCustomizer) {
            CustRemoteWAU = cust[1];
            CustLocalWAU = cust[0];
            colocation = (cust[2].equals("true"));
        }

        // set HTTPBaseAddr
        HTTPBaseAddr = getStringOption("HTTPBaseAddr");
        
        // set WSDLinterface and WSDLconcrete        
        WSDLinterface = serviceName+"Interface.wsdl";
        WSDLconcrete = serviceName+"Concrete.wsdl";        
        if (getStringOption("WSDLinterface") != null)
            WSDLinterface = getStringOption("WSDLinterface");
        if (getStringOption("WSDLconcrete") != null)
            WSDLconcrete = getStringOption("WSDLconcrete");
        WSDLinterfaceURL = HTTPBaseAddr+WSDLinterface;
        WSDLconcreteURL = HTTPBaseAddr+WSDLconcrete;

        // set WAD, WSD and WCD
        WAD = serviceName+"Abstract.wsami";
        WSD = serviceName+"Service.wsami";
        WCD = serviceName+"Customizer.wsami";
        if (getStringOption("WAD") != null)
            WAD = getStringOption("WAD");
        if (getStringOption("WSD") != null)
            WSD = getStringOption("WSD");
        if (getStringOption("WCD") != null)
            WCD = getStringOption("WCD");
        
        // set WAU, WSU and WCU
        WAU = HTTPBaseAddr+WAD;
        WSU = HTTPBaseAddr+WSD;
        WCU = HTTPBaseAddr+WCD;
        if (getStringOption("WAU") != null)
            WAU = getStringOption("WAU");
        if (getStringOption("WSU") != null)
            WSU = getStringOption("WSU");
        if (getStringOption("WCU") != null)
            WCU = getStringOption("WCU");
        
        
        outputDir = ".";
        if (getStringOption("outputDir") != null)
            outputDir = getStringOption("outputDir");
        
        scope = getStringOption("scope");
        instance_URL = getStringOption("instance_URL");
    }
    
    public void create_deployXML()
    {
       try
       {  
          DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
          DocumentBuilder db = dbf.newDocumentBuilder();

          Document d = db.newDocument();
          
          Element root = d.createElement("deploy");
          
          root.setAttribute("xmlns","http://www-rocq.inria.fr/arles/wsami");
          root.setAttribute("xmlns:xsi","http://www.w3.org/2001/XMLSchema-instance");
          root.setAttribute("xsi:schemaLocation","http://www-rocq.inria.fr/arles/wsami deploy_install.xsd");
          
          
          d.appendChild(root);
          Element service = d.createElement("service");          
          service.setAttribute("name",serviceName);
          if (isCustomizer != null)
              service.setAttribute("customizer",isCustomizer);

          Element el1 = d.createElement("wad");
          el1.setAttribute("name",WAD);
          service.appendChild(el1);          
          el1 = d.createElement("wsd");
          el1.setAttribute("name",WSD);
          service.appendChild(el1);
          if (hasCustomizer)
          {
            el1 = d.createElement("wcd");
            el1.setAttribute("name",WCD);
            service.appendChild(el1);
          }
          
          el1 = d.createElement("wau");
          el1.setAttribute("name",WAU);
          service.appendChild(el1);          
          /*
          el1 = d.createElement("wsu");
          el1.setAttribute("name",WSU);
          service.appendChild(el1);
          if (hasCustomizer)
          {
            el1 = d.createElement("wcu");
            el1.setAttribute("name",WCU);
            service.appendChild(el1);
          }
          */
          
          /*
          el1 = d.createElement("wsdl");
          el1.setAttribute("name",WSDLconcrete);
          service.appendChild(el1);
          */
          
          el1 = d.createElement("implementation");
          service.appendChild(el1);

          Element el2 = d.createElement("class");
          el2.setAttribute("name",className);
          el1.appendChild(el2);
          el2 = d.createElement("type");
          el2.setAttribute("name",type);
          el1.appendChild(el2);
          el2 = d.createElement("package");
          el2.setAttribute("name",packageName);
          el1.appendChild(el2);

          el1 = d.createElement("scope");
          el1.setAttribute("name",scope);
          service.appendChild(el1);

          if (instance_URL != null) {
            el1 = d.createElement("instance_URL");
            el1.setAttribute("name",instance_URL);
            service.appendChild(el1);
          }
          
          root.appendChild(service);

          java.io.File dir = new java.io.File(outputDir);  
          dir.mkdirs();
          java.io.FileOutputStream fout = new java.io.FileOutputStream(outputDir+"/"+deployXML);
          Utils.printDocToStream(d, fout);
          
       } catch (Exception ex) {
           ex.printStackTrace();           
       }              
    }
    

    public void create_undeployXML()
    {
       try
       {  
          DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
          DocumentBuilder db = dbf.newDocumentBuilder();
          Document d = db.newDocument();
          
          Element root = d.createElement("undeploy");
          root.setAttribute("xmlns","http://www-rocq.inria.fr/arles/wsami");
          root.setAttribute("xmlns:xsi","http://www.w3.org/2001/XMLSchema-instance");
          root.setAttribute("xsi:schemaLocation","http://www-rocq.inria.fr/arles/wsami deploy.xsd");          
          d.appendChild(root);
          
          Element service = d.createElement("service");          
          service.setAttribute("name",serviceName);
          
          Element el1 = d.createElement("wau");
          el1.setAttribute("name",WAU);
          service.appendChild(el1);          
          
                  
          root.appendChild(service);

          java.io.File dir = new java.io.File(outputDir);  
          dir.mkdirs();
          java.io.FileOutputStream fout = new java.io.FileOutputStream(outputDir+"/"+undeployXML);
          Utils.printDocToStream(d, fout);
          
       } catch (Exception ex) {
           ex.printStackTrace();           
       }              
    }
    
    
    public void createWSAMI()
    {
        java.io.File dir = new java.io.File(outputDir);  
        dir.mkdirs();

        try
        {
           WSAMI.WSAMIAbstractDocument abs = new WSAMI.WSAMIAbstractDocument();
           abs.setName(serviceName);
           abs.setInterface(WSDLinterfaceURL);
           if (hasCustomizer) 
                abs.setConnectorQoS(new String[]{"security"});
           abs.setTargetNamespace(HTTPBaseAddr);
           Document doc = abs.getXML();
           java.io.FileOutputStream fout = new java.io.FileOutputStream(outputDir+"/"+WAD);
           Utils.printDocToStream(doc, fout);

           WSAMI.WSAMIServiceDocument svc = new WSAMI.WSAMIServiceDocument();
           svc.setName(serviceName);
           svc.setTargetNamespace(HTTPBaseAddr);
           svc.setAbstract(WAU);
           svc.setConcrete(WSDLconcreteURL);
           doc = svc.getXML();
           fout = new java.io.FileOutputStream(outputDir+"/"+WSD);
           Utils.printDocToStream(doc, fout);
       
           if (hasCustomizer)
           {
               WSAMI.WSAMICustomizerDocument cust = new WSAMI.WSAMICustomizerDocument();
               cust.setName(serviceName);
               cust.setTargetNamespace(HTTPBaseAddr);
               cust.setQoSCriterion(new String[]{"security"});
               cust.setLocal(CustLocalWAU);
               cust.setRemote(CustRemoteWAU);
               cust.setColocation(colocation);
               doc = cust.getXML();
               fout = new java.io.FileOutputStream(outputDir+"/"+WCD);
               Utils.printDocToStream(doc, fout);               
           }
           
        } catch (Exception ex) { 
           ex.printStackTrace(); 
        }   
    }
       
    
    public static void main(String arg[]) {
        CLWSDL2WSAMI client = new CLWSDL2WSAMI();
        if (client.run(arg)) {                      
            client.create_deployXML();     
            client.create_undeployXML();
            client.createWSAMI();
        }
    }
        
}
