package CoreBroker.CSoap;

import CoreBroker.Syslog;
import java.util.Vector;
import javax.xml.soap.*;


public class WSAMIHandlerClientReq implements javax.xml.rpc.handler.Handler
{
//    private Vector svcList;  
    
   
    public void destroy() {
    }
    
    public javax.xml.namespace.QName[] getHeaders() {
        return null;
    }
    
    public boolean handleFault(javax.xml.rpc.handler.MessageContext messageContext) {
        return true;
    }
    
    public boolean handleRequest(javax.xml.rpc.handler.MessageContext messageContext) {
        try {
            javax.xml.rpc.handler.soap.SOAPMessageContext msgContext = 
                    (javax.xml.rpc.handler.soap.SOAPMessageContext)messageContext;
            Syslog.debug(this,"WSAMI handler client request invoke");

            /*
             * need to set the factory for the BrokerFactory because
             * this class is used at client side and when it is invoked
             * the factory hasn't been set yet.
             */
            CoreBroker.BrokerFactory.setFactory("CoreBroker.CSoap.CSoapBrokerWrapper");
            CoreBroker.BrokerWrapper broker = CoreBroker.BrokerFactory.getClientInstance();
            
            String customizerSessionID = null;
            String url = (String)msgContext.getProperty("transport.url");
           
            if (url != null)
                Syslog.debug(this,"url="+url);
  
            //Syslog.debug(this,"CUSTOMIZER Message BEFORE 1");            
            //javax.xml.soap.SOAPMessage msg1 = msgContext.getMessage();
            //msg1.writeTo(System.out);
            //Syslog.debug(this,"CUSTOMIZER Message AFTER 1");
             
            
            int index = url.lastIndexOf("?");
            if (index > 0)
            {
                customizerSessionID = url.substring(index+1);
                Syslog.debug(this,"customizerSessionID="+index+","+customizerSessionID);

                /* client:  customizerSessionID and the related customizer chain
                 *          has been set in the local 
                 *         Core Broker instance by the client code with the 
                 *         broker's method "String setCustomizerChain(LC, RC, WS)"
                 * LC:      customizerSessionID and the related customizer chain
                 *         has been set in the local 
                 *         Core Broker instance by the CustomizerProvider with the 
                 *         broker's method setCustID_and_Chain_FromHeader(msgSOAP, obj);
                 * RC:      customizerSessionID and the related customizer chain
                 *         has been set in the local 
                 *         Core Broker instance by the CustomizerProvider with the 
                 *         broker's method setCustID_and_Chain_FromHeader(msgSOAP, obj);
                 */
                if (broker.isCustomizer(customizerSessionID))
                    broker.addCustID_and_ChainToHeader(msgContext.getMessage(), customizerSessionID);
            }

            javax.xml.soap.SOAPMessage msg = msgContext.getMessage();

                        
            //Syslog.debug(this,"CUSTOMIZER Messge BEFORE 2");                        
            //msg.writeTo(System.out);
            //Syslog.debug(this,"CUSTOMIZER Message AFTER 2");                        
            
            return true;        
	} catch (Exception e) {
            e.printStackTrace();
        }
        return true;
    }
    
    public boolean handleResponse(javax.xml.rpc.handler.MessageContext messageContext) {
        return true;
    }
    
    public void init(javax.xml.rpc.handler.HandlerInfo handlerInfo) {
    }
    
}
