package NDService;


import CoreBroker.DeployedService;
import CoreBroker.BrokerWrapper;
import CoreBroker.BrokerFactory;
import CoreBroker.Utils;
import CoreBroker.IFUtils;
import java.util.Hashtable;
import java.util.Vector;
import WSAMI.*;
import CoreBroker.NetworkIFDescr;


import java.util.Enumeration;
import java.net.*;
import java.io.IOException;
import java.io.OutputStream;
import java.io.FileNotFoundException;
import java.io.InputStream;
import java.io.FileOutputStream;
import java.io.FileInputStream;

import com.solers.slp.*;
import com.solers.slp.ServiceLocationAttribute;
import com.solers.slp.ServiceLocationManager;
import com.solers.slp.ServiceURL;

import CoreBroker.SLPMgr;
import CoreBroker.Syslog;

import URService.*;
import java.util.Iterator;


public class NDImpl implements NDService.NDPortType 
   ,javax.xml.rpc.server.ServiceLifecycle 
{
    private Hashtable RemoteNDRepository;   // elements are RemoteNDRepositoryEntry
    private Hashtable RemoteRepository;     // key is WAU, elements are Vector of RemoteRepositoryEntry
    private Vector LocalRepositoryV;     // elements are LocalRepositoryEntry    

    /* FAVORITES */	
    private Favorites favorites;  // elements are favorite
    //private String favoritesFile="/opt/wsami/files/ur/favorite.xml";
    private String favoritesFile = CoreBroker.IFUtils.getFavoritesDir()+"/favorite.xml";
    
    private Hashtable TempRemoteServiceInstanceFound;
    
    private int energy[] = new int[9]; //{0,0,0,0,0,0,0,0,0};

    private boolean SLPMulticatEnabled = false; //true;

    private final String GWServiceWAU = "http://localhost:8080/wsami/GWAbstract.wsami";

    private CoreBroker.IFUtils CBIFUtils = new CoreBroker.IFUtils();
   
    private NetworkIFDescr[] _networkIFs = null;
    private String[] _hostAddresses = null;
    private boolean _ACStatus = false;
    private String _hostName = null;
    
    private int SLPEVENT_INITIALIZATION_SYSTEM = 0;
    private int SLPEVENT_WAITING_STARTSLP = 1;
    private int SLPEVENT_SLP_STARTED = 2;
    private int SLPEVENT_ND_REGISTRED = 3;
    
    private int SLPSTATE_SLP_RUNNING = 100;
    private int SLPSTATE_SLP_NOTRUNNING = 101;
    
    private String WSAMIBINDIR = null;
    private String SLPEVENTFILE = null;
    private String SLPCONFFILE = null;

    
    private String URAddr = null;
    private URInfo _urInfo = new URInfo();

    private boolean do_slp_lookup;
    private boolean do_slp_registration;

    
    private boolean isAdHoc_and_ConnectedToGW = false;
    
    public void destroy() {
        Syslog.debug(this,"ND destoy");

        do_slp_registration = false;
        do_slp_lookup = false;
       
        
        // unregister All services from UR
        Syslog.debug(this,"ND : unRegisterAllServicesFromUR()");
        unRegisterAllServicesFromUR();

        
        try{
            Thread.sleep(20000);
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        
        
        // unregister from slp
        java.util.Vector hostAddresses = new java.util.Vector();
        java.util.Properties p = new java.util.Properties();
        p.put("net.slp.traceDATraffic", "true");
        p.put("net.slp.traceMsg", "true");
        p.put("net.slp.traceDrop", "true");
        p.put("net.slp.traceReg", "true"); 
        p.put("net.slp.isBroadcastOnly","true");

        Advertiser adv = null;

        try {
            ServiceLocationManager.init(p);
            adv = ServiceLocationManager.getAdvertiser(java.util.Locale.getDefault());

            if( adv != null ) {
                CoreBroker.IFUtils util = new CoreBroker.IFUtils();
                String[] addrs = util.getLocalHostAddresses();
                for (int i=0; i<addrs.length; i++) {
                    hostAddresses.add(addrs[i]);
                }

                try {
                    for (int i=0; i<hostAddresses.size(); i++) {
                        String serviceURL = "service:ND:http://"+(String)hostAddresses.get(i)+":8080/services/ND";
                        ServiceURL ndURL = new ServiceURL( serviceURL, ServiceURL.LIFETIME_MAXIMUM);
                        Syslog.info(this,"unRegistering on SLP: "+serviceURL);            
                        adv.deregister(ndURL);
                    }
                } catch( Exception ex ) { 
                    //ex.printStackTrace();
                    Syslog.warning(this,"Cannot connect to slpd server on localhost. Starting slpd...");
                }        
            }
        } catch( Exception ex ) { 
            ex.printStackTrace();
        }                                    
    }
    
    public void init(Object obj) throws javax.xml.rpc.ServiceException {
        Syslog.debug(this,"ND init");
    } 
      
     
    
    
    public void initialization() throws java.rmi.RemoteException {

        _hostAddresses = CBIFUtils.getLocalHostAddresses();
        try {
            _hostName = java.net.InetAddress.getLocalHost().getHostName();
        } catch (java.net.UnknownHostException ex) {
            _hostName = "localhost";
        }

        energy = CBIFUtils.getEnergyInfo(); 
        if (energy[CoreBroker.IFUtils.ACLINE_STATUS] == 1)
            _ACStatus = true;
        else
            _ACStatus = false;

        // **************** init favorites object *************
        // ******************** add by Rafik ******************

	try {
	    java.io.File favoriteXMLFile = new java.io.File(favoritesFile);
	    if (!favoriteXMLFile.exists()) 
	    {
		favoriteXMLFile.createNewFile(); 
		java.io.FileWriter favoriteFile = new java.io.FileWriter(favoriteXMLFile);
		favoriteFile.write("<favorites>");
		favoriteFile.write("</favorites>");
		favoriteFile.close();
	    }
	} catch(Exception e) {
	    e.printStackTrace();
	}

        favorites = new Favorites(favoritesFile);

        //***************** end init favorites object *********

        
        do_slp_registration = true;    
        Thread registerThread = slp_registration();
        registerThread.start();

        do_slp_lookup = true;
        Thread lookupThread = slp_lookup();
        lookupThread.start();
    }

    public void stop() throws java.rmi.RemoteException {
        Syslog.debug(this,"ND stop");
        // unregister from slp: making a call to this method is not a good
        // solution. the nd.stop is never called
        // the right solution is with servicelifecycle destroy()
    }  
    
    public NDImpl() {
        LocalRepositoryV = new Vector(); 
        RemoteRepository = new Hashtable();
        RemoteNDRepository  = new Hashtable();
        TempRemoteServiceInstanceFound = new Hashtable();

        try {
            URAddr = BrokerFactory.getServerInstance().getURAddr();
        } catch (CoreBroker.CBException ex) {
            ex.printStackTrace();
        }        
        
        try {
            WSAMIBINDIR = BrokerFactory.getServerInstance().getWSAMIBinDir();
        } catch (CoreBroker.CBException ex) {
            ex.printStackTrace();
        }
        SLPEVENTFILE = WSAMIBINDIR+"/slp.evt";
        SLPCONFFILE = WSAMIBINDIR+"/slp.conf";

    }
    
    private class LocalRepositoryEntry {
        String name;
        String WAU;
        String WSU;
        String WCU;
        
        public LocalRepositoryEntry (String name, String WAU, String WSU, String WCU) {
            this.name = name;
            this.WAU = WAU; 
            this.WSU = WSU; 
            this.WCU = WCU;
        }
    } 
    private class RemoteNDRepositoryEntry {
        String NDAddr;
        java.util.Properties props;
        boolean AC;
        
        public RemoteNDRepositoryEntry (String NDAddr, java.util.Properties props) {
            this.NDAddr = NDAddr; 
            this.props = props;
        }
        public RemoteNDRepositoryEntry (String NDAddr, java.util.Properties props,boolean AC) {
            this.NDAddr = NDAddr; 
            this.props = props; 
            this.AC = AC;
        }
        
    } 
    private class RemoteRepositoryEntry {
        String serviceEP;
        int timestamp;
        
        RemoteService rs;
        boolean localArea;
        
        public RemoteRepositoryEntry (String ep, int ts) {
            this.serviceEP = ep;
            this.timestamp = ts;                
        }
	
	public boolean equals(Object o) {
	    RemoteRepositoryEntry rre = (RemoteRepositoryEntry)o;
	    return (this.serviceEP.equals(rre.serviceEP));
	}
    } 
    
    private class URInfo {
        String[] ipsLocalHost;
        Hashtable services; // key = serviceName, value = Vector of EndPoints        
        
        public URInfo() {
            ipsLocalHost = null;
            services = new Hashtable();
        }
    }     
   
    
    public Thread getHostInfo() {
        try {
  
            Thread resultsThread = new Thread( new Runnable() {
                public void run() {
                    try {                        
                        while (true) {
                            
                            CoreBroker.IFUtils util = new CoreBroker.IFUtils();
                            
                            energy = util.getEnergyInfo();
                            
                            CoreBroker.NetworkIFDescr[] nwifInfo = util.getNetworkInfo();
                            for (int i=0; i<nwifInfo.length; i++)
                                if (nwifInfo[i] != null)
                                    Syslog.debug(this,i+")) "+nwifInfo[i].name+" >"+nwifInfo[i].ipAddr+" >"+nwifInfo[i].mode+" >"+nwifInfo[i].essid);
                            
                            Thread.sleep(10000);
             
                          
                        }
                    } catch (Exception ex) {
                        ex.printStackTrace();
                    }
 
                }
            });
            
            return resultsThread;
         } catch (Exception ex) { 
            ex.printStackTrace();    
         } 
         return null;
    }

    public void invalidate(java.lang.String serviceEP) 
            throws java.rmi.RemoteException {
                
        if (serviceEP != null) {

            //*********** invalidate this Ep in favorites object (Rafik)

            favorites = new Favorites(favoritesFile);
            favorites.invalidateFavorite(serviceEP);

            //************* end invalidate Ep in favorite***************


            Vector rsVect = new Vector(); // elements are RemoteService
            Enumeration rreVectors = RemoteRepository.elements(); // elements are Vector of RemoteRepositoryEntry

            while (rreVectors.hasMoreElements()) {
                Vector rreVector = (Vector)rreVectors.nextElement(); // elements are RemoteRepositoryEntry

                if (rreVector != null) {
                    for (int i=0; i<rreVector.size(); i++) {    
                        RemoteRepositoryEntry rre = (RemoteRepositoryEntry)rreVector.elementAt(i);
                        if (rre.rs.getAddress().equals(serviceEP)) {
                            rreVector.remove(i);
                            return;
                        }
                    }
                }
            }
            
        }
    }    

    private RemoteService[] getServicesFromUR(String serviceWSAMI,String instanceURL) {
        
        if (URAddr == null || URAddr.equals(""))
            return null;
        
        try {
	    Syslog.debug(this,"Calling UR at "+URAddr);       

            URThread getServicesURThread = new URThread(URAddr, serviceWSAMI, instanceURL);
	    getServicesURThread.start();
	    getServicesURThread.join(2000);
	    URService.GetServiceDataUR[] servicesUR = getServicesURThread.getURServices();

	    Syslog.debug(this,"servicesUR is "+servicesUR);

            if (servicesUR != null && servicesUR.length >0) {
                RemoteService[] rs = new RemoteService[servicesUR.length];
                for (int i=0; i<servicesUR.length; i++) {
                    rs[i] = new RemoteService();
                    rs[i].setWAU(servicesUR[i].getWAU());
                    rs[i].setAddress( servicesUR[i].getServiceEP() );
                    rs[i].setLCwau( servicesUR[i].getLCWAU() );
                    rs[i].setRCwau( servicesUR[i].getRCWAU() );
                    rs[i].setColocation( servicesUR[i].isColocation() );
                }
                
                updateRemoteRepository(rs, false);
                
                return rs;
            } else
                return null;
            
        } catch (Exception ex) {
            Syslog.error(this,"Error calling UR at "+URAddr); 
	    //ex.printStackTrace();            
        }        
        return null;
    }
    

    public class URThread extends Thread {
        String serviceWSAMI; 
	String instanceURL; 
	String URAddr;
	URService.GetServiceDataUR[] servicesUR = null;

	public URThread(String _URAddr, String _serviceWSAMI,String _instanceURL) {
	    serviceWSAMI = _serviceWSAMI;
	    instanceURL = _instanceURL;
	    URAddr = _URAddr;
	}

        public void run() {	    
            try{
		URL url = new URL(URAddr);
            
		URService.URInterface URservice = 
		    new URService.URSOAPBindingStub( url, null );

		if (instanceURL != null)
		    servicesUR = URservice.getServices_ByInstanceURL(instanceURL); 
		else            
		    servicesUR = URservice.getServices(serviceWSAMI); 
            } catch (java.rmi.RemoteException ex) {
                Syslog.error(this,"Error connecting to "+URAddr);
            }  catch (Exception ex) {
                // added to solve problem "No Route to Host"
                // and exception related to connection problems
                Syslog.error(this,"Error connecting to "+URAddr);
            }                                                    
        }

	public URService.GetServiceDataUR[] getURServices() {
	    return servicesUR;
	}
    }

    private void registerServiceUR(String name, String WAU, String instanceURL) {
        
        if (URAddr == null || URAddr.equals(""))
            return;        
        
        try {
            URL url = new URL(URAddr);
            
            URService.URInterface URservice = 
                new URService.URSOAPBindingStub( url, null );

            String[] ips = getLocalHostAddressInfraBased();
            String[] serviceAddrs = getEPLocalService_OnlyInfraBased(name);

            WSAMICustomizerDocument dC = CoreBroker.BrokerWrapper.getWCD_DeployedService(name);
            String LCWAU = null;
            String RCWAU = null;
            boolean colocation = false;
            if (dC != null) {
                LCWAU = dC.getLocal();
                RCWAU = dC.getRemote();
                colocation = dC.getColocation();
            }            
            URservice.register(WAU,serviceAddrs,instanceURL,LCWAU,RCWAU, colocation);
            
            _urInfo.ipsLocalHost = ips;
            Vector eps = new Vector();
            for (int i=0; i<serviceAddrs.length; i++)
                eps.add(serviceAddrs[i]);
            _urInfo.services.put(name, eps);
            
        } catch (Exception ex) {
            ex.printStackTrace();            
        }        
        return;
    }    

    private void unRegisterServiceFromUR(String WAU, String name) {
        
        if (URAddr == null)
            return;        

        try {
            URL url = new URL(URAddr);
            
            URService.URInterface URservice = 
                new URService.URSOAPBindingStub( url, null );

            if (_urInfo.services.containsKey(name)) {                
                Vector eps = (Vector)_urInfo.services.get(name);
                for (int i=0; i<eps.size(); i++)
                    URservice.unRegister(WAU,(String)(eps.elementAt(i)));
                _urInfo.services.remove(name);
            }
            
        } catch (Exception ex) {
            ex.printStackTrace();            
        }        
        return;
    }    

    private void unRegisterAllServicesFromUR() {

        if (URAddr == null)
            return;        

        try {
            URL url = new URL(URAddr);
            URService.URInterface URservice = 
                new URService.URSOAPBindingStub( url, null );
            URservice.unRegisterAll(_urInfo.ipsLocalHost);
            
        } catch (Exception ex) {
            ex.printStackTrace();            
        }        
        return;
    }    
    
    private void updateAllServicesAddrUR() {
        
        if (URAddr == null)
            return;        

        try {
            URL url = new URL(URAddr);
            
            URService.URInterface URservice = 
                new URService.URSOAPBindingStub( url, null );

            String[] newIPS = getLocalHostAddressInfraBased();

            boolean updateRequired = false;
            for (int i=0; !updateRequired && _urInfo.ipsLocalHost!=null && i<_urInfo.ipsLocalHost.length; i++) {
                boolean found = false;

                for (int j=0; !found && newIPS!=null && j<newIPS.length; j++)
                    if (_urInfo.ipsLocalHost[i].equals(newIPS[j]))
                        found = true;
                
                // if found is false, a new address IB has been detected
                // and update is required:
                if (!found)
                    updateRequired = true;                
            }
            for (int i=0; !updateRequired && newIPS != null && i<newIPS.length; i++) {
                boolean found = false;

                for (int j=0; !found && _urInfo.ipsLocalHost!=null && j<_urInfo.ipsLocalHost.length; j++)
                    if (newIPS[i].equals(_urInfo.ipsLocalHost[j]))
                        found = true;
                
                // if found is false, an address registred on UR
                // no longer exists and update is required:
                if (!found)
                    updateRequired = true;                
            }            
            
            if (updateRequired) {
                URservice.updateAllAddresses(_urInfo.ipsLocalHost, newIPS);
                _urInfo.ipsLocalHost = new String[newIPS.length];
                for (int i=0; i<newIPS.length; i++)
                    _urInfo.ipsLocalHost[i] = newIPS[i];
            }
            
        } catch (Exception ex) {
            ex.printStackTrace();            
        }        
        return;
    }       
    
    private RemoteService[] getServicesFromRR(String WAU, boolean AC, boolean localArea) {
        Vector rsVect = new Vector(); // elements are RemoteService
        Vector rreVector = (Vector)RemoteRepository.get(WAU); // elements are RemoteRepositoryEntry
        
        Syslog.debug(this,"ND.getServicesFromRR ("+WAU+"): AC="+AC+" local="+localArea);
        if (rreVector != null) {
            for (int i=0; i<rreVector.size(); i++) {    
                RemoteRepositoryEntry rre = (RemoteRepositoryEntry)rreVector.elementAt(i);
               
                if (rre.localArea == localArea && rre.rs.isAC() == AC) {
		    Syslog.debug(this,"->Found in RR:"+rre.rs.getAddress()+"(local="+rre.localArea+",ac="+rre.rs.isAC()+")");
                    rsVect.add(rre.rs);       
		}
            }
            RemoteService[] rs = new RemoteService[rsVect.size()];
            rsVect.copyInto(rs);
            return rs;                
        } else
            return null;
    }

    private RemoteService[] getServicesFromRR_byInstanceURL(String instanceURL, boolean AC, boolean localArea) {
        Vector rsVect = new Vector(); // elements are RemoteService
        Enumeration rreVectors = RemoteRepository.elements(); // elements are Vector of RemoteRepositoryEntry
        
        Syslog.debug(this,"ND.getServicesFromRR_byInstanceURL ("+instanceURL+"): AC="+AC+" local= "+localArea);
        
        while (rreVectors.hasMoreElements()) {
            Vector rreVector = (Vector)rreVectors.nextElement(); // elements are RemoteRepositoryEntry
                    
            if (rreVector != null) {
                for (int i=0; i<rreVector.size(); i++) {    
                    RemoteRepositoryEntry rre = (RemoteRepositoryEntry)rreVector.elementAt(i);
                    Syslog.debug(this,"->IN RR:"+rre.rs.getAddress()+rre.localArea+rre.rs.isAC());
                    if (rre != null && rre.rs != null && 
			rre.rs.getInstanceURL() != null && 
			rre.rs.getInstanceURL().equals(instanceURL) &&
                        rre.localArea == localArea && rre.rs.isAC() == AC)

                            rsVect.add(rre.rs);       
                }
            }
        }
            
        RemoteService[] rs = new RemoteService[rsVect.size()];
        rsVect.copyInto(rs);
        return rs;                
    }
    
    private RemoteService[] getServicesFromLR_byInstanceURL(String _instanceURL) {
        Vector rsVect = new Vector(); // elements are RemoteService

        Syslog.debug(this,"ND.getServicesFromLR_byinstanceURL ("+_instanceURL+")");
        for (int i=0; i<LocalRepositoryV.size(); i++) {
            LocalRepositoryEntry lre = (LocalRepositoryEntry)LocalRepositoryV.elementAt(i);
                        
            DeployedService ds = CoreBroker.BrokerWrapper.getDeployedService(lre.name);
            String instanceURL = ds.getInstanceURL();
            if (instanceURL!=null && instanceURL.equals(_instanceURL)) {
                String[] eps = getEPLocalService(lre.name);                
  
                RemoteService tmpRS[] = new RemoteService[eps.length];
                for (int j=0; j<tmpRS.length; j++) {
                    tmpRS[j] = new RemoteService();
                    tmpRS[j].setWAU(lre.WAU);
                    tmpRS[j].setAddress( eps[j] );
                    tmpRS[j].setInstanceURL(instanceURL);
                    if (energy[CoreBroker.IFUtils.ACLINE_STATUS] == 1)
                        tmpRS[j].setAC(true);
                    else
                        tmpRS[j].setAC(false);
                    tmpRS[j].setBattery(energy[CoreBroker.IFUtils.BATTERY_PERC]);
                    if (lre.WCU != null) {           
                        WSAMICustomizerDocument dC = CoreBroker.BrokerWrapper.getWCD_DeployedService(lre.name);
                        tmpRS[j].setLCwau(dC.getLocal());
                        tmpRS[j].setRCwau(dC.getRemote());
                        tmpRS[j].setColocation(dC.getColocation());
                    } else {
                        tmpRS[j].setLCwau("");               
                        tmpRS[j].setRCwau("");
                        tmpRS[j].setColocation(false);
                    }
                    rsVect.add(tmpRS[j]);
                }
            }
        }
        RemoteService[] rs = new RemoteService[rsVect.size()];
        rsVect.copyInto(rs);
        return rs;                
    }

    private RemoteService[] getServicesFromLR(String WAU) {
        Vector rsVect = new Vector(); // elements are RemoteService

        Syslog.debug(this,"ND.getServicesFromLR ("+WAU+")");
        for (int i=0; i<LocalRepositoryV.size(); i++) {
            LocalRepositoryEntry lre = (LocalRepositoryEntry)LocalRepositoryV.elementAt(i);
            if ((lre.WAU).equals(WAU)) {
                String[] eps = getEPLocalService(lre.name);
                DeployedService ds = CoreBroker.BrokerWrapper.getDeployedService(lre.name);
                String instanceURL = ds.getInstanceURL();
   
                RemoteService tmpRS[] = new RemoteService[eps.length];
                for (int j=0; j<tmpRS.length; j++) {
                    tmpRS[j] = new RemoteService();
                    tmpRS[j].setWAU(WAU);
                    tmpRS[j].setAddress( eps[j] );
                    tmpRS[j].setInstanceURL(instanceURL);
                    if (energy[CoreBroker.IFUtils.ACLINE_STATUS] == 1)
                        tmpRS[j].setAC(true);
                    else
                        tmpRS[j].setAC(false);
                    tmpRS[j].setBattery(energy[CoreBroker.IFUtils.BATTERY_PERC]);
                    if (lre.WCU != null) {           
                        WSAMICustomizerDocument dC = CoreBroker.BrokerWrapper.getWCD_DeployedService(lre.name);
                        tmpRS[j].setLCwau(dC.getLocal());
                        tmpRS[j].setRCwau(dC.getRemote());
                        tmpRS[j].setColocation(dC.getColocation());
                    } else {
                        tmpRS[j].setLCwau("");               
                        tmpRS[j].setRCwau("");
                        tmpRS[j].setColocation(false);
                    }
                    rsVect.add(tmpRS[j]);
                }
            }
                
        }
        RemoteService[] rs = new RemoteService[rsVect.size()];
        rsVect.copyInto(rs);
        return rs;                
    }
   

    private RemoteService[] getServicesFromFavorites(String WAU)
    {
        // Add by Rafik
        NDService.RemoteService[] rs = null;

        Syslog.debug(this,"Serching :"+WAU);

        Syslog.debug(this,"Searching into Favorites");
        favorites = new Favorites(favoritesFile);
        Iterator favoritesIter = favorites.getFavorite(WAU);
        int length =0;
        if (favoritesIter != null)
            {
            while (favoritesIter.hasNext())
                {
                    length++;
                    favoritesIter.next();
                }
            rs = new NDService.RemoteService[length];
            favoritesIter = favorites.getFavorite(WAU);
            int i=0;
            while (favoritesIter.hasNext())
                {
                    Favorite favorite = (Favorite)favoritesIter.next();
                    if (favorite.getValidate())
                        {
                            rs[i] =  new NDService.RemoteService();
                            rs[i].setWAU(favorite.getWAU());
                            rs[i].setAddress(favorite.getAddress());
                            rs[i].setInstanceURL(favorite.getInstanceURL());
                            rs[i].setLCwau(favorite.getLCwau());
                            rs[i].setRCwau(favorite.getRCwau());
                            rs[i].setColocation(favorite.isColocation());
                        }
                    i++;
                    Syslog.debug(this,"Service found (into Favorite): "+favorite.getAddress());
                }
            }
        Syslog.debug(this,length+" services found into Favorites");
        return rs;
    } 
    

    private String[] getEPLocalService(String serviceName) {
        WSAMIAbstractDocument dA = CoreBroker.BrokerWrapper.getWAD_DeployedService(serviceName);
        WSAMIServiceDocument dS = CoreBroker.BrokerWrapper.getWSD_DeployedService(serviceName);
        String wsdl = dS.getConcrete();   
        String serviceAddr = CoreBroker.BrokerWrapper.getEndPointfromWSDL(wsdl);
        
        /*
         *  added to solve problem of "localhost" in the reference
         *  to the endpoint of the service
         *
         */
        int indexLocalHost = serviceAddr.indexOf("localhost");
        if (indexLocalHost != -1) {
            
	    if (_hostAddresses !=null && _hostAddresses.length > 0) {
                String[] eps = new String[_hostAddresses.length];
                for (int i=0; i<_hostAddresses.length; i++) {
	            String beforeLocalHost = serviceAddr.substring(0,indexLocalHost);
        	    String afterLocalHost = serviceAddr.substring(indexLocalHost+"localhost".length());
                    eps[i] = beforeLocalHost + _hostAddresses[i] + afterLocalHost; 
                }
                return eps;
            } else {
                String eps[] = new String[1];
                String beforeLocalHost = serviceAddr.substring(0,indexLocalHost);
                String afterLocalHost = serviceAddr.substring(indexLocalHost+"localhost".length());
                eps[0] = beforeLocalHost + "localhost" + afterLocalHost;
                
                return eps;
            }     
		
        } else
            return null;
    } 

    private String[] getLocalHostAddressInfraBased() {
        NetworkIFDescr[] nwIFs = CBIFUtils.getNetworkInfo(); 
        Vector nwIFVector = new Vector();

        if (nwIFs != null && nwIFs.length>0) {
            for (int i=0; i<nwIFs.length; i++)
                if (nwIFs[i].mode != CBIFUtils.ADHOC)
                    nwIFVector.add(nwIFs[i].ipAddr);
            String[] ipAddrs = new String[nwIFVector.size()];
            nwIFVector.copyInto(ipAddrs);
            return ipAddrs;
        } else {
	   String[] ipAddrs = CBIFUtils.getLocalHostAddresses();
	   return ipAddrs;
	}
    }
    
    private String[] getEPLocalService_OnlyInfraBased(String serviceName) {
        WSAMIAbstractDocument dA = CoreBroker.BrokerWrapper.getWAD_DeployedService(serviceName);
        WSAMIServiceDocument dS = CoreBroker.BrokerWrapper.getWSD_DeployedService(serviceName);
        String wsdl = dS.getConcrete();   
        String serviceAddr = CoreBroker.BrokerWrapper.getEndPointfromWSDL(wsdl);
        
        /*
         *  added to solve problem of "localhost" in the reference
         *  to the endpoint of the service
         *
         */
        int indexLocalHost = serviceAddr.indexOf("localhost");
        if (indexLocalHost != -1) {
            
            String[] hostAddressesIB = getLocalHostAddressInfraBased();
                
	    if (hostAddressesIB !=null && hostAddressesIB.length > 0) {
                String[] eps = new String[hostAddressesIB.length];
                for (int i=0; i<hostAddressesIB.length; i++) {
	            String beforeLocalHost = serviceAddr.substring(0,indexLocalHost);
        	    String afterLocalHost = serviceAddr.substring(indexLocalHost+"localhost".length());
                    eps[i] = beforeLocalHost + hostAddressesIB[i] + afterLocalHost; 
                }
                return eps;
            } else {
                String eps[] = new String[1];
                String beforeLocalHost = serviceAddr.substring(0,indexLocalHost);
                String afterLocalHost = serviceAddr.substring(indexLocalHost+"localhost".length());
                eps[0] = beforeLocalHost + "localhost" + afterLocalHost;
                
                return eps;
            }     
		
        } else
            return null;
    } 
    
    
    private RemoteService[] callRemoteNDs(String WAU, String instanceURL, boolean AC) {     
        
	
	Object[] ndList = RemoteNDRepository.keySet().toArray();

	if (ndList != null && ndList.length >0 ) {

	    Thread[] resultsThread = new Thread[ndList.length];
	    int nThread = 0;

	    Syslog.debug(this,"ND.callRemoteNDs ("+WAU+"): AC="+AC);

	    TempRemoteServiceInstanceFound.clear();

	    for (int i=0; i<ndList.length; i++) {
		RemoteNDRepositoryEntry ndEntry = (RemoteNDRepositoryEntry)RemoteNDRepository.get(ndList[i]);

		if (ndEntry.AC == AC) {    

		    boolean myHostAddress = false;
		    for (int k=0; k<_hostAddresses.length; k++) {
			try {
			    String hostND= new URL(ndEntry.NDAddr).getHost();
			    if (_hostAddresses[k].equals(hostND))
				myHostAddress = true;
			} catch (Exception ex) {
			    ex.printStackTrace();
			}
		    }

		    if (myHostAddress)
			Syslog.debug(this,"Not Call ND at "+ndEntry.NDAddr+" because it's local. ");
		    else {

			Syslog.debug(this,"Calling ND at "+ndEntry.NDAddr+"(AC ="+ndEntry.AC+") with thread "+nThread+"... ");

			resultsThread[nThread] = getRemoteServices_queryService(WAU, instanceURL, ndEntry.NDAddr);
			resultsThread[nThread].start();                
			nThread++;

		    }
		}


	    }
	    for (int i=0; i<nThread; i++) {
		Syslog.debug(this,"Waiting for thread "+i+" to die for 2000ms...");
		try {
		    resultsThread[i].join(2000);
		} catch (InterruptedException ex) {
		    ex.printStackTrace();
		}
		Syslog.debug(this,"Finished waiting for thread "+i+" to die for 2000ms...");
	    }
	}
        
        if (TempRemoteServiceInstanceFound.size() > 0) {
            RemoteService[] remoteServicesArray = 
                    new RemoteService[TempRemoteServiceInstanceFound.size()];
            


            int index = 0;
            Enumeration enum = TempRemoteServiceInstanceFound.elements();
            while (enum.hasMoreElements()) {
                RemoteService rs = (RemoteService)enum.nextElement();
                
                // add to list of RemoteService for return value of the methdd
                remoteServicesArray[index++] = rs;
             
            }
            
            updateRemoteRepository(remoteServicesArray, true);

            
            return remoteServicesArray;
        } else
            return null;
        
    }    
    
    private RemoteService[] _callRemoteNDs(String WAU, boolean AC) {     
        
        Object[] ndList = RemoteNDRepository.keySet().toArray();
        Thread[] resultsThread = new Thread[ndList.length];
        int nThread = 0;

        Syslog.debug(this,"ND.callRemoteNDs ("+WAU+"): AC="+AC);

        TempRemoteServiceInstanceFound.clear();
        
        for (int i=0; i<ndList.length; i++) {
            RemoteNDRepositoryEntry ndEntry = (RemoteNDRepositoryEntry)RemoteNDRepository.get(ndList[i]);

            if (ndEntry.AC == AC) {    
                
                boolean myHostAddress = false;
                for (int k=0; k<_hostAddresses.length; k++) {
                    try {
                        String hostND= new URL(ndEntry.NDAddr).getHost();
                        if (_hostAddresses[k].equals(hostND))
                            myHostAddress = true;
                    } catch (Exception ex) {
                        ex.printStackTrace();
                    }
                }
                    
                if (myHostAddress)
                    Syslog.debug(this,"Not Call ND at "+ndEntry.NDAddr+" because it's local. ");
                else {
 
                    Syslog.debug(this,"Calling ND at "+ndEntry.NDAddr+"(AC ="+ndEntry.AC+") ... ");

//                    resultsThread[nThread] = getRemoteServices_queryService(WAU, ndEntry.NDAddr);
                    resultsThread[nThread].start();                
                    nThread++;
                    
                }
            }
        
        
        }
        for (int i=0; i<nThread; i++) {
            Syslog.debug(this,"Waiting for thread["+i+"] to die for 2000ms...");
            try {
                resultsThread[i].join(2000);
            } catch (InterruptedException ex) {
                ex.printStackTrace();
            }
            Syslog.debug(this,"Finished waiting for thread["+i+"] to die for 2000ms...");
        }
        
        if (TempRemoteServiceInstanceFound.size() > 0) {
            RemoteService[] remoteServicesArray = 
                    new RemoteService[TempRemoteServiceInstanceFound.size()];
            


            int index = 0;
            Enumeration enum = TempRemoteServiceInstanceFound.elements();
            while (enum.hasMoreElements()) {
                RemoteService rs = (RemoteService)enum.nextElement();
                
                // add to list of RemoteService for return value of the methdd
                remoteServicesArray[index++] = rs;
             
            }
            
            updateRemoteRepository(remoteServicesArray, true);

            
            return remoteServicesArray;
        } else
            return null;
        
    }        
    
    private void updateRemoteRepository(RemoteService[] rs, boolean localArea) {

        if (rs != null) {
            for (int i=0; i<rs.length; i++) {
                RemoteRepositoryEntry rre = new RemoteRepositoryEntry(rs[i].getAddress(), 0);
                rre.rs = rs[i];
                rre.localArea = localArea;
                String WAU = rs[i].getWAU();

                if (RemoteRepository.containsKey(WAU)) {
                  Vector listRS = (Vector)RemoteRepository.get(WAU);
                  if (!listRS.contains(rre)) {
                        Syslog.debug(this,"* RR contains "+WAU+": adding "+rre.serviceEP);
                        listRS.add(rre);
                        RemoteRepository.put(WAU,listRS);
		  } 		  
                } else {
                  Syslog.debug(this,"* RR doesn't contain "+WAU+": adding "+rre.serviceEP);              
                  Vector listRS = new Vector();
                  listRS.add(rre);
                  RemoteRepository.put(WAU,listRS);
                }
		//Syslog.debug(this,"* (RemoteRepository.contains("+WAU+")) : "+(RemoteRepository.contains(WAU)));
		//Vector listRS = (Vector)RemoteRepository.get(WAU);
		//for (int y=0;y<listRS.size(); y++)
		    //Syslog.debug(this,"Entry is " +((RemoteRepositoryEntry)listRS.elementAt(y)).serviceEP);
                
            }
        }
    }

    public Thread getRemoteServices_queryService(String _WAU, String _instanceURL, String _ndAddr) {
        final String ndAddr = _ndAddr;
        final String WAU = _WAU;
        final String instanceURL = _instanceURL;
        
        try {
            Thread resultsThread = new Thread( new Runnable() {
                
                public void run() {
                    
                    NDService.RemoteServices remoteServices = null;
                    
                    try{
                        BrokerWrapper broker = BrokerFactory.getServerInstance();
                        NDService.NDPortType nd = broker.getNDStub(ndAddr);
                        
                        if (WAU != null)
                            remoteServices = nd.queryService(WAU);
                        else
                            remoteServices = nd.queryService_ByInstanceURL(instanceURL);
                    } catch (java.rmi.RemoteException ex) {
                        Syslog.error(this,"Error connecting to "+ndAddr);
                        //ex.printStackTrace();
                    }  catch (Exception ex) {
                        // added to solve problem "No Route to Host"
                        // and exception related to connection problems
                        Syslog.error(this,"Error connecting to "+ndAddr);
                        //ex.printStackTrace();
                    }                                  
                    
                    if (remoteServices != null) {
                        NDService.RemoteService[] svc_remote = remoteServices.getList();
                        
                        if (svc_remote != null) {

                            for (int j=0; j<svc_remote.length; j++) {                                
                                try {                                 
                                    String addrSvc = svc_remote[j].getAddress();    
                                    URL urlSvc = new URL(addrSvc);
                                    URL urlND = new URL(ndAddr);
                                    if (urlSvc.getHost().equals(urlND.getHost()))
                                        TempRemoteServiceInstanceFound.put(svc_remote[j].getAddress(), svc_remote[j]);
                                    else 
                                        Syslog.error(this,"Error: ADDRESS "+addrSvc +"/"+urlSvc.getHost() +"/"+ urlND.getHost() +" not reacheable");
                                } catch (Exception ex) {
                                    ex.printStackTrace();
                                }
                            }
                            
                        }

                    }
                }

            });
            
            return resultsThread;
        } catch (Exception ex) { 
            ex.printStackTrace();    
        } 
        return null;
    }
    
    
    void updateRemoteNDRepositoryACInfo(RemoteService[] remServices) {
        for (int i=0; i<remServices.length; i++) {
            String addrRS = remServices[i].getAddress();
            
            try {
                URL urlAddrRS = new URL(addrRS);
                String hostRS = urlAddrRS.getHost();

                if (RemoteNDRepository.contains(hostRS)) {
                    RemoteNDRepositoryEntry ndEntry = (RemoteNDRepositoryEntry)RemoteNDRepository.get(hostRS);
                    ndEntry.AC = remServices[i].isAC();
                }
            } catch (java.net.MalformedURLException ex) {}                
        }
    }


    public NDService.GetServiceData[] getService(java.lang.String WAU) 
            throws java.rmi.RemoteException
    {
        return getService_common(WAU, null);
    }

    public NDService.GetServiceData[] getAllService(java.lang.String WAU) 
            throws java.rmi.RemoteException
    {
        return getAllService_common(WAU);
    }

    public NDService.GetServiceData[] getService_ByInstanceURL(java.lang.String instanceURL) 
            throws java.rmi.RemoteException
    {
        return getService_common(null, instanceURL);        
    }
 
    
    public NDService.GetServiceData[] getService_common(java.lang.String WAU,String instanceURL) 
            throws java.rmi.RemoteException
    {        
        NDService.GetServiceData[] servicesFound = null;
        
        Syslog.debug(this,"Searching: "+WAU+","+instanceURL);                
        
	String defaultNwType = "InfraBased";
        String nwType = defaultNwType;
        CoreBroker.IFUtils util = new CoreBroker.IFUtils();
        CoreBroker.NetworkIFDescr[] nwifInfo = util.getNetworkInfo();
        for (int i=0; i<nwifInfo.length; i++)
            if (nwifInfo[i] != null) {
                if (!nwifInfo[i].name.equals("lo") 
                    && !nwifInfo[i].name.equals("usbf") ) {
                        
                    if (nwifInfo[i].mode == IFUtils.INFRABASED_WIRED ||
                            nwifInfo[i].mode == IFUtils.INFRABASED)
                        nwType = "InfraBased"; 
                    else
                        nwType ="adhoc";
                }
            }
        
        Syslog.debug(this,", Network type:"+nwType);                

        RemoteService[] rs;
        boolean found = false;
        
        if (nwType != null && nwType.equals("InfraBased")) {
            
            isAdHoc_and_ConnectedToGW = false;
            
            rs = resolveServiceInfraBased(WAU,instanceURL,null);
            if (rs != null && rs.length > 0) {
                
                servicesFound = new NDService.GetServiceData[rs.length];
                
                for (int i=0; i<rs.length; i++) {
                    
                    servicesFound[i] = new NDService.GetServiceData();
                    servicesFound[i].setServiceEP(rs[i].getAddress());
                    servicesFound[i].setInstanceURL(rs[i].getInstanceURL());
                    servicesFound[i].setCustLocalEP("");
                    servicesFound[i].setCustRemoteEP("");                    
                    
                    Syslog.debug(this,"Service found (IB): "+rs[i].getAddress()+" : "
                        +rs[i].getLCwau()+" : "+rs[i].getRCwau()+" . ");
                    
                    if (rs[i].getLCwau() != null && !rs[i].getLCwau().equals("")) {
                        Syslog.debug(this,"search local customizer: "+rs[i].getLCwau());
                        
                        RemoteService[] rsLC = null;
                        if (rs[i].isColocation())
                           rsLC = resolveServiceInfraBased(rs[i].getLCwau(),null,"localhost");
                        else
                           rsLC = resolveServiceInfraBased(rs[i].getLCwau(),null,null);
                            
                        if (rsLC != null && rsLC.length > 0) {
                            for (int j=0; j<rsLC.length; j++) {
                                Syslog.debug(this,"found local customizer at "+rsLC[j].getAddress());
                            }
                            servicesFound[i].setCustLocalEP(rsLC[0].getAddress());
                        }
                    }

                    if (rs[i].getRCwau() != null && !rs[i].getRCwau().equals("")) {                    
                        Syslog.debug(this,"search remote customizer: "+rs[i].getRCwau());

                        RemoteService[] rsRC = null;
                        if (rs[i].isColocation()) {
                            try {
                                URL u = new URL(rs[i].getAddress());
                                String remoteHostIP = u.getHost();                            
                                rsRC = resolveServiceInfraBased(rs[i].getRCwau(), null,remoteHostIP);
                            } catch (Exception ex) {}
                        } else 
                            rsRC = resolveServiceInfraBased(rs[i].getRCwau(),null, null);
                        
                        if (rsRC != null && rsRC.length > 0) {
                            for (int j=0; j<rsRC.length; j++) {
                                Syslog.debug(this,"found remote customizer at "+rsRC[j].getAddress());
                            }
                            servicesFound[i].setCustRemoteEP(rsRC[0].getAddress());
                        }                    
                    }
                }
            }
            
        } else if (nwType != null && nwType.equals("adhoc")) {
            
            rs = resolveServiceAdHoc(WAU,instanceURL, null);
            if (rs != null && rs.length > 0) {
                
                servicesFound = new NDService.GetServiceData[rs.length];
                
                for (int i=0; i<rs.length; i++) {
                    
                    servicesFound[i] = new NDService.GetServiceData();
                    servicesFound[i].setServiceEP(rs[i].getAddress());
                    servicesFound[i].setInstanceURL(rs[i].getInstanceURL());
                    servicesFound[i].setCustLocalEP("");
                    servicesFound[i].setCustRemoteEP("");            
            
                    Syslog.debug(this,"Service found (AH): "+rs[i].getAddress()+" : "
                        +rs[i].getLCwau()+" : "+rs[i].getRCwau()+" . ");

                    if (rs[i].getLCwau() != null && !rs[i].getLCwau().equals("")) {                    
                        Syslog.debug(this,"search local customizer: "+rs[i].getLCwau());

                        RemoteService[] rsLC = null;
                        if (rs[i].isColocation())
                           rsLC = resolveServiceAdHoc(rs[i].getLCwau(),null,"localhost");
                        else
                           rsLC = resolveServiceAdHoc(rs[i].getLCwau(),null,null);
                        
                        if (rsLC != null && rsLC.length > 0) {
                            for (int j=0; j<rsLC.length; j++) {
                                Syslog.debug(this,"found local customizer at "+rsLC[j].getAddress());
                            }
                            servicesFound[i].setCustLocalEP(rsLC[0].getAddress());
                        }
                    }

                    if (rs[i].getRCwau() != null && !rs[i].getRCwau().equals("")) {                    
                        Syslog.debug(this,"search remote customizer: "+rs[i].getRCwau());
                        
                        RemoteService[] rsRC = null;
                        if (rs[i].isColocation()) {
                            try {
                                URL u = new URL(rs[i].getAddress());
                                String remoteHostIP = u.getHost();                            
                                rsRC = resolveServiceAdHoc(rs[i].getRCwau(),null,remoteHostIP);
                            } catch (Exception ex) {}
                        } else 
                            rsRC = resolveServiceAdHoc(rs[i].getRCwau(),null,null);
                                                
                        if (rsRC != null && rsRC.length > 0) {
                            for (int j=0; j<rsRC.length; j++) {
                                Syslog.debug(this,"found remote customizer at "+rsRC[j].getAddress());
                            }
                            servicesFound[i].setCustRemoteEP(rsRC[0].getAddress());                            
                        }                    
                    }
                }
            }
            
        } else 
            Syslog.error(this,"Netwrok type "+nwType+" not supported");
        
        
        return servicesFound;
        
    }

    public NDService.GetServiceData[] getAllService_common(java.lang.String WAU) 
            throws java.rmi.RemoteException
    {        
        NDService.GetServiceData[] servicesFound = null;
        
        Syslog.debug(this,"Searching: "+WAU);                
        
	String defaultNwType = "InfraBased";
        String nwType = defaultNwType;
        CoreBroker.IFUtils util = new CoreBroker.IFUtils();
        CoreBroker.NetworkIFDescr[] nwifInfo = util.getNetworkInfo();
        for (int i=0; i<nwifInfo.length; i++)
            if (nwifInfo[i] != null) {
                
                if (!nwifInfo[i].name.equals("lo") 
                    && !nwifInfo[i].name.equals("usbf") ) {
		
                    if (nwifInfo[i].mode == IFUtils.INFRABASED_WIRED ||
                            nwifInfo[i].mode == IFUtils.INFRABASED)
                        nwType = "InfraBased"; 
                    else
                        nwType ="adhoc";
                }
            }
        
        Syslog.debug(this,", Network type:"+nwType);                

        RemoteService[] rs;
        boolean found = false;
        
        if (nwType != null && nwType.equals("InfraBased")) {
            
            isAdHoc_and_ConnectedToGW = false;
            
            rs = resolveAllServiceInfraBased(WAU);

            if (rs != null && rs.length > 0) {
              
                servicesFound = new NDService.GetServiceData[rs.length];
                
                for (int i=0; i<rs.length; i++) { 
                    servicesFound[i] = new NDService.GetServiceData();
                    servicesFound[i].setServiceEP(rs[i].getAddress());
                    servicesFound[i].setInstanceURL(rs[i].getInstanceURL());
                    servicesFound[i].setCustLocalEP("");
                    servicesFound[i].setCustRemoteEP("");                    
                    
                    Syslog.debug(this,"Service found (IB): "+rs[i].getAddress()+" : "
                        +rs[i].getLCwau()+" : "+rs[i].getRCwau()+" . ");
		}
	     }
        } else if (nwType != null && nwType.equals("adhoc")) {
            
	    /*
	     * at current stage, for getAllService
	     * adhoc or infrabased doesn't matter because
	     * resolveAllServiceInfraBased does not
	     * query the UR for services
	     */
            rs = resolveAllServiceInfraBased(WAU);
            if (rs != null && rs.length > 0) {
                
                servicesFound = new NDService.GetServiceData[rs.length];
                
                for (int i=0; i<rs.length; i++) {
                    
                    servicesFound[i] = new NDService.GetServiceData();
                    servicesFound[i].setServiceEP(rs[i].getAddress());
                    servicesFound[i].setInstanceURL(rs[i].getInstanceURL());
                    servicesFound[i].setCustLocalEP("");
                    servicesFound[i].setCustRemoteEP("");                    
                    
                    Syslog.debug(this,"Service found (IB): "+rs[i].getAddress()+" : "
                        +rs[i].getLCwau()+" : "+rs[i].getRCwau()+" . ");
		}
	     }
            
        } else 
            Syslog.error(this,"nwtype "+nwType+" not supported");
        
 
        
        return servicesFound;
        
    }


    private RemoteService[] resolveService_colocationFilter(RemoteService[] rs, String colocation_IPAddress) {        
        Vector validRS = new Vector();
        if (rs != null) {
            for (int i=0; i<rs.length; i++){
                try {
                    URL u = new URL(rs[i].getAddress());
                    String rsIP = u.getHost();                            
                    if (IFUtils.isSameHost(colocation_IPAddress, rsIP))
                        validRS.add(rs[i]);                
                } catch (Exception ex) {}
            }
        }
         RemoteService[] validRSArray = new RemoteService[validRS.size()];
         validRS.copyInto(validRSArray);
        return validRSArray;
    }
    
    private RemoteService[] _resolveServiceInfraBased(String WAU, String colocation_IPAddress) {
        RemoteService[] rs;
        boolean found = false;
        
        /* I1 */            
        rs = getServicesFromLR(WAU); 
        if (colocation_IPAddress != null)
            rs = resolveService_colocationFilter(rs, colocation_IPAddress);        
        
        if (rs == null || rs.length == 0) {

            /* I1: look for services in RR that have AC=true and localArea=true */            
            rs = getServicesFromRR(WAU,true,true);

            if (colocation_IPAddress != null)
                rs = resolveService_colocationFilter(rs, colocation_IPAddress);
            if (rs == null || rs.length ==0) {
                
                /* I1: look for services in NDs in local Area RR that have AC=true */
                rs = _callRemoteNDs(WAU, true);
                if (colocation_IPAddress != null)
                    rs = resolveService_colocationFilter(rs, colocation_IPAddress);

                if (rs != null && rs.length > 0) 
                    found = true;
            } else
                found = true;
        } else 
            found = true;


        /* I2 */
        if (!found) {
            rs = getServicesFromRR(WAU,true, false);            
            if (colocation_IPAddress != null)
                rs = resolveService_colocationFilter(rs, colocation_IPAddress);
            
            if (rs != null && rs.length > 0) 
                found = true;
            
            rs = getServicesFromRR(WAU,false, false);
          
  
            if (colocation_IPAddress != null)
                rs = resolveService_colocationFilter(rs, colocation_IPAddress);            
            if (rs != null && rs.length > 0) 
                found = true;            
        }

        /* I3 */     
        if (!found) {                
            rs = getServicesFromRR(WAU,false, true);
            if (colocation_IPAddress != null)
                rs = resolveService_colocationFilter(rs, colocation_IPAddress);
            
            if (rs == null || rs.length ==0) {
                rs = _callRemoteNDs(WAU, false);
                if (colocation_IPAddress != null)
                    rs = resolveService_colocationFilter(rs, colocation_IPAddress);                
                if (rs != null && rs.length > 0) 
                    found = true;                
            } else
                found =true;
        }

        /* I4 */
        if (found) {   
            Syslog.debug(this,"Found "+rs.length+" services");
            return rs;
        } else {
            RemoteService[] rsUR = getServicesFromUR(WAU,null);            
            if (colocation_IPAddress != null)
                rsUR = resolveService_colocationFilter(rsUR, colocation_IPAddress);
            if (rsUR != null)
                Syslog.debug(this,"Found "+rsUR.length+" services");

            return rsUR;            
        }
    }
    

    private RemoteService[] resolveServiceInfraBased(String WAU, String instanceURL, String colocation_IPAddress) {
        RemoteService[] rs;
        boolean found = false;
        
        /* I1 */            
        if (instanceURL != null)
            rs = getServicesFromLR_byInstanceURL(instanceURL); 
        else
            rs = getServicesFromLR(WAU);         
        if (colocation_IPAddress != null)
            rs = resolveService_colocationFilter(rs, colocation_IPAddress);        
        
        if (rs == null || rs.length == 0) {

            /* I1: look for services in RR that have AC=true and localArea=true */            
            if (instanceURL != null)
                rs = getServicesFromRR_byInstanceURL(instanceURL,true,true); 
            else            
                rs = getServicesFromRR(WAU,true,true);

            if (colocation_IPAddress != null)
                rs = resolveService_colocationFilter(rs, colocation_IPAddress);
            if (rs == null || rs.length ==0) {
                
                /* I1: look for services in NDs in local Area RR that have AC=true */
                rs = callRemoteNDs(WAU, instanceURL, true);
                if (colocation_IPAddress != null)
                    rs = resolveService_colocationFilter(rs, colocation_IPAddress);

                if (rs != null && rs.length > 0) 
                    found = true;
            } else
                found = true;
        } else 
            found = true;


        /* I2 */
	
	/* FAVORITES */
 	if (!found) {
            if (instanceURL != null)
                rs = getServicesFromRR_byInstanceURL(instanceURL,true,false);
            else
                rs = getServicesFromFavorites(WAU);
            if (colocation_IPAddress != null)
                rs = resolveService_colocationFilter(rs, colocation_IPAddress);

            if (rs != null && rs.length > 0)
                found = true;
       }

        if (!found) {
            if (instanceURL != null)
                rs = getServicesFromRR_byInstanceURL(instanceURL,true,false); 
            else             
                rs = getServicesFromRR(WAU,true, false);            
            if (colocation_IPAddress != null)
                rs = resolveService_colocationFilter(rs, colocation_IPAddress);
            
            if (rs != null && rs.length > 0) 
                found = true;
            
            if (instanceURL != null)
                rs = getServicesFromRR_byInstanceURL(instanceURL,false,false); 
            else 
                rs = getServicesFromRR(WAU,false, false);  
            if (colocation_IPAddress != null)
                rs = resolveService_colocationFilter(rs, colocation_IPAddress);            
            
            if (rs != null && rs.length > 0) 
                found = true;            
        }

        /* I3 */     
        if (!found) {                
            if (instanceURL != null)
                rs = getServicesFromRR_byInstanceURL(instanceURL,false,true); 
            else             
                rs = getServicesFromRR(WAU,false, true);
            if (colocation_IPAddress != null)
                rs = resolveService_colocationFilter(rs, colocation_IPAddress);
            
            if (rs == null || rs.length ==0) {
                rs = callRemoteNDs(WAU, instanceURL, false);
                if (colocation_IPAddress != null)
                    rs = resolveService_colocationFilter(rs, colocation_IPAddress);                
                if (rs != null && rs.length > 0) 
                    found = true;                
            } else
                found =true;
        }

        /* I4 */
        if (found) {   
            Syslog.debug(this,"Found "+rs.length+" services");
            return rs;
        } else {
            RemoteService[] rsUR = getServicesFromUR(WAU, instanceURL);            
            if (colocation_IPAddress != null)
                rsUR = resolveService_colocationFilter(rsUR, colocation_IPAddress);
            if (rsUR != null)
                Syslog.debug(this,"Found "+rsUR.length+" services");

            return rsUR;            
        }
    }
  private RemoteService[] resolveAllServiceInfraBased(String WAU) {
        RemoteService[][] rs_tmp = new RemoteService[8][];
	RemoteService[] rs;
	Vector rsVect = new Vector();
        boolean found = false;
        
        /* I1 */            
        rs_tmp[0] = getServicesFromLR(WAU);         
      
        /* I1: look for services in RR that have AC=true and localArea=true */ 
        rs_tmp[1] = getServicesFromRR(WAU,true,true);

        /* I1: look for services in NDs in local Area RR that have AC=true */
        rs_tmp[2] = callRemoteNDs(WAU, null, true);

        /* I2 */
        rs_tmp[3] = getServicesFromRR(WAU,true, false);            
        rs_tmp[4] = getServicesFromRR(WAU,false, false);  

        /* I3 */     
        rs_tmp[5] = getServicesFromRR(WAU,false, true);
        rs_tmp[6] = callRemoteNDs(WAU, null, false);


        /* Temporary modification: 
	   the services are retrieved also in UR
	   only to build the biggest group of nodes
	   but after the end of the development and
	   test of group service, the services on the UR
	   must not be used
	found = true;

	for (int i=0; i<rs_tmp.length; i++)
	    if (rs_tmp[i] != null)
		for (int j=0; j<rs_tmp[i].length; j++)
		    if (!rsVect.contains(rs_tmp[i][j]))
			rsVect.add(rs_tmp[i][j]);

	rs = new RemoteService[rsVect.size()];
	rsVect.copyInto(rs);

        if (found) {   
            Syslog.debug(this,"Found "+rs.length+" services");
            return rs;
        } else {
            RemoteService[] rsUR = getServicesFromUR(WAU, null);           
            if (rsUR != null)
                Syslog.debug(this,"Found "+rsUR.length+" services");

            return rsUR;            
        }
	*/

	rs_tmp[7] = getServicesFromUR(WAU, null); 

	found = true;

	for (int i=0; i<rs_tmp.length; i++)
	    if (rs_tmp[i] != null)
		for (int j=0; j<rs_tmp[i].length; j++) {
		    boolean contains = false;
		    for (int k=0; !contains && k<rsVect.size(); k++) {
			if (((RemoteService)rsVect.elementAt(k)).getAddress().equals(rs_tmp[i][j].getAddress()))
			    contains = true;
		    }
		    if (!contains)
			rsVect.add(rs_tmp[i][j]);
		}

	rs = new RemoteService[rsVect.size()];
	rsVect.copyInto(rs);
	Syslog.debug(this,"Found "+rs.length+" services");
	return rs;
	
    }
       
    
    private RemoteService[] resolveServiceAdHoc_withoutGW(String WAU, String instanceURL, String colocation_IPAddress) {
        RemoteService[] rs;
        boolean found = false;

        
        /* A1 */            
        if (instanceURL != null)
            rs = getServicesFromLR_byInstanceURL(instanceURL); 
        else        
            rs = getServicesFromLR(WAU);         
        if (colocation_IPAddress != null)
                rs = resolveService_colocationFilter(rs, colocation_IPAddress);            
        
        if (rs == null || rs.length == 0) { 
            
            /* A1: look for services in RR that have AC=true and localArea=true*/
            if (instanceURL != null)
                rs = getServicesFromRR_byInstanceURL(instanceURL,true,true); 
            else            
                rs = getServicesFromRR(WAU,true,true);                       
            if (colocation_IPAddress != null)
                rs = resolveService_colocationFilter(rs, colocation_IPAddress);            
            
            if (rs == null || rs.length ==0) {
                rs = callRemoteNDs(WAU, instanceURL, true);
                if (colocation_IPAddress != null)
                    rs = resolveService_colocationFilter(rs, colocation_IPAddress);
                
                if (rs != null && rs.length > 0) 
                    found = true;
            } else
                found =true;
        } else
            found =true;
        
        /* A2 */
        if (!found) {
            if (instanceURL != null)
                rs = getServicesFromRR_byInstanceURL(instanceURL,false,true); 
            else                        
                rs = getServicesFromRR(WAU,false, true);
            if (colocation_IPAddress != null)
                rs = resolveService_colocationFilter(rs, colocation_IPAddress);
            
            if (rs == null || rs.length ==0) {
                rs = callRemoteNDs(WAU, instanceURL, false);
                if (colocation_IPAddress != null)
                    rs = resolveService_colocationFilter(rs, colocation_IPAddress);
                
                if (rs != null && rs.length > 0) 
                    found = true;
            } else
                found =true;            
        }
        
        return rs;
    }
    



    private RemoteService[] resolveServiceAdHoc(String WAU, String instanceURL, String colocation_IPAddress) {
        RemoteService[] rs;
        boolean found = false;

        rs = resolveServiceAdHoc_withoutGW(WAU, instanceURL, colocation_IPAddress);
        if (colocation_IPAddress != null)
            rs = resolveService_colocationFilter(rs, colocation_IPAddress);
        
        if (rs != null && rs.length > 0) 
            found = true;
            
        
        /* A3 */
        /* looking for a GW service and do I2 and I4 */
        if (found) {
            Syslog.debug(this,"Found "+rs.length+" services");            
            return rs;
        } else {
            if (!isAdHoc_and_ConnectedToGW) {            
Syslog.debug(this,"isAdHoc_and_ConnectedToGW FALSE");
                String gw = resolveServiceAdHoc_findGW();
                if (gw != null) {
                    CoreBroker.IFUtils util = new CoreBroker.IFUtils();
                    int ret = util.IProute(gw);                
                    if (ret != -1)
                        isAdHoc_and_ConnectedToGW = true;
                }
            }
            
            if (isAdHoc_and_ConnectedToGW) {
Syslog.debug(this,"isAdHoc_and_ConnectedToGW TRUE");                
                    RemoteService[] rsUR = getServicesFromUR(WAU,instanceURL);            
                    
                    if (colocation_IPAddress != null)
                        rsUR = resolveService_colocationFilter(rsUR, colocation_IPAddress);
                    
                    if (rsUR != null)
                        Syslog.debug(this,"Found "+rsUR.length+" services");
                    return rsUR;            
                    
                    /*
                    String ep = getServiceEPfromUR(WAU);
                    if (ep != null && !ep.equals("")) {
                        RemoteService[] rsUR = new RemoteService[1];
                        rsUR[0] = new RemoteService();
                        rsUR[0].setAddress(ep);
                        rsUR[0].setLCwau("");               
                        rsUR[0].setRCwau(""); 
                        return rsUR;            
                    } else
                        return null;
                     */                
            } else
                return null;

        }
    }
    
        
    public Thread slp_registration() {
        
        Thread resultsThread = new Thread( new Runnable() {                
            public void run() {

                String hostname = null;

                java.util.Properties p = new java.util.Properties();
                p.put("net.slp.traceDATraffic", "true");
                p.put("net.slp.traceMsg", "true");
                p.put("net.slp.traceDrop", "true");
                p.put("net.slp.traceReg", "true"); 
                p.put("net.slp.isBroadcastOnly","true");

                Advertiser adv = null;

                try {
                    ServiceLocationManager.init(p);
                    adv = ServiceLocationManager.getAdvertiser(java.util.Locale.getDefault());
                } catch( Exception ex ) { 
                } 

                if( adv == null ) {
                }

                
               
                int slpState = SLPSTATE_SLP_NOTRUNNING;
                _hostAddresses = CBIFUtils.getLocalHostAddresses(); 
                
                // oldHostAddresses contains the latest IP addresses
                // written into slp.conf and used to start the currently
                // running instance of slp server
                String[] oldHostAddresses = new String[_hostAddresses.length];
                for (int i=0; i<_hostAddresses.length; i++) {
                    oldHostAddresses[i] = _hostAddresses[i]; 
                }
                
                SLPMgr.writeSLPConfFile(SLPCONFFILE, _hostAddresses);
                sendSLPEvent(SLPEVENT_WAITING_STARTSLP);
                
                while (do_slp_registration) {

                    boolean oldACStatus = _ACStatus;
                    energy = CBIFUtils.getEnergyInfo();                            
                    if (energy[CoreBroker.IFUtils.ACLINE_STATUS] == 1)
                        _ACStatus = true;
                    else
                        _ACStatus = false;
                    
                    
                    int event = receiveSLPEvent();
                    
                    if (slpState == SLPSTATE_SLP_NOTRUNNING) { 
                        if (event == SLPEVENT_SLP_STARTED) {  

                            /*
                             *  here add attributes for ND service
                             */
                            Vector attributes = new Vector(0);                 
                            Vector v1 = new Vector(1);

                            if (_ACStatus)
                                v1.add(new Boolean("True"));
                            else
                                v1.add(new Boolean("False"));
                            ServiceLocationAttribute sla1 = new ServiceLocationAttribute("ac",v1);
                            attributes.add(sla1);

                            try {
                                for (int i=0; i<oldHostAddresses.length; i++) {
                                    String serviceURL = "service:ND:http://"+oldHostAddresses[i]+":8080/services/ND";
                                    ServiceURL ndURL = new ServiceURL( serviceURL, ServiceURL.LIFETIME_MAXIMUM);
                                    Syslog.info(this,"Registering on SLP: "+serviceURL+" with ac="+_ACStatus);            
                                    adv.register(ndURL, attributes);
                                }
                                
                                sendSLPEvent(SLPEVENT_ND_REGISTRED);        
                                slpState = SLPSTATE_SLP_RUNNING;
                                
                                
                            } catch (Exception ex) {
                                //ex.printStackTrace();
                                Syslog.warning(this,"Cannot connect to slpd server on localhost. Starting slpd...");
                                sendSLPEvent(SLPEVENT_WAITING_STARTSLP);
                            }
                            
                            
                            
                        } else {
                            _hostAddresses = CBIFUtils.getLocalHostAddresses();
                        }
                        
                    } else { //if (slpState == SLPSTATE_SLP_RUNNING) { 
                        oldHostAddresses = new String[_hostAddresses.length];
                        for (int i=0; i<_hostAddresses.length; i++) {
                            oldHostAddresses[i] = _hostAddresses[i]; 
                        }
                        _hostAddresses = CBIFUtils.getLocalHostAddresses(); 
                        
                        boolean modified = false;
                        
                        for (int i=0; !modified && i<_hostAddresses.length; i++) {
                            boolean found = false;
                            for (int j=0; !found && j<oldHostAddresses.length; j++)
                                if (_hostAddresses[i].equals(oldHostAddresses[j]))
                                    found = true;
                            if (!found) 
                                modified = true;
                        }
                        for (int i=0; !modified && i<oldHostAddresses.length; i++) {
                            boolean found = false;
                                
                            for (int j=0; !found && j<_hostAddresses.length; j++)
                                if (oldHostAddresses[i].equals(_hostAddresses[j]))
                                    found = true;
                            if (!found)
                                modified = true;
                        }
                        
                        if (modified) {
                            oldHostAddresses = new String[_hostAddresses.length];
                            for (int i=0; i<_hostAddresses.length; i++) {
                                oldHostAddresses[i] = _hostAddresses[i]; 
                            }                             
                            
                            SLPMgr.writeSLPConfFile(SLPCONFFILE, oldHostAddresses);
                            sendSLPEvent(SLPEVENT_WAITING_STARTSLP); 
                            
                            slpState = SLPSTATE_SLP_NOTRUNNING;
                            
                            updateAllServicesAddrUR();
                            
                        } else if (_ACStatus != oldACStatus) {
                           /*
                             *  here add attributes for ND service
                             */
                            Vector attributes = new Vector(0);                 
                            Vector v1 = new Vector(1);

                            if (_ACStatus)
                                v1.add(new Boolean("True"));
                            else
                                v1.add(new Boolean("False"));
                            ServiceLocationAttribute sla1 = new ServiceLocationAttribute("ac",v1);
                            attributes.add(sla1);

                            try {
                                
                                for (int i=0; i<oldHostAddresses.length; i++) {
                                    String serviceURL = "service:ND:http://"+oldHostAddresses[i]+":8080/services/ND";
                                    ServiceURL ndURL = new ServiceURL( serviceURL, ServiceURL.LIFETIME_MAXIMUM);
                                    Syslog.info(this,"unRegistering on SLP: "+serviceURL+" with ac="+oldACStatus);            
                                    adv.deregister(ndURL);
                                }                                
                                
                                for (int i=0; i<oldHostAddresses.length; i++) {
                                    String serviceURL = "service:ND:http://"+oldHostAddresses[i]+":8080/services/ND";
                                    ServiceURL ndURL = new ServiceURL( serviceURL, ServiceURL.LIFETIME_MAXIMUM);
                                    Syslog.info(this,"Registering on SLP: "+serviceURL+" with ac="+_ACStatus);            
                                    adv.register(ndURL, attributes);
                                }
                            } catch (Exception ex) {
                                //ex.printStackTrace();
                                Syslog.warning(this,"Cannot connect to slpd server on localhost. Starting slpd...");
                                slpState = SLPSTATE_SLP_NOTRUNNING;
                                sendSLPEvent(SLPEVENT_WAITING_STARTSLP);                                
                            }
              
                        }
                        
                    }
                    
                    try {
                        Thread.sleep(5000); 
                    } catch (Exception ex) {
                        ex.printStackTrace();
                    }                        
                }
            }
        });
        return resultsThread;
    }

    
    
    public void register(java.lang.String name,java.lang.String WAU, java.lang.String WSU, java.lang.String WCU) 
            throws java.rmi.RemoteException {
                
        if (BrokerWrapper.isServiceDeployed(name)) {
            LocalRepositoryV.add(new LocalRepositoryEntry(name,WAU,WSU,WCU));
            Syslog.info(this,"Register: (Local Repository size = "+LocalRepositoryV.size()+")"+
                        "\nwau="+WAU+" wsu="+WSU+" wcu="+WCU);        
            
            if (WAU.equals(GWServiceWAU))
                SLPMulticatEnabled = true;
            
            DeployedService ds = CoreBroker.BrokerWrapper.getDeployedService(name);
            String instanceURL = ds.getInstanceURL();            
            registerServiceUR(name, WAU, instanceURL);
            
        } else {                    
            throw new java.rmi.RemoteException("\nNot Registered: name="+name+"wau="+WAU+" wsu="+WSU+
                    " wcu="+WCU+"\nLocal Repository size = "+LocalRepositoryV.size());
        } 
    }

    public java.lang.String unRegister(java.lang.String serviceName) 
            throws java.rmi.RemoteException {
                
        boolean found = false;
                
        int foundPos = -1;
        for (int i=0; !found && i<LocalRepositoryV.size(); i++) {
            LocalRepositoryEntry entry = (LocalRepositoryEntry)LocalRepositoryV.elementAt(i);
            if (entry.name.equals(serviceName)) {
                foundPos = i;
                found = true;
                String WAU = entry.WAU;
                Syslog.info(this,"unregistering... "+WAU+" "+ serviceName);              
                unRegisterServiceFromUR(WAU, serviceName);
            
                LocalRepositoryV.removeElementAt(foundPos);
            
                Syslog.info(this,"unRegister: (Local Repository size = "
                    +LocalRepositoryV.size()+")"+" service name="+serviceName);
                return "OK";    // to remove and modify with a void return in 
                            // method definition
            }
        } 
        
        if (!found) {
            throw new java.rmi.RemoteException("Not UnRegistered:\nservice name="+serviceName+
                    "\nLocal Repository size = "+LocalRepositoryV.size()+
                    "The service was not registred");
        }
        
        return null;
    }    

    public NDService.RemoteServices queryService_ByInstanceURL(java.lang.String instanceURLquery) 
            throws java.rmi.RemoteException 
    {        
        RemoteService[] rs = getServicesFromLR_byInstanceURL(instanceURLquery);
        RemoteServices returnValue = new RemoteServices();

        if (rs == null)
            rs = new RemoteService[0];
            
        returnValue.setList(rs);            
        return returnValue;
    }

    public NDService.RemoteServices queryService(java.lang.String WAUquery) 
            throws java.rmi.RemoteException {       

        RemoteService[] rs = getServicesFromLR(WAUquery);
        RemoteServices returnValue = new RemoteServices();

        if (rs == null)
            rs = new RemoteService[0];
            
        returnValue.setList(rs);            
        return returnValue;
    }


    public Thread slp_lookup() {
        try {
            
            Thread resultsThread = new Thread( new Runnable() {
                public void run() {
                    try {              
                        Locator loc = ServiceLocationManager.getLocator(java.util.Locale.getDefault());    
                        String queryTrue = "(&(ac=true))";
                        String queryFalse = "(&(ac=false))";
                        Vector scopes = ServiceLocationManager.findScopes();
                        while (do_slp_lookup) {
                            try {
                                ServiceURL[] serviceURLs = 
                                    slp_lookup_find(loc, scopes, queryTrue);
                                        
                                if (serviceURLs != null) {
                                    for (int i=0; i<serviceURLs.length; i++) {

                                        ServiceURL url = serviceURLs[i];
                                        String addr = "http://"+url.getHost()+":"+url.getPort()+url.getURLPath();                                    
                                        RemoteNDRepositoryEntry ndEntry;

                                        ndEntry= new RemoteNDRepositoryEntry(addr, null, true);

                                        if (RemoteNDRepository.put(addr, ndEntry) != null)
                                            Syslog.info(this,"Found ND Service at address "+addr+" with AC=true");

                                    }
                                }
                                
                                serviceURLs = slp_lookup_find(loc, scopes, queryFalse);
                                if (serviceURLs != null) {

                                    for (int i=0; i<serviceURLs.length; i++) {
                                        ServiceURL url = serviceURLs[i];
                                        String addr = "http://"+url.getHost()+":"+url.getPort()+url.getURLPath();                                    
                                        RemoteNDRepositoryEntry ndEntry;

                                        ndEntry= new RemoteNDRepositoryEntry(addr, null, false);

                                        if (RemoteNDRepository.put(addr, ndEntry) != null)
                                            Syslog.info(this,"Found ND Service at address "+addr+" with AC=false");

                                    }
                                }                                
                                                                 
                                Thread.sleep(15000);
                                
                            } catch (Exception ex) {
                                ex.printStackTrace();
                              /*
                               *    here add code to solve the problem
                               *    that probably is due to IP address change
                               */
                                CoreBroker.IFUtils util = new CoreBroker.IFUtils();
                                String[] hostAddrs = util.getLocalHostAddresses();
                                for (int i=0; i<hostAddrs.length; i++)
                                    Syslog.warning(this,"SLP exception: new address is "+hostAddrs[i]);
                                Thread.sleep(30000);                                                                
                            }
                        }
                        
                    } catch (Exception ex) {
                        ex.printStackTrace();
                    }
 
                }
            });
            
            return resultsThread;
         } catch (Exception ex) { 
            ex.printStackTrace();    
         } 
         return null;
    }    


    
    private ServiceURL[] slp_lookup_find(Locator loc, Vector scopes, String query) {    
        
        ServiceURL[] serviceURLs;
        
        if (SLPMulticatEnabled) {
            ServiceType st  = new ServiceType("service:ND");
            serviceURLs = SLPFindServices.find(st,scopes,query);
        } else {             
            try {
                ServiceLocationEnumeration urls =
                    loc.findServices(new ServiceType("service:ND"),scopes,query);

                Vector vectServiceURL = new Vector();
                while (urls.hasMoreElements()) {
                    ServiceURL url = (ServiceURL)urls.next();
                    vectServiceURL.add(url);
                }
                serviceURLs = new ServiceURL[vectServiceURL.size()];
                vectServiceURL.copyInto(serviceURLs);
            } catch (com.solers.slp.ServiceLocationException ex) {
                //ex.printStackTrace();
                Syslog.warning(this,"SLP Error: Could not send message");
                return null;
            }
        }
        return serviceURLs;
    }

 
    
    private Thread create_Echo_Server() {
        try {

            Thread resultsThread = new Thread( new Runnable() {
                public void run() {
                    try {                  
                        int size = 256;

                        DatagramSocket sd = null;
                        DatagramPacket packet = null;

                        try {
                            // create a datagram socket
                            sd = new DatagramSocket(8081);
                            // print the chosen port number
                            Syslog.debug(this,"Server waiting on port: "+sd.getLocalPort());

                            for (;;) {
                                // create a datagram packet to receive message in
                                byte[] buffer = new byte[size];
                                packet = new DatagramPacket(buffer, size);

                                // wait for message from client
                                sd.receive(packet);

                                // extract information from datagram packet
                                byte[] data = packet.getData();
                                int port = packet.getPort();
                                int length = packet.getLength();
                                InetAddress address = packet.getAddress();

                                // print information to standard output
                                String msg = new String(buffer);
                                Syslog.debug(this,"from "+address+":"+port+": "+msg);

                                // create a datagram packet to send message in
                                packet = new DatagramPacket(buffer, length, address, port);

                                // send the message back to the client
                                sd.send(packet);
                            }

                        } catch (SocketException e) {
                            // Something went wrong with the socket connection
                            Syslog.debug(this,e.toString());

                        } catch (IOException e) {
                            // Something went wrong on receive
                            Syslog.debug(this,e.toString());
                        }  
                    } catch (Exception ex) {
                        ex.printStackTrace();
                    }
                }
            });
             return resultsThread;
             
        }catch (Exception ex) {
                        ex.printStackTrace();
                    }
        return null;
    }


    private String resolveServiceAdHoc_findGW() {
        
        try {            
                        
            RemoteService[] rs = resolveServiceAdHoc_withoutGW(GWServiceWAU,null,null);
            if (rs != null && rs.length > 0) {
                
                URL url = new URL(rs[0].getAddress());
                
                GWService.GWInterface GWservice = 
                    new GWService.GWSOAPBindingStub( url, null );

                String gwAddr = GWservice.getGWIPAddr();
                Syslog.info(this,"The gw addr is "+gwAddr);
                return gwAddr;
                
            } else
                return null;

        } catch (Exception ex) {
            ex.printStackTrace();            
        }        
        return null;        
    }
    

    private int receiveSLPEvent() {
        try {
            FileInputStream fis = new FileInputStream(SLPEVENTFILE);
            int event = fis.read();
            event-=48; //48 is the char of '0'
            fis.close();
            //Syslog.debug(this,"get SLP event : "+ event);
            return event;
        } catch (FileNotFoundException ex) {            
            String configSLPEVENTFILE = null;          
            if (System.getProperty("catalina.home") != null) 
                configSLPEVENTFILE = System.getProperty("catalina.home")+"/webapps/wsami/WEB-INF/web.xml";
            else if (System.getProperty("jetty.home") != null) 
                configSLPEVENTFILE = System.getProperty("jetty.home")+"/wsami/WEB-INF/web.xml";
            
            Syslog.error(this,"File "+SLPEVENTFILE+" not found: please set the right value in "+configSLPEVENTFILE);
        } catch (IOException ex) {
            String configSLPEVENTFILE = null;          
            if (System.getProperty("catalina.home") != null) 
                configSLPEVENTFILE = System.getProperty("catalina.home")+"/webapps/wsami/WEB-INF/web.xml";
            else if (System.getProperty("jetty.home") != null) 
                configSLPEVENTFILE = System.getProperty("jetty.home")+"/wsami/WEB-INF/web.xml";
            
            Syslog.error(this,"File "+SLPEVENTFILE+" not found: please set the right value in "+configSLPEVENTFILE);
        }         
        return -1;
    }

    private void sendSLPEvent(int event) {
        try {
            FileOutputStream fos = new FileOutputStream(SLPEVENTFILE);
            //Syslog.debug(this,"send SLP event : "+ event);            
            event +=48; //48 is the char of '0'
            fos.write(event);
            fos.close();
        } catch (FileNotFoundException ex) {
            String configSLPEVENTFILE = null;          
            if (System.getProperty("catalina.home") != null) 
                configSLPEVENTFILE = System.getProperty("catalina.home")+"/webapps/wsami/WEB-INF/web.xml";
            else if (System.getProperty("jetty.home") != null) 
                configSLPEVENTFILE = System.getProperty("jetty.home")+"/wsami/WEB-INF/web.xml";
            
            Syslog.error(this,"File "+SLPEVENTFILE+" not found: please set the right value in "+configSLPEVENTFILE);
        } catch (IOException ex) {
            String configSLPEVENTFILE = null;          
            if (System.getProperty("catalina.home") != null) 
                configSLPEVENTFILE = System.getProperty("catalina.home")+"/webapps/wsami/WEB-INF/web.xml";
            else if (System.getProperty("jetty.home") != null) 
                configSLPEVENTFILE = System.getProperty("jetty.home")+"/wsami/WEB-INF/web.xml";
            
            Syslog.error(this,"File "+SLPEVENTFILE+" not found: please set the right value in "+configSLPEVENTFILE);
        }         
    }
    
    
}
