#include <jni.h>
#include "NDService_SLPFindServices.h"
#include <slp.h>
#include <libslp.h>
#include <slptool.h>


JNIEnv * envJNI;
jobjectArray serviceURLs;
int indexServiceURLs;


SLPBoolean mySLPSrvURLCallback( SLPHandle hslp, 
                             const char* srvurl, 
                             unsigned short lifetime, 
                             SLPError errcode, 
                             void* cookie ) 
{
    jclass clazzServiceURL = (*envJNI)->FindClass(envJNI,"com/solers/slp/ServiceURL");
    jmethodID mid = (*envJNI)->GetMethodID(envJNI, clazzServiceURL, "<init>", "(Ljava/lang/String;I)V");

    if(errcode == SLP_OK)
    {
        jstring jurl = (*envJNI)->NewStringUTF(envJNI, srvurl);
        jint jlifetime = lifetime;
        jobject objServiceURL = (*envJNI)->NewObject(envJNI, clazzServiceURL, mid, jurl, jlifetime);
        
//        printf("%s,%i\n",srvurl,lifetime);

        (*envJNI)->SetObjectArrayElement(envJNI, serviceURLs,indexServiceURLs++, objServiceURL);
        (*envJNI)->ReleaseStringUTFChars(envJNI,jurl, srvurl);
        (*envJNI)->DeleteLocalRef(envJNI, objServiceURL);
        
    }
    
    return SLP_TRUE;
}



JNIEXPORT jobjectArray JNICALL Java_NDService_SLPFindServices_findServices
    (JNIEnv * env, jobject jTmp, jobject jServiceTypeObj, jobject jScopes, jstring jSearchFilter) 
{


    SLPError    result;
    SLPHandle   hslp;
    const char *pcSearchFilter = (*env)->GetStringUTFChars(env,jSearchFilter,0);
    const char* lang = "US";

    jclass clazz;
    jmethodID mid;
    jstring jServiceType;
    char* serviceType;


    //////////////////////////////

    jclass clazzServiceURL = (*env)->FindClass(env,"com/solers/slp/ServiceURL");
    serviceURLs = (*env)->NewObjectArray(env, 100, clazzServiceURL, NULL);
    indexServiceURLs = 0;

    /////////////////////////////////



    clazz = (*env)->GetObjectClass(env,jServiceTypeObj);
    mid = (*env)->GetMethodID(env,clazz, "toString", "()Ljava/lang/String;");
    jServiceType = (jstring)(*env)->CallObjectMethod(env,jServiceTypeObj, mid);
    serviceType = strdup((*env)->GetStringUTFChars(env,jServiceType, 0));

    envJNI = env;



    if(SLPOpen(lang,SLP_FALSE,&hslp) == SLP_OK)    
    {

        PSLPHandleInfo handle = (PSLPHandleInfo)hslp; 

        handle = (PSLPHandleInfo)hslp; 
        /*
         *  multicast on multiple interfaces is 
         *  supported only in 1.1.5 and not in 1.0.11
         */
        //handle->McastIFList = strdup("192.168.24.1,128.93.135.14");
        handle->McastIFList = NULL;
         

        handle->langtaglen = 2;
        handle->langtag=(char *)malloc(30*sizeof(char));
        strcpy(handle->langtag,"US");

        result = SLPFindSrvs(hslp,
                            //"service:service-agent",
                            serviceType,
                            "",
                            pcSearchFilter,
                            &mySLPSrvURLCallback,
                            0);
        if(result != SLP_OK)
        {
            printf("errorcode: %i\n",result);
        }

        SLPClose(hslp);

    }    
    (*env)->ReleaseStringUTFChars(env,jServiceType, serviceType);
    (*env)->ReleaseStringUTFChars(env,jSearchFilter, pcSearchFilter);
    
    ////////////////////////////////

    return serviceURLs;

    ////////////////////////////////

}
