package NDService;

import org.xml.sax.helpers.DefaultHandler;
import org.xml.sax.SAXParseException;
import org.xml.sax.SAXException;
import org.xml.sax.Attributes;
import java.util.Vector;

import CoreBroker.Syslog;

public class SAXHandler extends DefaultHandler {
  
    private int stat = 0, cpt =0;
    Vector tableAttributes = new Vector();
    Vector favorites = new Vector();
    int[][] startTable = new int[3][9];
    int[][] endTable = new int[10][9];
    Favorite favorite = null;
    
    public SAXHandler() {
	
	tableAttributes.addElement("favorites");
        tableAttributes.addElement("favorite");
        tableAttributes.addElement("wau");
        tableAttributes.addElement("ep");
        tableAttributes.addElement("validate");
	tableAttributes.addElement("instanceURL");
	tableAttributes.addElement("LCwau");
	tableAttributes.addElement("RCwau");
	tableAttributes.addElement("colocation");

	for (int y=0;y<9;y++)
	    for (int z=0;z<3;z++)
		startTable[z][y]=-1;
	
	startTable[0][0]=1;
	startTable[1][1]=2;
	startTable[2][2]=3;
	startTable[2][3]=4;
	startTable[2][4]=5;
	startTable[2][5]=6;
	startTable[2][6]=7;
	startTable[2][7]=8;
	startTable[2][8]=9;

	
	endTable[1][0]=0;
	endTable[2][1]=1;
	endTable[3][2]=2;
	endTable[4][3]=2;
	endTable[5][4]=2;
	endTable[6][5]=2;
	endTable[7][6]=2;
	endTable[8][7]=2;
	endTable[9][8]=2;

	stat = 0;
    }

    private void init() {
	favorites.removeAllElements();
        stat = 0; // initial stat
        }


    public void startDocument() throws SAXException {
        init();
    }

    public void startElement(String uri, String localName, String qName, Attributes atts) throws SAXException
    {
	stat = startTable[stat][tableAttributes.indexOf(localName)];
	switch (stat)
	    {
	    case 2 :
			favorite = new Favorite();
			break;
	    case -1:
		Syslog.error(this,"Error XML");
		System.exit(0); 
	    }
	
	
    }
    
   public void characters(char ch[], int start, int length)
    {
	switch (stat)
	    {
	    case 3: 
		favorite.setWAU(new String(ch, start, length));
		break;
	    case 4: 
		favorite.setAddress(new String(ch, start, length));
		break;
	    case 5:
		favorite.setValidate(new String(ch, start, length));
		break;
	    case 6:
		favorite.setInstanceURL(new String(ch, start, length));
		break;
	    case 7:
		favorite.setLCwau(new String(ch, start, length));
		break;
	    case 8:
		favorite.setRCwau(new String(ch, start, length));
		break;
	    case 9:
		String isColocation = new String(ch, start, length);
		if (isColocation.equals("true"))
		    favorite.setColocation(true);
		    else favorite.setColocation(false);
		break;

	    case -1:
		Syslog.error(this,"Error XML");
		System.exit(0); 
	    }
    }
    
    public void endElement(String uri, String localName, String qName) throws SAXException
    {
	stat = endTable[stat][tableAttributes.indexOf(localName)];
	if (stat == 1) favorites.addElement(favorite);
	else if (stat == -1)
	    {
		Syslog.error(this,"Error XML");
		System.exit(0);
	    } 
    }
    
    public void startPrefixMapping(String prefix, String uri)
    {
	
    }

    public void endPrefixMapping(String string)
    {
	
    }
    

    public void endDocument() throws SAXException
    {
	
    }

    public void error(SAXParseException sAXParseException) throws SAXException
    {
	Syslog.error(this,"Error");
    }

    public void fatalError(SAXParseException sAXParseException) throws SAXException
    {
	Syslog.error(this,"Fatal Error ");
    }

    public Vector getFavorites()
    {
	return favorites;
    }
}
