package URService;

import java.util.*;
import java.io.*;
import CoreBroker.Syslog;

public class URImpl implements URService.URInterface{

    Hashtable services; // key=WAU, value= Vector of GetServiceDataUR
    
    public URImpl() {
        services = new Hashtable();
        Thread t = getUR();
        //t.start();
    }

    public void register(java.lang.String WAU, java.lang.String[] serviceEP, java.lang.String instanceURL, java.lang.String LCWAU, java.lang.String RCWAU, boolean colocation)
            throws java.rmi.RemoteException {
        
        
        for (int i=0; i<serviceEP.length; i++) {
            Syslog.info(this,"UR.register: "+WAU+" "+serviceEP[i]+" "+LCWAU+" "+RCWAU);

            GetServiceDataUR service = new GetServiceDataUR();
            service.setServiceEP(serviceEP[i]);
            service.setLCWAU(LCWAU);
            service.setRCWAU(RCWAU);
            service.setColocation(colocation);
            service.setInstanceURL(instanceURL);
            service.setWAU(WAU);
            
            Vector listServices = null;
            if (services.containsKey(WAU)) {
                listServices = (Vector)services.get(WAU);
                if (listServices == null)
                    listServices = new Vector();
            } else
                listServices = new Vector();

            listServices.add(service);
            services.put(WAU,listServices);
        }
    }
    
    public void unRegister(java.lang.String WAU, java.lang.String serviceEP)
            throws java.rmi.RemoteException {
        Syslog.info(this,"UR.unregister: "+WAU+" "+serviceEP);
        
        if (services.containsKey(WAU)) {
            Vector listServices = (Vector)services.get(WAU);
            for (int i=0; listServices != null && i<listServices.size(); i++) {
                GetServiceDataUR service = (GetServiceDataUR)listServices.elementAt(i);
                if (service.getServiceEP().equals(serviceEP)) {
                    listServices.remove(i);
                }
            }
        } 
        
    }
    
    public void unRegisterAll(java.lang.String[] ips) 
            throws java.rmi.RemoteException {

        Syslog.info(this,"UR.unregisterAll: ");
        for (int i=0; i<ips.length; i++)
            Syslog.info(this," "+ips[i]);
               

        Enumeration allServices = services.elements();
        while (allServices.hasMoreElements()) {
           
            Vector listServices = (Vector)allServices.nextElement();
            Vector indexToRemove = new Vector();
            
            for (int i=0; listServices != null && i<listServices.size(); i++) {
                GetServiceDataUR service = (GetServiceDataUR)listServices.elementAt(i);
                Syslog.debug(this,"Service is "+service.getServiceEP());
                                
                for (int j=0; ips!=null && j<ips.length; j++)
                    if (service.getServiceEP().indexOf(ips[j]) != -1) {
                        indexToRemove.add(new Integer(i));
                        Syslog.debug(this,"to be removed:"+i);
                    } else
                       Syslog.debug(this," not to be removed: "+i);
            }
            for (int i=indexToRemove.size()-1; i>=0; i--) {
                Syslog.debug(this,"removing "+((Integer)indexToRemove.elementAt(i)).intValue());
                listServices.remove(((Integer)indexToRemove.elementAt(i)).intValue());
            }
        } 
    }
    
    public void updateAllAddresses(java.lang.String[] ipsOld, java.lang.String[] ipsNew) 
            throws java.rmi.RemoteException {
                
        Syslog.info(this,"UR.updateAlladdress: ");
        for (int i=0; i<ipsOld.length; i++)
            Syslog.info(this," "+ipsOld[i]);
        for (int i=0; i<ipsNew.length; i++)
            Syslog.info(this,"/"+ipsNew[i]);        
                
        
        Vector ipsToRemove = new Vector();
        Vector ipsToAdd = new Vector();
        
        for (int i=0; ipsOld!=null && i<ipsOld.length; i++) {
            boolean found = false;
            for (int j=0; !found && ipsNew!=null && j<ipsNew.length; j++)
                if (ipsOld[i].equals(ipsNew[j]))
                    found = true;
            if (!found) {
                ipsToRemove.add(ipsOld[i]);
                Syslog.info(this,"IP to remove :"+ipsOld[i]);
            }
        }
        for (int i=0; ipsNew!=null && i<ipsNew.length; i++) {
            boolean found = false;
            for (int j=0; !found && ipsOld!=null && j<ipsOld.length; j++)
                if (ipsNew[i].equals(ipsOld[j]))
                    found = true;
            if (!found) {
                ipsToAdd.add(ipsNew[i]);
                Syslog.info(this,"IP to add :"+ipsNew[i]);
            }
        }
                    
        
        Enumeration allServices = services.elements();
        while (allServices.hasMoreElements()) {
            Vector listServices = (Vector)allServices.nextElement();
            for (int i=0; listServices != null && i<listServices.size(); i++) {
                GetServiceDataUR service = (GetServiceDataUR)listServices.elementAt(i);
                Syslog.debug(this,"Service is "+service.getServiceEP());
                
                String ep = service.getServiceEP();
                if (ipsToRemove.size() > 0) {
                    for (int j=0; j<ipsToRemove.size(); j++)
                        if (ep.indexOf((String)ipsToRemove.elementAt(j)) != -1) {
                            listServices.remove(i);
                            Syslog.debug(this," removed");
                        } else
                            Syslog.debug(this," not removed ");                    
                }
                if (ipsToAdd.size() > 0) {
                    for (int j=0; ipsOld!=null && j<ipsOld.length; j++) {
                        
                        int indexIP = ep.indexOf(ipsOld[j]);
                        if (indexIP != -1) {
                            
                            for (int k=0; k<ipsToAdd.size(); k++) {
                            
                                GetServiceDataUR serviceNew = new GetServiceDataUR();
				serviceNew.setWAU(service.getWAU());
                                serviceNew.setLCWAU(service.getLCWAU());
                                serviceNew.setRCWAU(service.getRCWAU());
                    
                                String beforeIP = ep.substring(0,indexIP);
                                String afterIP = ep.substring(indexIP+ipsOld[j].length());
                                String newEP= beforeIP + ipsToAdd.elementAt(k).toString() + afterIP; 
                                                                
                                serviceNew.setServiceEP(newEP);
                                listServices.add(serviceNew);
                                Syslog.debug(this,"Added service "+newEP);
                            }
                        }
                    }
                }
            }
        } 
        
    }
    
    public URService.GetServiceDataUR[] getServices(java.lang.String WAU) 
            throws java.rmi.RemoteException {
       Syslog.info(this,"UR.getServices: "+WAU);            
        
        if (services.containsKey(WAU)) {            
            Vector listServices = (Vector)services.get(WAU);            
            GetServiceDataUR[] arrayServices = new GetServiceDataUR[listServices.size()]; 
            listServices.copyInto(arrayServices);            
            return arrayServices;
        } else      
            return null;
    }

    public URService.GetServiceDataUR[] getServices_ByInstanceURL(java.lang.String instanceURL) 
        throws java.rmi.RemoteException {

        Syslog.info(this,"UR.getServices_byinstanceURL: "+instanceURL);            

        Vector srvsVector = new Vector();
        Enumeration enumServices = services.elements(); //values=Vector of GetServiceDataUR
        while (enumServices.hasMoreElements()) {
            Vector vectorServices = (Vector)enumServices.nextElement(); // elements are GetServiceDataUR
            if (vectorServices != null) {
                for (int i=0; i<vectorServices.size(); i++) {    
                    GetServiceDataUR service = (GetServiceDataUR)vectorServices.elementAt(i);                    
                    if (service.getInstanceURL()!=null && service.getInstanceURL().equals(instanceURL))
                        srvsVector.add(service);       
                }
            }
        }
        GetServiceDataUR[] srvs = new GetServiceDataUR[srvsVector.size()];
        srvsVector.copyInto(srvs);
        return srvs;         
    }
    
    public Thread getUR() {
        try {
  
            Thread resultsThread = new Thread( new Runnable() {
                public void run() {
                                           
                        while (true) {    
    
                            Enumeration keys = services.keys();
                            
                            while (keys.hasMoreElements()) {
                                String key = keys.nextElement().toString();
                                Syslog.debug(this,"UR Key="+key);
                                
                                Vector listServices = (Vector)services.get(key);
                                for (int i=0; listServices != null && i<listServices.size(); i++) {
                                    GetServiceDataUR service = (GetServiceDataUR)listServices.elementAt(i);
                                    Syslog.debug(this,"Service is "+service.getServiceEP());    
                                }
                            }
                            try {
                                Thread.sleep(15000);
                            } catch (Exception ex) {
                                ex.printStackTrace();
                            }                                
                        }
                    }
                });
           return resultsThread;
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        return null;
    }
    

}
