package WSAMI;

import CoreBroker.CBException;

import org.w3c.dom.*;
import javax.xml.parsers.*;

import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;
import java.io.IOException;

import java.io.InputStream;

public class WSDLConcrete { 
    private String location;
    private String portName;

    public WSDLConcrete() {}
   
    public WSDLConcrete(String XSDfilesPath, InputStream is) 
            throws CBException{

        Document document;
        org.apache.xerces.parsers.DOMParser domParser = new org.apache.xerces.parsers.DOMParser();
        
        try {                        
            domParser.parse(new org.xml.sax.InputSource(is));
        } catch (org.xml.sax.SAXException ex) {
            throw new CBException("parsing00","Error parsing WSDL file");
        } catch (java.io.IOException ex) {
            throw new CBException("parsing00","Error reading WSDL file");
        }
        
        document = domParser.getDocument();                    
            
            
        Element root = document.getDocumentElement();
        Node addressNode = document.getElementsByTagNameNS("*","address").item(0);
        setLocation(addressNode.getAttributes().item(0).getNodeValue());
            
        Node portNode = document.getElementsByTagNameNS("*","port").item(0);
        setPortName(portNode.getAttributes().getNamedItem("name").getNodeValue());        
    }
   
    public void setLocation(String _location) {
        location = _location;
    }

    public String getLocation() {
        return location;
    }
   
    public void setPortName(String _portname) {
        portName = _portname;
    }

    public String getPortName() {
        return portName;
    }
   
}
