package csoap.server;

import java.util.*;
import csoap.deployment.*;

public class ProviderManager 
{ 

  RPCProvider provider = new RPCProvider();
  RPCProvider providerGlobal = new RPCProvider();

    // for session manager
    Vector  client_ids      = new Vector();
    Vector  client_providers = new Vector();
    int[]   client_lifes     = new int[1000];
    
    public ProviderManager()
    {
    Thread session = lifeSession();
    session.start();
    }

    synchronized public RPCProvider getProvider(Service service, javax.xml.rpc.holders.StringHolder client_id) 
    {
	provider = providerGlobal;
	if (service.getServiceType() != null && service.getServiceType().equals("Session"))
	    {
		System.out.println("the Service "+service.getServiceName()+" is session ");
		System.out.println("The ID received="+client_id.value);
		System.out.println("Existing ids :");
		for(int idcpt=0;idcpt<client_ids.size();idcpt++)
		    System.out.println("id "+idcpt+" "+(String)client_ids.elementAt(idcpt));
		    

		if (client_id.value == null || client_id.value.equals("")) client_id.value = (new Integer(client_ids.size())).toString();
		System.out.println("Id after creation="+client_id.value);
		if (client_ids.indexOf(client_id.value)==-1)
		    {
			System.out.println("I create a new provider for this service named "+service.getServiceName());

			String client_idString = new String(client_id.value);
			client_ids.addElement(client_idString);
			provider = new RPCProvider();
			client_providers.addElement(provider);
			client_lifes[client_ids.indexOf(client_id.value)] = 90 ; // for 30 mins
		    }
		else
		    {
			System.out.println("I not create a new provider for this service named "+service.getServiceName());
			provider = (RPCProvider)client_providers.elementAt(client_ids.indexOf(client_id.value));
			client_lifes[client_ids.indexOf(client_id.value)] = 90;
			
			
		    }
	    }
	return provider;
    }

  public Thread lifeSession() {
        try
	    {
		Thread resultsThread = 
		    new Thread( new Runnable() 
			{
			    public void run() 
			    {
				while (true)
				    {
					int i = 0;
					while (i < client_providers.size()) 
					    {
						if (client_lifes[i] > 0 && --client_lifes[i] == 0)
						    {
							((RPCProvider)client_providers.elementAt(i)).destroy();
							client_providers.setElementAt(null,i);
							client_ids.setElementAt(null,i);
						    }
						i++;
					    }
					try
					    {
						Thread.sleep(2000);
					    }
					catch (Exception ex)
					    {
						System.out.println("Sleep Error");
					    }
				    }
				
			    }
			});
		return resultsThread;
	    }
	catch (Exception ex)
	    {
		System.out.println("Error in create Thread");
	    }
	return null;
  }
    public void destroy()
    {
	providerGlobal.destroy();
	for (int i=0; i<client_providers.size();i++)
	    if (client_providers.elementAt(i) != null)
		((RPCProvider)client_providers.elementAt(i)).destroy();
    }
}
