package csoap.xml.rpc.encoding;

import csoap.xml.soap.*;
import java.util.Vector;
import java.util.Iterator;
import java.lang.reflect.Array;
import javax.xml.namespace.QName;

public class DeserializerArrayType2 implements DeserializerBase
{
  String mechanismType="default";
  Class JAVAClass;
  QName XMLType;
  
  public DeserializerArrayType2(Class JavaClass , QName XMLType)
  {
      JAVAClass = JavaClass;
      XMLType = XMLType;
  }
  public void setMechanismType(String MechanismType)
  {
    mechanismType = MechanismType;
  }
  public String getMechanismType()
  {
    return mechanismType;
  }
    public Object deserialize(javax.xml.soap.SOAPElement sOAPElement, javax.xml.rpc.encoding.TypeMappingRegistry typeMappingRegistry, csoap.deployment.Service service)
    {   Object objArray = null;
	String isnull = sOAPElement.getAttributeValue(new NameImpl("nil"));
	if (isnull.equals("true")) return null;

	// CASTING 
	csoap.xml.rpc.encoding.TypeMappingRegistryImpl typeMappingRegistry2 = (csoap.xml.rpc.encoding.TypeMappingRegistryImpl)typeMappingRegistry;
   
	String type = sOAPElement.getAttributeValue(new NameImpl("arrayType"));
	Integer dim = new Integer(type.substring(type.indexOf("[")+1,type.indexOf("]")));
	String uri ="";
	if (type.indexOf(":") != -1)
	    {
		String prefix = type.substring(0, type.indexOf(":"));
		type = type.substring(type.indexOf(":") + 1,type.indexOf("["));
		uri = sOAPElement.getNamespaceURI(prefix);
			    }
        QName XMLTypeElement = QName.valueOf("{"+uri+"}"+type);
	Class componentType = typeMappingRegistry2.getJavaClass(XMLTypeElement);
	
	Iterator childs = sOAPElement.getChildElements();
        
	if (componentType == int.class)
	    {
		objArray = new int[dim.intValue()];
		for (int i = 0; i < dim.intValue(); i++)
		    {
			javax.xml.soap.SOAPElement child = (javax.xml.soap.SOAPElement)childs.next();
			Integer resultInteger = new Integer(child.getValue());
			Array.setInt(objArray,i,resultInteger.intValue());
		    }
	    }
	else
	    {
		objArray= Array.newInstance(componentType, dim.intValue());

		// Find Desrialiser for this XMLType Element
		javax.xml.rpc.encoding.TypeMapping typeMapping = typeMappingRegistry2.getTypeMapping(XMLTypeElement.getNamespaceURI());
		javax.xml.rpc.encoding.DeserializerFactory deserializerFactory = typeMapping.getDeserializer(null,XMLTypeElement);
		DeserializerBase deserializer = (DeserializerBase)deserializerFactory.getDeserializerAs("default");
		
		for (int i = 0; i < dim.intValue(); i++)
		    {
			javax.xml.soap.SOAPElement child = (javax.xml.soap.SOAPElement)childs.next();
			child = Reference.getSOAPElementForDeserialiser(child);            
			Array.set(objArray, i, deserializer.deserialize(child,typeMappingRegistry, service));
			
		    }
	    }
	return objArray;
  }

}
