package csoap.xml.rpc.encoding;

import java.lang.reflect.*;
import java.util.Iterator;
import csoap.xml.soap.NameImpl;
import javax.xml.namespace.QName;

public class DeserializerComplexType implements DeserializerBase
{
  String mechanismType="default";
  Class JAVAClass;
  QName XMLType;

 public DeserializerComplexType(Class JavaClass, QName XmlType)
  {
    JAVAClass= JavaClass;
    XMLType = XmlType;
  }
  public void setMechanismType(String MechanismType)
  {
    mechanismType = MechanismType;
  }
  public String getMechanismType()
  {
    return mechanismType;
  }

 public Object deserialize(javax.xml.soap.SOAPElement sOAPElement, javax.xml.rpc.encoding.TypeMappingRegistry typeMappingRegistry, csoap.deployment.Service service)
  {
      String isnull = sOAPElement.getAttributeValue(new NameImpl("nil")); 
      if (isnull != null && isnull.equals("true")) return null; 
	   // jump reference
      sOAPElement = Reference.getSOAPElementForDeserialiser(sOAPElement);
      Object obj =null;
      try
	  {
	      //Class objectClass = Class.forName(javaClass.getName());
	      obj = JAVAClass.newInstance();
	      Field attributes[] = JAVAClass.getFields();
	      Iterator childs = sOAPElement.getChildElements();
	      for (int i = 0; i < attributes.length; i++)
		  {
		      Field attribute = attributes[i];
		      if (childs.hasNext())
			  {
			      javax.xml.soap.SOAPElement element = (javax.xml.soap.SOAPElement) childs.next();
			      element = Reference.getSOAPElementForDeserialiser(element);
			      String elementType = element.getAttributeValue(new NameImpl("type")); 
			      String uri ="";
			      if (elementType.indexOf(":") != -1)
				  {
				      String prefix = elementType.substring(0, elementType.indexOf(":"));
				      elementType = elementType.substring(elementType.indexOf(":") + 1);
				      uri = element.getNamespaceURI(prefix);
				  }
			      QName XMLTypeAtt = QName.valueOf("{"+uri+"}"+elementType);
			      javax.xml.rpc.encoding.TypeMapping typeMapping = typeMappingRegistry.getTypeMapping(XMLTypeAtt.getNamespaceURI());
			       
			      javax.xml.rpc.encoding.DeserializerFactory deserializerFactory = typeMapping.getDeserializer(null,XMLTypeAtt);
			        
			      csoap.xml.rpc.encoding.DeserializerBase  deserializer = (DeserializerBase)deserializerFactory.getDeserializerAs("default");
			      
			      
			      Object attValue = deserializer.deserialize(element,typeMappingRegistry, service);
			      attribute.set(obj, attValue);
			  }
		      else  attribute.set(obj, null);
		  }
	  }
      catch (Exception ex)
	  {
	      ex.printStackTrace();
	  }
      return obj;
  }
    
}
