package csoap.xml.rpc.encoding;

import javax.xml.rpc.encoding.*;
import java.util.*;
import javax.xml.namespace.QName;

public class DeserializerComplexTypeFactory implements DeserializerFactory{

Vector deserializers = new Vector();
Vector mechanismTypes = new Vector();

public DeserializerComplexTypeFactory(Class JavaClass,  QName XmlType)
{
    this.addDeserializer(new DeserializerComplexType(JavaClass,XmlType));
}

public Deserializer getDeserializerAs(String mechanismType)
{
  return (Deserializer)deserializers.elementAt(mechanismTypes.indexOf(mechanismType));
}

public Iterator getSupportedMechanismTypes()
{
  return mechanismTypes.iterator();
}

public void addDeserializer(Deserializer newDeserializer)
{
 deserializers.addElement(newDeserializer);
 mechanismTypes.addElement(newDeserializer.getMechanismType());
}

}
