package csoap.xml.rpc.encoding;

import csoap.xml.soap.*;
import javax.xml.namespace.QName;
import javax.xml.soap.*;
import java.lang.reflect.Array;

public class SerializerArrayType2 implements SerializerBase
{
  String mechanismType="default";
  Class JAVAClass;
  QName XMLType;
    

    public SerializerArrayType2(Class JavaClass, QName XmlType)
    {
	JAVAClass = JavaClass;
	XMLType = XmlType;
    }
    
    public String getMechanismType()
    {
	return mechanismType;
    }
    
    public javax.xml.soap.SOAPElement serialize(Object obj, Name name, javax.xml.soap.SOAPElement SOAPParent, javax.xml.rpc.encoding.TypeMappingRegistry typeMappingRegistry)
    {
	// CASTING OF JAX-RPC ON CSOAP CLASS IMPLEMENTATION
	csoap.xml.rpc.encoding.TypeMappingRegistryImpl typeMappingRegistry2 = (csoap.xml.rpc.encoding.TypeMappingRegistryImpl)typeMappingRegistry;
     csoap.xml.soap.SOAPElementImpl SOAPParent2 = (csoap.xml.soap.SOAPElementImpl)SOAPParent; 
     QName XMLTypeElement=null;
     
     // FIND TYPE OF ARRAY ELEMENTS
     String type="";
     Class typeClass = null;
     try
	 {
	     type = obj.getClass().getName();
	     if (type.equals("[I")) 
		 { 
		 type = "int";
		 typeClass = int.class;
		 XMLTypeElement = typeMappingRegistry2.getXMLType(typeClass);
		 System.out.println("XMLTYPEElement1 "+XMLTypeElement);
		 }
	     else
		 { 
		     type = type.substring(2, type.length()-1);
		     typeClass = Class.forName(type);		     
		     //**************************************************
		     // PROBLEM OF SERIALISATION BIGDECIMAL ELEMENT TYPE
		     // I CAN'T DISTINGUE BETWEEN XSD:DOUBLE AND XSD:DECIMAL 
		     //**************************************************
		     XMLTypeElement = typeMappingRegistry2.getXMLType(typeClass);
		 }
	 }
     catch (Exception ex)
	 {
	     System.out.println("Class "+type+" not found");
	 }
     
     // CREATION OF SOAPELEMENT 
    SOAPElementImpl forReturn = new SOAPElementImpl((NameImpl)name);
    String pre = null;
    if (SOAPParent2!=null) pre=SOAPParent2.getPrefixOf(XMLType.getNamespaceURI());
    if (pre != null && !pre.equals(""))
	{
	    forReturn.addAttribute(new NameImpl("type", "xsi"),pre + ":" +XMLType.getLocalPart()); 
	}
    else 
	{ 
	    forReturn.addAttribute(new NameImpl("type", "xsi"), "nsa:" + XMLType.getLocalPart());
	    forReturn.addNamespaceDeclaration("nsa",XMLType.getNamespaceURI());
	}
    
    
    if (obj != null)
	{   // ARRAY CONTENT 0 (ZERO) ELEMENTS OR MORE 
	    int dim = Array.getLength(obj);
	    String preE = null;
	    preE = forReturn.getPrefixOf(XMLTypeElement.getNamespaceURI());
	    if ((preE == null || preE.equals("")) && SOAPParent2 != null) preE = SOAPParent2.getPrefixOf(XMLTypeElement.getNamespaceURI());
	    if (preE != null && !preE.equals(""))
	    	{
		    forReturn.addAttribute(new NameImpl("arrayType", "xsi"),preE + ":" + XMLTypeElement.getLocalPart()+"["+dim+"]"); 
	    	}
	    else 
		{ 
		    forReturn.addAttribute(new NameImpl("arrayType", "xsi"), "nst:" + XMLTypeElement.getLocalPart()+"["+dim+"]");
		    forReturn.addNamespaceDeclaration("nst",XMLTypeElement.getNamespaceURI());
		}
	    
            // FIND SERIALISER OF ARRAY ELEMENT'S
	    javax.xml.rpc.encoding.TypeMapping typeMapping = typeMappingRegistry2.getTypeMapping(XMLTypeElement.getNamespaceURI());
	    
	    javax.xml.rpc.encoding.SerializerFactory serializerFactory = null;
	    try
		{
		    serializerFactory = typeMapping.getSerializer(typeClass, XMLTypeElement);
		}
	    catch(Exception ex)
		{
		    System.out.println("Class : "+type + " Not found");    
		}
	    csoap.xml.rpc.encoding.SerializerBase serializer = (SerializerBase)serializerFactory.getSerializerAs("default");
	    NameImpl item =  new NameImpl("item");
	    for (int i=0;i<dim;i++)
		{
		    try
			{
			    Object element = Array.get(obj,i);
			    SOAPElement child =  serializer.serialize(element,item,forReturn ,typeMappingRegistry);
			    forReturn.addChildElement(child);
			}
		    catch(Exception ex)
			{
			    System.out.println("ERROR in serialisation of element Array's");    
			}
		}
	}
     else // OBJ NULL 
	 forReturn.addAttribute(new NameImpl("nil", "xsi"),"true");    
     
     return forReturn;
    }
    public void setMechanismType(String MechanismType)
    {
	mechanismType = MechanismType;
    }
    
}

