package csoap.xml.rpc.handler;

import java.util.Map;
import java.util.*;
import javax.xml.rpc.handler.Handler;
import javax.xml.rpc.handler.HandlerInfo;
import csoap.deployment.parameter;
import csoap.deployment.handlerFlow;
import java.lang.reflect.Constructor;


public class HandlerChainImpl extends Vector implements javax.xml.rpc.handler.HandlerChain {

  String[] roles;
  Vector handlersNames = new Vector();
  handlerFlow flow;


  public void destroy()
  {
    ///kill handler
    for (int i=0;i<super.size();i++)
      ((Handler)super.get(i)).destroy();
    super.removeAllElements();

  }
  public String[] getRoles()
  {
    return roles;
  }
  public boolean handleFault(javax.xml.rpc.handler.MessageContext context)
  {
    return true;
  }
  public boolean handleRequest(javax.xml.rpc.handler.MessageContext context)
  {
    Iterator ite;
    try
    {
      if (super.isEmpty()) {
        ite = flow.getHandlers();
        while (ite.hasNext()) {
          HandlerInfo2 handlerInfo = (HandlerInfo2) ite.next();
          Class classHandler  = handlerInfo.getHandlerClass();
          Handler instanceHandler = (Handler)classHandler.newInstance();
          instanceHandler.init(handlerInfo);
          super.addElement(instanceHandler);
          handlersNames.addElement((String)handlerInfo.getHandlerName());
        }

      }
    }
    catch (Exception ex)
    {
      ex.printStackTrace();
    }

    ite = flow.getRequestFlow();

    while ( ite.hasNext() )
    {
      String requestHandler = (String) ite.next();
      ((Handler)super.elementAt(handlersNames.indexOf(requestHandler))).handleRequest(context);
    }

    return true;
  }

  public boolean handleResponse(javax.xml.rpc.handler.MessageContext context)
  {
    Iterator ite;
     try
     {
       if (super.isEmpty()) {
         ite = flow.getHandlers();
         while (ite.hasNext()) {
           HandlerInfo2 handlerInfo = (HandlerInfo2)ite.next();
           Class classHandler = handlerInfo.getHandlerClass();
           Handler instanceHandler = (Handler)classHandler.newInstance();
           instanceHandler.init(handlerInfo);
           super.addElement(instanceHandler);
           handlersNames.addElement((String)handlerInfo.getHandlerName());
         }

       }
     }
     catch (Exception ex)
     {
       ex.printStackTrace();
     }


  ite = flow.getResponseFlow();
  while ( ite.hasNext() )
  {
    String responseHandler = (String) ite.next();
    ((Handler)super.elementAt(handlersNames.indexOf(responseHandler))).handleResponse(context);
  }

  return true;
}


/*  public boolean handleResponse(javax.xml.rpc.handler.MessageContext context)
  {

    try
    {
      if (super.isEmpty()) {
        Iterator ite = service.getHandlers();
        while (ite.hasNext()) {
          handler userHandler = (handler) ite.next();
          Class classHandler = Class.forName(userHandler.getType());
          Iterator ite2 = userHandler.getParameters();
          int j = 0;
          while (ite2.hasNext()) {
            j++;
            ite.next();
          }

          Object params[] = new Object[j];
          ite2 = userHandler.getParameters();
          j = 0;
          while (ite2.hasNext()) {
            parameter param = (parameter)ite.next();
            params[j]= param.getValue();
          }
          //Handler instanceHandler = (Handler) classHandler.newInstance();
          Constructor constructors[] = classHandler.getConstructors();
          Constructor constructor = constructors[0];
          Handler instanceHandler = (Handler)constructor.newInstance(params);
          instanceHandler.init(new HandlerInfo());
          super.addElement(instanceHandler);
          handlersNames.addElement(userHandler.getName());
        }

      }
    }
    catch (Exception ex)
    {
      ex.printStackTrace();
    }

    Iterator ite3 = service.getResponseFlow();
    while ( ite3.hasNext() )
    {
      String responseHandler = (String) ite3.next();
      ((Handler)super.elementAt(handlersNames.indexOf(responseHandler))).handleResponse(context);
    }

    return true;
  }
      */
  public void init(Map config)
  {
    flow = (handlerFlow)config.get("handlerFlow");
  }
  public void setRoles(String[] soapActorNames)
  {
    roles = soapActorNames;
  }

}