package csoap.xml.soap;

// Imports
import java.util.Iterator;
import javax.activation.DataHandler;

public class AttachmentPartImpl extends javax.xml.soap.AttachmentPart
{
  int size=0;
  Object content;
  MimeHeadersImpl mimeHeaders;
  DataHandler dataHandler;
 
  // Constructeurs
  public AttachmentPartImpl() { }

  // Mthodes
  public int getSize()
  {
    return size;
  }
  public void clearContent()
  {
    content= null;
  }
  public Object getContent()
  {
    return content;
  }
  public void setContent(Object Content, String contentType)
  {
    content = Content;
    mimeHeaders.addHeader("Content-Type",contentType);
  }

  public DataHandler getDataHandler()
  {
    return dataHandler;
  }
  public void setDataHandler(DataHandler datahandler)
  {
    datahandler = datahandler;
  }
  public String getContentId()
  {
    return mimeHeaders.getHeader("Content-Id")[0];
  }
  public String getContentLocation()
  {
    return mimeHeaders.getHeader("Content-Location")[0];
  }
  public String getContentType()
  {
    return mimeHeaders.getHeader("Content-Type")[0];
  }
  public void setContentId(String contentId)
  {
    mimeHeaders.setHeader("Content-Id",contentId);
  }
  public void setContentLocation(String contentLocation)
  {
    mimeHeaders.setHeader("Content-Location",contentLocation);
  }
  public void setContentType(String contentType)
  {
    mimeHeaders.setHeader("Content-Type",contentType);
  }
  public void removeMimeHeader(String name)
  {
    mimeHeaders.removeHeader(name);
  }
  public void removeAllMimeHeaders()
  {
    mimeHeaders.removeAllHeaders();
  }
  public String[] getMimeHeader(String name)
  {
    return mimeHeaders.getHeader(name);
  }
  public void setMimeHeader(String name, String value)
  {
    mimeHeaders.setHeader(name, value);
  }
  public void addMimeHeader(String name, String value)
  {
    mimeHeaders.addHeader(name, value);
  }
  public Iterator getAllMimeHeaders()
  {
    return mimeHeaders.getAllHeaders();
  }
  public Iterator getMatchingMimeHeaders(String[] names)
  {
    return mimeHeaders.getMatchingHeaders(names);
  }
  public Iterator getNonMatchingMimeHeaders(String[] names)
  {
    return mimeHeaders.getNonMatchingHeaders(names);
  }
}
