package csoap.xml.soap;

import javax.xml.namespace.QName;
import javax.xml.soap.*;

public class SOAPBodyImpl extends SOAPElementImpl implements SOAPBody {
    
    private SOAPBodyElementImpl sOAPBodyElement;
    private SOAPFaultImpl sOAPFault;
    private boolean fault = false;

    public SOAPBodyImpl()
    {
        super("Body");
    }

    public SOAPBodyImpl(String localName, String prefix, String uri)
    {
        super(localName,prefix,uri);
    }
    
    public SOAPBodyImpl(String localName, String prefix)
    {
        super(localName,prefix);
    }
    
    public SOAPBodyImpl(String prefix)
    {
        super("Body",prefix);
    }
    
    public SOAPBodyImpl(QName qualifiedName)
    {
        super(qualifiedName);
    }


  public SOAPBodyElement addBodyElement(Name name)
  {
    sOAPBodyElement = new SOAPBodyElementImpl((NameImpl)name);
    sOAPBodyElement.setParentElement(this);
    super.childElements.addElement(sOAPBodyElement);
    fault = false;
    return sOAPBodyElement;
  }
  public SOAPFault addFault()
  {
    sOAPFault  = new SOAPFaultImpl();
    sOAPFault.setParentElement(this);
    super.childElements.removeAllElements();
    super.addChildElement(sOAPFault);
    fault = true;
    return sOAPFault;
  }
  public SOAPFault getFault()
  {
    return sOAPFault;
  }
  public boolean hasFault()
  {
    return fault;
  }

}