package csoap.xml.soap;

import java.util.Iterator;
import java.util.Vector;
import javax.xml.namespace.QName;
import javax.xml.soap.*;



public class SOAPElementImpl extends NodeImpl implements SOAPElement {

    NameImpl name;
    Vector attributes;//  = new Vector();
    Vector attributeValues; //  = new Vector();
    Vector prefixs; // = new Vector();
    Vector uris; //  = new Vector();
    Vector childElements; //  = new Vector();
    String encodingStyle; //="";

    
    public SOAPElementImpl(NameImpl nameP) {
        name = nameP;
        attributes = new Vector();
        attributeValues  = new Vector();
        prefixs  = new Vector();
        uris  = new Vector();
        childElements  = new Vector();
        encodingStyle="";        
    }
    
    public SOAPElementImpl(QName qualifiedName) {
        this(new NameImpl(qualifiedName));
    }

    public SOAPElementImpl(String localName, String prefix) {
        //name = new NameImpl(localName,prefix);
        this(localName, prefix, "");
    }
    
    public SOAPElementImpl(String localName) {
        //name = new NameImpl(localName);
        this(localName, "", "");
    }
    
    public SOAPElementImpl(String localName, String prefix, String uri) {     
        this(new NameImpl(localName, prefix, uri));
    }
    

  public SOAPElement addChildElement(Name name)
  {
    SOAPElementImpl sOAPElement = new SOAPElementImpl((NameImpl)name);
    //sOAPElement.setEncodingStyle(this.getEncodingStyle());
    sOAPElement.setParentElement(this);
    childElements.addElement(sOAPElement);
    return sOAPElement;
  }
  public SOAPElement addChildElement(String localName)
  {
   try
   {
     SOAPElement sOAPElement = new SOAPElementImpl(new NameImpl(localName));
     //sOAPElement.setEncodingStyle(this.getEncodingStyle());
     sOAPElement.setParentElement(this);
     childElements.addElement(sOAPElement);
     return sOAPElement;
   }
   catch (Exception e)
   {
     e.printStackTrace();
   }
   return null;
  }
  public SOAPElement addChildElement(String localName, String prefix)
  {
    SOAPElementImpl sOAPElement = new SOAPElementImpl(new NameImpl(localName,prefix));
    //sOAPElement.setEncodingStyle(this.getEncodingStyle());
    sOAPElement.setParentElement(this);
    childElements.addElement(sOAPElement);
    return sOAPElement;
  }
  public SOAPElement addChildElement(String localName, String prefix, String uri)
  {
    SOAPElementImpl sOAPElement = new SOAPElementImpl(new NameImpl(localName,prefix,uri));
    //sOAPElement.setEncodingStyle(this.getEncodingStyle());
    sOAPElement.setParentElement(this);
    childElements.addElement(sOAPElement);
    return sOAPElement;
  }
  public SOAPElement addChildElement(SOAPElement sOAPElement)
  {
    SOAPElementImpl Se = (SOAPElementImpl)sOAPElement;
    //Se.setEncodingStyle(this.getEncodingStyle());
    Se.setParentElement(this);
    childElements.addElement(Se);
    return Se;
  }
  public SOAPElement addTextNode(String TextNode)
  {
      //long t1 = System.currentTimeMillis();
      //super.textNode = super.textNode.concat(TextNode);
      super.textNode = super.textNode.append(TextNode);
      //long t2 = System.currentTimeMillis();
      //System.out.println("Time for add String to String is "+(t2-t1));
    return this;
  }

  public SOAPElement addBigTextNode(char[] bigTextNode)
  {
    super.setBigValue(bigTextNode);
    return this;
  }
  public SOAPElement addAttribute(Name name, String value)
  {
    attributes.addElement(name);
    attributeValues.addElement(value);
    return this;
  }
  public SOAPElement addNamespaceDeclaration(String prefix, String uri)
  {
      // if (prefixs.indexOf(prefix) ==-1)
      // {
      prefixs.addElement(prefix);
      uris.addElement(uri);
      // }
    return this;
  }
  public String getAttributeValue(Name name)
  {
  int i =0 ;
  while ( i< attributes.size())
          {
             NameImpl elementName = (NameImpl)attributes.elementAt(i);
             if (elementName.equals2(name))
                   {
                    return (String) attributeValues.elementAt(i);
               }
             else {i++;
             }
          }

   return "";
  }
  public Iterator getAllAttributes()
  {
    return attributes.iterator();
  }
  public String getNamespaceURI(String prefix)
  {

    if (prefixs.indexOf(prefix) != -1)
      {
         return (String) uris.elementAt(prefixs.indexOf(prefix));
      }
    else if ( getParentElement() != null )
      {
        return getParentElement().getNamespaceURI(prefix);
      }
   // return "http://schemas.xmlsoap.org/soap/encoding/";
    return "";
  }
  public Iterator getNamespacePrefixes()
  {
   return prefixs.iterator();
  }
  public Name getElementName()
  {
    return (Name)name;
  }
  public boolean removeAttribute(Name name)
  {
    if (attributes.indexOf(name) !=-1)
     {
       attributeValues.removeElementAt(attributes.indexOf(name));
       attributes.removeElement(name);
       return true;
     }
    return false;
  }
  public boolean removeNamespaceDeclaration(String prefix)
  {
    if (prefixs.indexOf(prefix) !=-1)
    {
      uris.removeElementAt(prefixs.indexOf(prefix));
      prefixs.removeElement(prefix);
      return true;
    }
    return false;
  }
  public Iterator getChildElements()
  {
    return childElements.iterator();
  }
  public Iterator getChildElements(Name name)
  {
    Vector forReturn = new Vector();
    for (int i=0;i<childElements.size();i++)
    {
      SOAPElementImpl Se = (SOAPElementImpl)childElements.elementAt(i);
      if (((NameImpl)Se.getElementName()).equals2((NameImpl)name)) forReturn.addElement(Se);
    }
    return forReturn.iterator();
  }

  public void setEncodingStyle(String EncondingStyle)
  {
//    encodingStyle = EncondingStyle;
    // c juste pour envelope
    addAttribute(new NameImpl("encodingStyle", name.getPrefix()),EncondingStyle);
  }
  public String getEncodingStyle()
  {
    return getAttributeValue(new NameImpl("encodingStyle"));
  }


// NOT IN SUN SPECIFICATION
    // ****** ADD FOR CSOAP APPLICATION
    // ****** JUMP REFERENCE IN SOAP ELEMENT 

  public SOAPElement getSOAPElementMutiRef(String id, int x)
  {
     int i=0;
    boolean notfound = true;
    SOAPElementImpl child = null;
    while (notfound && i< childElements.size())
    {
      child = (SOAPElementImpl)childElements.elementAt(i);
      if ( child.getAttributeValue(new NameImpl("id")).equals(id)) notfound = false;
      else i++;
    }
    if (!notfound)
    {
       return child;
    }
    else if (getParentElement() != null)
          {
          x++;
          return ((SOAPElementImpl)getParentElement()).getSOAPElementMutiRef(id, x);
      }
    return null;
  }
    //******* NOT IN SUN SPECIFIACTION
    //******* ADD FOR CSOAP APPLICATION
    //******* FIND PREFIX IN SOAPELMENT PARENT OF SPECIFIED URI

    public String getPrefixOf(String uri)
    {
	if (uris.indexOf(uri) !=-1) return (String)prefixs.elementAt(uris.indexOf(uri));
        if (parentElement != null) return parentElement.getPrefixOf(uri);
        return ""; 
    }
}
