package csoap.xml.soap;

import javax.xml.namespace.QName;
import javax.xml.soap.*;
import java.util.*;

public class SOAPHeaderImpl extends SOAPElementImpl implements SOAPHeader
{
  private SOAPHeaderElementImpl sOAPHeaderElement;

  public SOAPHeaderImpl()
  {
    super("Header");
  }
  public SOAPHeaderImpl(String localName, String prefix, String uri)
  {
    super(localName,prefix,uri);
  }
  public SOAPHeaderImpl(String localName, String prefix)
  {
    super(localName,prefix);
  }
  public SOAPHeaderImpl(String prefix)
  {
    super("Header",prefix);
  }
  public SOAPHeaderImpl(QName qualifiedName)
  {
    super(qualifiedName);
  }

  public SOAPHeaderElement addHeaderElement(Name name)
  {
    sOAPHeaderElement = new SOAPHeaderElementImpl((NameImpl)name);
    sOAPHeaderElement.setParentElement(this);
    super.addChildElement(sOAPHeaderElement);
    return sOAPHeaderElement;
  }
  public Iterator examineHeaderElements(String actor)
  {
   Vector forReturn = new Vector();
   for (int i=0;i<super.childElements.size();i++)
   {
     sOAPHeaderElement = (SOAPHeaderElementImpl)super.childElements.elementAt(i);
     if (sOAPHeaderElement.getActor().equals(actor)) forReturn.addElement(sOAPHeaderElement);
   }

   return forReturn.iterator();
  }
  public Iterator extractHeaderElements(String actor)
  {
    Vector forReturn = new Vector();
    int i=0;
    while (i<super.childElements.size())
    {
      sOAPHeaderElement = (SOAPHeaderElementImpl)super.childElements.elementAt(i);
      if (sOAPHeaderElement.getActor().equals(actor))
        {
          forReturn.addElement(sOAPHeaderElement);
          super.childElements.removeElementAt(i);
        }
      else i++;
    }

    return forReturn.iterator();

  }

}