package csoap.xml.soap;

import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.InputStreamReader;
import java.util.Iterator;
import java.util.Vector;
import javax.activation.DataHandler;
import java.io.*;
import javax.xml.soap.*;
import csoap.util.*;
 


public class SOAPMessageImpl extends javax.xml.soap.SOAPMessage{
    
    String contentDescription; // = "";
    public String SOAPMessageText; // = "";
    SOAPPartImpl sOAPPart; // = new SOAPPartImpl();
    Vector attachmentParts; // = new Vector();
    MimeHeadersImpl mimeHeaders;
    private boolean saverequired; // = false;
    private AttachmentPartImpl attachmentPart;
    private XMLWriter xmlWriter; //= new XMLWriterImpl();


    public SOAPMessageImpl()
    {
        sOAPPart= new SOAPPartImpl();
        attachmentParts = new Vector();
        xmlWriter = new XMLWriterImpl();
        contentDescription = "";
        SOAPMessageText = "";        
        saverequired = false;
    }

  // Mthodes
  public String getContentDescription()
  {
    return contentDescription;
  }
  public void setContentDescription(String ContentDescription)
  {
      contentDescription = ContentDescription;
  }

  public SOAPPart getSOAPPart()
  {
        saverequired = true;
        return sOAPPart;
  }
  public void removeAllAttachments()
  {
    attachmentParts.removeAllElements();
    saverequired=true;
  }
  public int countAttachments()
  {
    return attachmentParts.size();
  }
  public Iterator getAttachments()
  {
    return attachmentParts.iterator();
  }
  public Iterator getAttachments(javax.xml.soap.MimeHeaders mimeHeaders)
  { /// erreur ici faut comparer le contenu de mimeHeaders pas directement les objets parce que l'odre peut ne pas etr respecter
    Vector forReturn = new Vector();
    for (int i=0;i<attachmentParts.size();i++)
    {
      attachmentPart =(AttachmentPartImpl)attachmentParts.elementAt(i);
      if (attachmentPart.mimeHeaders.equals(mimeHeaders)) forReturn.addElement(attachmentPart);
    }
    return forReturn.iterator();
  }
  public void addAttachmentPart(AttachmentPart attachmentPart)
  {
    attachmentParts.addElement(attachmentPart);
    saverequired=true;
  }
  public AttachmentPart createAttachmentPart()
  {
    return new AttachmentPartImpl();
  }
  public AttachmentPart createAttachmentPart(DataHandler dataHandler)
  {
    attachmentPart = new AttachmentPartImpl();
    attachmentPart.setDataHandler(dataHandler);
    return attachmentPart;
  }
  public MimeHeaders getMimeHeaders()
  {
    return mimeHeaders;
  }
  public AttachmentPart createAttachmentPart(Object content, String contentType)
  {
    attachmentPart = new AttachmentPartImpl();
    attachmentPart.setContent(content, contentType);
    return attachmentPart;
  }
  public void saveChanges()
  { 
      // if (saveRequired()) {      
	  SOAPEnvelopeImpl sOAPEnvelope = (SOAPEnvelopeImpl)sOAPPart.getEnvelope();
        xmlWriter.init();
        writeSOAPElement(sOAPEnvelope);
	//SOAPMessageText = xmlWriter.getSOAPMessage();
	saverequired=false;
	//  }

	//      log.debug("SOAP MESSAGE 2: " +xmlWriter.getSOAPMessage(),3);
  }

  public void writeSOAPElement(SOAPElement element)
  {
          
    NameImpl name = (NameImpl)element.getElementName();
    xmlWriter.startElement(name.getLocalName(),name.getPrefix(),name.getURI());
    Iterator attributes = element.getAllAttributes();
    while (attributes.hasNext())
    {
      name = (NameImpl)attributes.next();
      xmlWriter.addAttribute(name.getQualifiedName(),element.getAttributeValue(name));
    }
    Iterator xmlns = element.getNamespacePrefixes();
    while (xmlns.hasNext())
    {
      String prefix = (String)xmlns.next();
      xmlWriter.addAttribute("xmlns:"+prefix,element.getNamespaceURI(prefix));
    }

    Iterator childs = element.getChildElements();
    if (childs.hasNext())
      while(childs.hasNext())
      {
        SOAPElement child = (SOAPElement)childs.next();
        writeSOAPElement(child);
      }
    else 
	{
	    // test if there is a big textNode , use char[]
	    //if (((csoap.xml.soap.SOAPElementImpl)element).isBig()) xmlWriter.addBigTextNode(((csoap.xml.soap.SOAPElementImpl)element).getBigValue());
	    //else
	    xmlWriter.addTextNode(element.getValue());
	}
    xmlWriter.endElement();

  }
  public boolean saveRequired()
  {
    return saverequired;
  }
  public void writeTo(OutputStream outputStream)
  {
  /*  try
    {
      OutputStreamWriter writer = new  OutputStreamWriter(outputStream);
      outputStream.write(SOAPMessageText.getBytes(),0,SOAPMessageText.length());
      //writer.write(SOAPMessageText);
    }
    catch(Exception ex)
    {
      ex.printStackTrace();
    }
        */
      //log.debug("Message SOAP : "+xmlWriter.getSOAPMessage(),3);
      if (saveRequired())
          saveChanges();
      xmlWriter.writeTo(outputStream);
  }
}
